process two_oversampling_TRA =
     ( ? integer u1, u2;
       ! boolean b1, b2;
     )
   pragmas 
      Main
   end pragmas
   (| (| CLK_b1 := ^b1
       | CLK_b1 ^= b1
       | ACT_CLK_b1{}
       |)
    | (| CLK := CLK_b2 ^- CLK_u1 |)
    | (| CLK_b2 := ^b2
       | CLK_b2 ^= b2
       | ACT_CLK_b2{}
       |)
    | assert (| CLK_u1 ^= CLK_22
              | CLK_33 ^= CLK_u1
              |)
    |)
   where 
   event CLK_b2, CLK, CLK_b1;
   process ACT_CLK_b1 =
        ( )
      (| CLK_b1 ^= z ^= v ^= pre_z
       | (| CLK_u1 := when b1
          | CLK_u1 ^= u1 ^= u2
          | ACT_CLK_u1{}
          | CLK_15 := when (not b1)
          |)
       | (| b1 := v<=0
          | z := (u1 when CLK_u1) default (v when CLK_15)
          | v := pre_z-1
          | pre_z := z$1 init 1
          |)
       |)
      where 
      event CLK_15, CLK_u1;
      integer z, v, pre_z;
      process ACT_CLK_u1 =
           ( )
         (| CLK_u1 ^= x1 ^= x2 ^= XZX_66
          | (| CLK_33 := when XZX_66 |)
          | (| CLK_39 := when x1
             | CLK_40 := when (not x1)
             |)
          | (| CLK_41 := when x2
             | CLK_42 := when (not x2)
             |)
          | (| x1 := CLK_u1
             | x2 := CLK_u1
             | XZX_66 := x1=x2
             |)
          |)
         where 
         event CLK_42, CLK_41, CLK_40, CLK_39, CLK_33;
         boolean x1, x2, XZX_66;
         end
      %ACT_CLK_u1%; 
      end
   %ACT_CLK_b1%; 
   process ACT_CLK_b2 =
        ( )
      (| CLK_b2 ^= z_36 ^= v_37 ^= pre_z_41
       | (| CLK_22 := when b2 |)
       | (| b2 := v_37<=0
          | z_36 := (u2 when CLK_u1) default (v_37 when CLK)
          | v_37 := pre_z_41-1
          | pre_z_41 := z_36$1 init 1
          |)
       |)
      where 
      event CLK_22;
      integer z_36, v_37, pre_z_41;
      end
   %ACT_CLK_b2%; 
   end
%two_oversampling_TRA%; 
