#include "type.h"
#include "heure.h"


struct rhythm_descr heure_count;

/*=========================================================================*/
/*                 POUR AFFICHAGE de HEURE,MINUTES,SECONDES                */
/*=========================================================================*/


void meter_heure_creat( Widget widget)
/********************************************* X11 Callback function
                                               to get Widget descriptor */
 {
  (heure_count).discount = widget;
 }

/*=========================================================================*/
void get_adresse_heure(struct rhythm_descr **descr)
/************************* Starting function called by the SIGNAL program */


{ 
   make_display_heure(&heure_count,10,20);
  *descr=&heure_count;
}
/*=========================================================================*/
  

/*======================================================================*/
void make_display_heure(struct rhythm_descr *scale_pt,int X,int Y)
/*******************************  Initialization procedure */

{ 
    Widget mys_widget;
    XGCValues values;

    mys_widget=(*scale_pt).discount;
    values.font =  XLoadFont(XtDisplay(mys_widget),"6x10");
    XtVaGetValues(mys_widget,XmNforeground,&values.foreground,
		  XmNbackground,&values.background,NULL);
    (*scale_pt).dgc = XtGetGC(mys_widget,GCForeground|GCBackground|GCFont,&values);
    (*scale_pt).dgchi = 10;
    (*scale_pt).dgcwi = 6;
    (*scale_pt).x = X;
    (*scale_pt).y = Y;
    (*scale_pt).vcode = NUL_CODE;
}
/*======================================================================*/


/*======================================================================*/
void wnbwrite_heure(struct rhythm_descr *widgst_pt,char str_v1[5],char str_v2[5],char str_v3[5],char str_v4[5])
/************************ */
{
  Display *ecran;
  Window fenetre;
  int height;
  int x1,y1;
  x1=(*widgst_pt).x+40;
  y1=(*widgst_pt).y;
  ecran=XtDisplay((*widgst_pt).discount);
  fenetre=XtWindow((*widgst_pt).discount);
  height=(*widgst_pt).dgchi;
  XClearArea(ecran,fenetre,x1-10,y1-height+1,10*(*widgst_pt).dgcwi,height,pk_false); 
  XDrawString(ecran,fenetre,(*widgst_pt).dgc,x1-10,y1,str_v1,4);
  XClearArea(ecran,fenetre,x1+20,y1-height+1,10*(*widgst_pt).dgcwi,height,pk_false); 
  XDrawString(ecran,fenetre,(*widgst_pt).dgc,x1+20,y1,str_v2,4);
  XClearArea(ecran,fenetre,x1+50,y1-height+1,10*(*widgst_pt).dgcwi,height,pk_false); 
  XDrawString(ecran,fenetre,(*widgst_pt).dgc,x1+50,y1,str_v3,4);
  XClearArea(ecran,fenetre,x1+80,y1-height+1,10*(*widgst_pt).dgcwi,height,pk_false); 
  XDrawString(ecran,fenetre,(*widgst_pt).dgc,x1+80,y1,str_v4,4);
}
/*======================================================================*/




/*======================================================================*/
/*------------------ write an integer number*/
void write_heure(struct rhythm_descr *widgst_pt,int jour,int heure,int min,int sec)
{
  char str_v1[5], str_v2[5], str_v3[5], str_v4[5];

  sprintf(str_v1,"%4d",jour);
  sprintf(str_v2,"%4d",heure);
  sprintf(str_v3,"%4d",min);
  sprintf(str_v4,"%4d",sec);
  wnbwrite_heure(widgst_pt,str_v1,str_v2,str_v3,str_v4);

}
/*======================================================================*/
