process TRAIN =
     { real DMIN, XT1, XT2, XT3, XT4, XT5;
       integer DEL1, DEL2, DEL3, DEL_BARRIERE; }
     ( ? boolean H, HV11, HV12, HLW1, HNW1, HV21, HV22, HLW2, HNW2, HREPARER1, HPANNE1, HDEFAILLANCE1, HREPARER2, HPANNE2, HDEFAILLANCE2;
         real V11, V12, LW1;
         integer NW1;
         real V21, V22, LW2;
         integer NW2;
     )
   (| (| (| H1 := HMOD100
          | HVOIE := HMAX
          | H100 := HMAX
          | HBAR := HMOD40
          | SIMULATION{DMIN,XT1,XT2,XT3,XT4,XT5,DEL1,DEL2,DEL3,DEL_BARRIERE}
          |) where boolean HBAR, H100, HVOIE, H1; end
       | (| H := HMOD40
          | GRAPHIQUES{}
          |) where boolean H; end
       | GERE_ENTREES{}
       |)/ DEFAILLANCE2, PANNE2, REPARER2, DEFAILLANCE1, PANNE1, REPARER1, HMOD100, HMAX, HMOD40, EB2C, EB2D, EB2U, SB2, EB1C, EB1D, EB1U, SB1, TS2E, TS2C, TS2W, TS1W, TS1C, TS1E, L2CO, L2CS, L2CH, L1CO, L1CS, L1CH |)
   where 
   process SIMULATION =
        { real DMIN, XT1, XT2, XT3, XT4, XT5;
          integer DEL1, DEL2, DEL3, DEL_BARRIERE; }
        ( ? boolean H100, H1, HVOIE;
            real V11, V12, LW1;
            integer NW1;
            real V21, V22, LW2;
            integer NW2;
            boolean HMAX, HBAR, REPARER1, PANNE1, DEFAILLANCE1, REPARER2, PANNE2, DEFAILLANCE2;
          ! boolean TS1E, TS1C, TS1W, TS2W, TS2C, TS2E, SB1, EB1U, EB1D, EB1C, SB2, EB2U, EB2D, EB2C, L1CH, L1CS, L1CO, L2CH, L2CS, L2CO;
        )
      (| (| (| H := HVOIE
             | VOIES{DMIN,XT1,XT2,XT3,XT4,XT5}
             |) where boolean H; end
          | BARRIERES{}
          | CONTROLE_PASSAGE{XT2-XT1,XT3-XT2,DEL1,DEL2,DEL3,DEL_BARRIERE}
          |)/ B2CD, B2CU, B1CD, B1CU, B2SD, B2SU, B1SD, B1SU, T2S40, T2S30, T2S20, T2S11, T2S10, T1S10, T1S20, T1S30, T1S41, T1S40 |)
      where 
      process BARRIERES =
           ( ? boolean HBAR, HMAX, REPARER1, PANNE1, DEFAILLANCE1, B1CU, B1CD, REPARER2, PANNE2, DEFAILLANCE2, B2CU, B2CD;
             ! boolean B1SU, B1SD, B2SU, B2SD;
           )
         (| (| BCD := B2CD
             | BCU := B2CU
             | DEFAILLANCE := DEFAILLANCE2
             | PANNE := PANNE2
             | REPARER := REPARER2
             | SIMUL_BARRIERE{520,310}
             | B2SU := BSU
             | B2SD := BSD
             |) where boolean REPARER, PANNE, DEFAILLANCE, BCU, BCD, BSU, BSD; end
          | (| BCD := B1CD
             | BCU := B1CU
             | DEFAILLANCE := DEFAILLANCE1
             | PANNE := PANNE1
             | REPARER := REPARER1
             | SIMUL_BARRIERE{520,80}
             | B1SU := BSU
             | B1SD := BSD
             |) where boolean REPARER, PANNE, DEFAILLANCE, BCU, BCD, BSU, BSD; end
          |)
         where 
         process SIMUL_BARRIERE =
              { integer XBAR, YBAR; }
              ( ? boolean HMAX, PANNE, DEFAILLANCE, REPARER, BCU, BCD, HBAR;
                ! boolean BSU, BSD;
              )
            (| (| MOTEUR{XBAR,YBAR}
                | CONTROLE{}
                |)/ MOUVEMENT, POS_THEORIQUE |)
            where 
            process MOTEUR =
                 { integer XBAR, YBAR; }
                 ( ? boolean POS_THEORIQUE, MOUVEMENT, HBAR;
                   ! boolean BSU, BSD;
                 )
               (| DP := ((1 when POS_THEORIQUE) default ((-1) when (not POS_THEORIQUE))) when MOUVEMENT when (^HBAR)
                | NP := ZP+DP
                | BSU := true when (NP>=9)
                | BSD := true when (NP<=0)
                | P := (9 when (^BSU)) default (0 when (^BSD)) default NP
                | ZP := P$1
                | DEPLACE_BARRIERE{XBAR,YBAR}
                |)
               where 
               integer DP, NP, P, ZP init 9;
               process DEPLACE_BARRIERE =
                    { integer XBAR, YBAR; }
                    ( ? integer P, ZP;
                    )
                  (| (| X := XBAR when (^P)
                      | Y := YBAR when (^P)
                      | EFFACE_BARRIERE{}
                      | TRACE_BARRIERE{}
                      |)/ X, Y, EFFACE |)
                  where 
                  boolean EFFACE;
                  integer X, Y;
                  process EFFACE_BARRIERE =
                       ( ? integer X, Y, ZP;
                         ! boolean EFFACE;
                       )
                       spec (| X ^= Y ^= ZP ^= EFFACE |)
                  
                  ; 
                  process TRACE_BARRIERE =
                       ( ? integer X, Y, P;
                           boolean EFFACE;
                       )
                       spec (| X ^= Y ^= P ^= EFFACE |)
                  
                  ; 
                  end
               ; 
               end
            ; 
            process CONTROLE =
                 ( ? boolean HMAX, PANNE, REPARER, BCU, BCD, DEFAILLANCE, BSU, BSD;
                   ! boolean POS_THEORIQUE, MOUVEMENT;
                 )
               (| (| (| DESACTIVER := REPARER
                      | ACTIVER := PANNE
                      | H := HMAX
                      | ETAT{}
                      | ZACTIF_1 := ZACTIF
                      |) where boolean H, ACTIVER, DESACTIVER, ZACTIF init false; end/ ACTIF
                   | (| DESACTIVER := BCD
                      | ACTIVER := BCU
                      | H := HMAX
                      | ETAT{}
                      | POS_THEORIQUE := ZACTIF
                      |) where boolean H, ACTIVER, DESACTIVER, ZACTIF init true; end/ ACTIF
                   | (| DESACTIVER := FIN_DEF
                      | ACTIVER := DEFAILLANCE
                      | H := HMAX
                      | ETAT{}
                      | ZACTIF_2 := ZACTIF
                      |) where boolean H, ACTIVER, ZACTIF init false, DESACTIVER; end/ ACTIF
                   | (| DESACTIVER := FIN_MV
                      | ACTIVER := DEB_MV
                      | H := HMAX
                      | ETAT{}
                      | MOUVEMENT := ZACTIF
                      |) where boolean H, ZACTIF init false, ACTIVER, DESACTIVER; end/ ACTIF
                   | (| ZDEFAILLANT := ZACTIF_2
                      | ZPANNE := ZACTIF_1
                      | (| COMMANDE := (^BCU) default (^BCD)
                         | FIN_DEF := (^REPARER) default (^COMMANDE)
                         | DEB_MV := (^REPARER) default ((^COMMANDE) when (not (ZPANNE or ZDEFAILLANT)))
                         | FIN_MV := (^PANNE) default (^DEFAILLANCE) default (^BSU) default (^BSD)
                         |)/ COMMANDE
                      |) where boolean ZPANNE, ZDEFAILLANT; end
                   |)/ FIN_MV, DEB_MV, FIN_DEF, ZACTIF_2, ZACTIF_1 |)
               where 
               boolean COMMANDE, ACTIF, ZACTIF_1 init false, ZACTIF, ZACTIF_2 init false, FIN_DEF, DEB_MV, FIN_MV;
               end
            ; 
            boolean POS_THEORIQUE init true, MOUVEMENT init false;
            end
         ; 
         end
      ; 
      process VOIES =
           { real DMIN, XT1, XT2, XT3, XT4, XT5; }
           ( ? boolean H;
               real V11, V12, LW1;
               integer NW1;
               real V21, V22, LW2;
               integer NW2;
             ! boolean T1S40, T1S41, T1S30, T1S20, T1S10, T2S10, T2S11, T2S20, T2S30, T2S40;
           )
         (| (| NW := NW1
             | LW := LW1
             | V2 := V12
             | V1 := V11
             | SIMUL_VOIE{XT1,XT2,XT3,XT4,XT5,DMIN,140,1,1}
             | T1S40 := T1
             | T1S41 := T2
             | T1S30 := T3
             | T1S20 := T4
             | T1S10 := T5
             |) where real V1, V2, LW;
                      integer NW;
                      boolean T1, T2, T3, T4, T5; end
          | (| NW := NW2
             | LW := LW2
             | V2 := V22
             | V1 := V21
             | SIMUL_VOIE{XT1,XT2,XT3,XT4,XT5,DMIN,370,-1,3}
             | T2S10 := T1
             | T2S11 := T2
             | T2S20 := T3
             | T2S30 := T4
             | T2S40 := T5
             |) where real V1, V2, LW;
                      integer NW;
                      boolean T1, T2, T3, T4, T5; end
          |)
         where 
         process SIMUL_VOIE =
              { real XT1, XT2, XT3, XT4, XT5, DMIN;
                integer YV, SENS, NSLIDER; }
              ( ? boolean H;
                  real V1, V2, LW;
                  integer NW;
                ! boolean T1, T2, T3, T4, T5;
              )
            (| (| SIMUL_CAPTEURS{XT1,XT2,XT3,XT4,XT5}
                | (| VT2 := V2
                   | VT1 := V1
                   | SIMUL_TRAINS{XT1,XT5,DMIN,NSLIDER}
                   |) where real VT1, VT2; end
                | (| LW := LW1
                   | XFIN := XX1
                   | XDEB := X1
                   | AFF_TRAIN{YV,YV-20,SENS}
                   |) where real XDEB, XFIN, LW; end
                | (| LW := LW2
                   | XFIN := XX2
                   | XDEB := X2
                   | AFF_TRAIN{YV,YV-20,SENS}
                   |) where real XDEB, XFIN, LW; end
                |)/ VIT2, LW2, XX2, X2, VIT1, LW1, XX1, X1 |)
            where 
            process SIMUL_TRAINS =
                 { real XDEB, XFIN, DMIN;
                   integer NSLIDER; }
                 ( ? boolean H;
                     real VT1;
                     real VT2;
                     real LW;
                     integer NW;
                   ! real X1;
                     real XX1;
                     real LW1;
                     real VIT1;
                     real X2;
                     real XX2;
                     real LW2;
                     real VIT2;
                 )
               (| (| (| LWAG := LWAG1
                      | NWAG := NWAG1
                      | STOP := STOP1
                      | V := VIT1
                      | TRAIN{XDEB}
                      | X1 := X
                      | XX1 := XX
                      | LW1 := LWAGONS
                      |) where real X, XX, LWAGONS, V, LWAG;
                               boolean STOP;
                               integer NWAG; end
                   | (| LWAG := LWAG2
                      | NWAG := NWAG2
                      | STOP := STOP2
                      | V := VIT2
                      | TRAIN{XDEB}
                      | X2 := X
                      | XX2 := XX
                      | LW2 := LWAGONS
                      |) where real X, XX, LWAGONS, V, LWAG;
                               boolean STOP;
                               integer NWAG; end
                   | (| CONTROLE{DMIN,XDEB,XFIN}
                      | VIT1 := V1
                      | VIT2 := V2
                      |) where real V1, V2; end
                   | (| RAZ := STOP2
                      | RAZV{NSLIDER+1}
                      |) where boolean RAZ; end
                   | (| RAZ := STOP1
                      | RAZV{NSLIDER}
                      |) where boolean RAZ; end
                   |)/ LWAG2, NWAG2, STOP2, LWAG1, NWAG1, STOP1 |)
               where 
               process TRAIN =
                    { real XDEB; }
                    ( ? real V, LWAG;
                        integer NWAG;
                        boolean STOP;
                      ! real X, XX, LWAGONS;
                    )
                  (| (| X := (XDEB when (^STOP)) default (ZX+V)
                      | XX := X-LTRAIN
                      | ZX := X$1
                      | L := LWAG*real(NWAG)
                      | LTRAIN := L default ZLTRAIN
                      | ZLTRAIN := LTRAIN$1
                      | LWAGONS := LWAG default ZLWAGONS
                      | ZLWAGONS := LWAGONS$1
                      | LWAGONS ^= V
                      |)/ ZX, ZXX, L, LTRAIN, ZLTRAIN, ZLWAGONS |)
                  where 
                  real ZX init XDEB, L, LTRAIN, ZLTRAIN init 100.0e0, ZLWAGONS init 10.0e0;
                  end
               ; 
               process CONTROLE =
                    { real DMIN, XDEB, XFIN; }
                    ( ? boolean H;
                        real X1, X2, XX1, XX2, VT1, VT2, LW;
                        integer NW;
                      ! real V1, LWAG1;
                        integer NWAG1;
                        boolean STOP1;
                        real V2, LWAG2;
                        integer NWAG2;
                        boolean STOP2;
                    )
                  (| (| (| ZXXAUTRE := ZXX2
                         | ZXX := ZXX1
                         | ZXAUTRE := ZX2
                         | ZX := ZX1
                         | VT := VT1
                         | CONTROLE_VITESSE{DMIN,XDEB,XFIN}
                         | V1 := V
                         | LWAG1 := LWAG
                         | NWAG1 := NWAG
                         | STOP1 := STOP
                         |) where real VT, V, LWAG, ZX, ZXAUTRE, ZXX, ZXXAUTRE;
                                  integer NWAG;
                                  boolean STOP; end
                      | (| ZXX := ZXX2
                         | ZXXAUTRE := ZXX1
                         | ZX := ZX2
                         | ZXAUTRE := ZX1
                         | VT := VT2
                         | CONTROLE_VITESSE{DMIN,XDEB,XFIN}
                         | V2 := V
                         | LWAG2 := LWAG
                         | NWAG2 := NWAG
                         | STOP2 := STOP
                         |) where real VT, V, LWAG, ZXAUTRE, ZX, ZXXAUTRE, ZXX;
                                  integer NWAG;
                                  boolean STOP; end
                      | (| ZX1 := RESYNC{}(H,X1)
                         | ZX2 := RESYNC{}(H,X2)
                         | ZXX1 := RESYNC{}(H,XX1)
                         | ZXX2 := RESYNC{}(H,XX2)
                         |)
                      |)/ ZXX2, ZXX1, ZX2, ZX1 |)
                  where 
                  real ZX1 init XDEB, ZX2 init XDEB, ZXX1 init XDEB, ZXX2 init XDEB;
                  process RESYNC =
                       ( ? boolean H;
                           real X;
                         ! real ZX;
                       )
                     (| (| Z := X default ZX
                         | ZX := Z$1
                         | Z ^= H
                         |)/ Z |)
                     where 
                     real Z;
                     end
                  ; 
                  process CONTROLE_VITESSE =
                       { real DMIN, XDEB, XFIN; }
                       ( ? boolean H;
                           real ZX, ZXAUTRE, ZXX, ZXXAUTRE, VT, LW;
                           integer NW;
                         ! real V, LWAG;
                           integer NWAG;
                           boolean STOP;
                       )
                     (| STOP := true when (ZXX>XFIN)
                      | VITESSE := (0.0e0 when STOP) default VT default ZVITESSE
                      | ZVITESSE := VITESSE$1
                      | VITESSE ^= H
                      | HV := (^STOP) default (true when ((VITESSE>0.0e0) and ((ZX>=ZXAUTRE) or ((ZX+DMIN)<ZXXAUTRE))))
                      | V := VITESSE when (^HV)
                      | DEMARRAGE := (^V) when (ZXX<=XDEB)
                      | L := LW cell (^DEMARRAGE)
                      | LWAG := L when (^DEMARRAGE)
                      | N := NW cell (^DEMARRAGE)
                      | NWAG := N when (^DEMARRAGE)
                      |)
                     where 
                     integer N init 10;
                     real VITESSE, ZVITESSE init 0.0e0, L init 10.0e0;
                     boolean DEMARRAGE, HV;
                     end
                  ; 
                  end
               ; 
               process RAZV =
                    { integer NSLIDER; }
                    ( ? boolean RAZ;
                    )
                  (| (| NS := NSLIDER when (^RAZ)
                      | RAZSLIDER{}
                      |)/ NS |)
                  where 
                  integer NS;
                  process RAZSLIDER =
                       ( ? integer NS;
                       )
                  
                  ; 
                  end
               ; 
               boolean STOP1, STOP2;
               integer NWAG1, NWAG2;
               real LWAG1, LWAG2;
               end
            ; 
            process SIMUL_CAPTEURS =
                 { real XT1, XT2, XT3, XT4, XT5; }
                 ( ? real X1;
                     real XX1;
                     real X2;
                     real XX2;
                     real VIT1;
                     real VIT2;
                     real LW1;
                     real LW2;
                   ! boolean T1;
                     boolean T2;
                     boolean T3;
                     boolean T4;
                     boolean T5;
                 )
               (| (| MUX_CAPTEUR{XT1}
                   | T1 := T
                   |)/ T
                | (| MUX_CAPTEUR{XT2}
                   | T2 := T
                   |)/ T
                | (| MUX_CAPTEUR{XT3}
                   | T3 := T
                   |)/ T
                | (| MUX_CAPTEUR{XT4}
                   | T4 := T
                   |)/ T
                | (| MUX_CAPTEUR{XT5}
                   | T5 := T
                   |)/ T
                |)
               where 
               process MUX_CAPTEUR =
                    { real XT; }
                    ( ? real X1;
                        real XX1;
                        real LW1;
                        real VIT1;
                        real X2;
                        real XX2;
                        real LW2;
                        real VIT2;
                      ! boolean T;
                    )
                  (| (| (| V := VIT1
                         | LW := LW1
                         | XX := XX1
                         | X := X1
                         | ACTIVITE_CAPTEUR{XT}
                         | DX_1 := DX
                         | LGW_2 := LGW
                         | XW0_3 := XW0
                         |) where real X, XX, LW, V, DX, LGW, XW0; end
                      | (| V := VIT2
                         | LW := LW2
                         | XX := XX2
                         | X := X2
                         | ACTIVITE_CAPTEUR{XT}
                         | DX_4 := DX
                         | LGW_5 := LGW
                         | XW0_6 := XW0
                         |) where real X, XX, LW, V, DX, LGW, XW0; end
                      | (| XW0_2 := XW0_6
                         | LGW2 := LGW_5
                         | DX2 := DX_4
                         | XW0_1 := XW0_3
                         | LGW1 := LGW_2
                         | DX1 := DX_1
                         | (| DX := DX1 default DX2
                            | LGW := LGW1 default LGW2
                            | XW0 := XW0_1 default XW0_2
                            | CAPTEUR{}
                            |)
                         |) where real DX1, LGW1, XW0_1, DX2, LGW2, XW0_2; end
                      |)/ XW0_6, LGW_5, DX_4, XW0_3, LGW_2, DX_1 |)
                  where 
                  real DX, LGW, XW0, DX_1, LGW_2, XW0_3, DX_4, LGW_5, XW0_6;
                  process ACTIVITE_CAPTEUR =
                       { real XT; }
                       ( ? real X, XX, LW, V;
                         ! real DX, LGW, XW0;
                       )
                     (| (| ACTIF := (X>XT) and (XX<=(XT+1.0))
                         | ZACTIF := ACTIF$1
                         | XW0 := (X-XT) when (ACTIF and (not ZACTIF))
                         | LGW := LW when ZACTIF
                         | DX := V when ZACTIF
                         |)/ ACTIF, ZACTIF |)
                     where 
                     boolean ACTIF, ZACTIF init false;
                     end
                  ; 
                  process CAPTEUR =
                       ( ? real DX, LGW, XW0;
                         ! boolean T;
                       )
                     (| Z := ZXW when (^DX)
                      | NXW := Z+DX
                      | T := true when (NXW>=LGW)
                      | XW := XW0 default ((NXW-LGW) when (^T)) default NXW
                      | ZXW := XW$1
                      |)
                     where 
                     real Z, NXW, XW, ZXW init 0e0;
                     end
                  ; 
                  end
               ; 
               end
            ; 
            process AFF_TRAIN =
                 { integer YV1, YV2, SENS; }
                 ( ? real XDEB, XFIN, LW;
                 )
               (| (| L := LW when (^XDEB)
                   | Y1 := YV1 when (^XDEB)
                   | Y2 := YV2 when (^XDEB)
                   | S := SENS when (^XDEB)
                   | ZX1 := X1$1
                   | ZX2 := X2$1
                   | ZX3 := X3$1
                   | DESSINERTRAIN{}
                   |)/ L, Y1, Y2, S, ZX1, ZX2, ZX3, X1, X2, X3 |)
               where 
               integer Y1, Y2, S, ZX1 init 0, ZX2 init 0, ZX3 init 0, X1, X2, X3;
               real L, ZL init 10e0;
               process DESSINERTRAIN =
                    ( ? real XDEB, XFIN, L;
                        integer Y1, Y2, ZX1, ZX2, ZX3, S;
                      ! integer X1, X2, X3;
                    )
                    spec (| XDEB ^= XFIN ^= L ^= Y1 ^= Y2 ^= ZX1 ^= ZX2 ^= ZX3 ^= S ^= X1 ^= X2 ^= X3 |)
               
               ; 
               end
            ; 
            real X1, XX1, LW1, VIT1, X2, XX2, LW2, VIT2;
            end
         ; 
         end
      ; 
      process CONTROLE_PASSAGE =
           { real DIST1, DIST2;
             integer DEL1, DEL2, DEL3, DEL_BARRIERE; }
           ( ? boolean T1S40, T1S30, T1S20, T1S10, T2S10, T2S20, T2S30, T2S40, T1S41, T2S11, B1SU, B1SD, B2SU, B2SD, H1, H100;
             ! boolean TS1E, TS1C, TS1W, TS2E, TS2C, TS2W, L1CH, L1CS, L1CO, L2CH, L2CS, L2CO, B1CU, B1CD, EB1U, EB1D, EB1C, SB1, B2CU, B2CD, EB2U, EB2D, EB2C, SB2;
           )
         (| OCCUPATIONS{}
          | (| T1SC := TS1C
             | PASSAGE{DIST1,DIST2,DEL1,DEL2,DEL3,DEL_BARRIERE}
             |) where boolean T1SC; end
          |)
         where 
         process OCCUPATIONS =
              ( ? boolean T1S40, T1S30, T1S20, T1S10, T2S10, T2S20, T2S30, T2S40;
                ! boolean TS1E, TS1C, TS1W, TS2W, TS2C, TS2E;
              )
            (| (| TS40 := T1S10
                | TS30 := T1S20
                | TS20 := T1S30
                | TS10 := T1S40
                | OCCUPATION_VOIE{}
                | TS1E := OUEST
                | TS1C := CENTRE
                | TS1W := EST
                |) where boolean TS10, TS20, TS30, TS40, OUEST, CENTRE, EST; end
             | (| TS40 := T2S40
                | TS30 := T2S30
                | TS20 := T2S20
                | TS10 := T2S10
                | OCCUPATION_VOIE{}
                | TS2W := OUEST
                | TS2C := CENTRE
                | TS2E := EST
                |) where boolean TS10, TS20, TS30, TS40, OUEST, CENTRE, EST; end
             |)
            where 
            process OCCUPATION_VOIE =
                 ( ? boolean TS10, TS20, TS30, TS40;
                   ! boolean OUEST, CENTRE, EST;
                 )
               (| (| TFIN := TS20
                   | TDEB := TS10
                   | OCCUPATION_SECTEUR{}
                   | OUEST := OCCUPE
                   |) where boolean TDEB, TFIN, OCCUPE; end
                | (| TFIN := TS30
                   | TDEB := TS20
                   | OCCUPATION_SECTEUR{}
                   | CENTRE := OCCUPE
                   |) where boolean TDEB, TFIN, OCCUPE; end
                | (| TFIN := TS40
                   | TDEB := TS30
                   | OCCUPATION_SECTEUR{}
                   | EST := OCCUPE
                   |) where boolean TDEB, TFIN, OCCUPE; end
                |)
               where 
               process OCCUPATION_SECTEUR =
                    ( ? boolean TDEB, TFIN;
                      ! boolean OCCUPE;
                    )
                  (| DN := (0 when (^TDEB) when (^TFIN)) default (1 when (^TDEB)) default ((-1) when (^TFIN))
                   | N := ZN+DN
                   | ZN := N$1
                   | OCCUPE := (true when (ZN=0)) default (false when (N=0))
                   |)
                  where 
                  integer N, ZN init 0, DN;
                  end
               ; 
               end
            ; 
            end
         ; 
         process PASSAGE =
              { real DIST1, DIST2;
                integer DEL1, DEL2, DEL3, DEL_BARRIERE; }
              ( ? boolean B1SU, B1SD, H1, H100, T1S40, T1S41, TS1C, T2S10, T2S11, TS2C, B2SU, B2SD;
                ! boolean L1CH, L1CS, L1CO, B1CU, B1CD, EB1U, EB1D, EB1C, SB1, L2CH, L2CS, L2CO, B2CU, B2CD, EB2U, EB2D, EB2C, SB2;
              )
            (| (| (| TSC := TS2C
                   | TS2 := T2S11
                   | TS1 := T2S10
                   | COMMANDES{DIST1,DIST2,DEL1,DEL2,DEL3,170,220}
                   | MONTER_1 := MONTER
                   | T_2 := T
                   | DESCENDRE_3 := DESCENDRE
                   |) where boolean TS1, TS2, TSC, MONTER, T, DESCENDRE; end
                | (| H := H1
                   | BSD := B1SD
                   | BSU := B1SU
                   | CONTROLE_BARRIERE{DEL_BARRIERE}
                   | L1CH := LCH
                   | L1CS := LCS
                   | L1CO := LCO
                   | B1CU := BCU
                   | B1CD := BCD
                   | EB1U := EBU
                   | EB1D := EBD
                   | EB1C := EBC
                   | SB1 := SB
                   |) where boolean BSU, BSD, H, LCH, LCS, LCO, BCU, BCD, EBU, EBD, EBC, SB; end
                | (| BSD := B2SD
                   | BSU := B2SU
                   | H := H1
                   | CONTROLE_BARRIERE{DEL_BARRIERE}
                   | L2CH := LCH
                   | L2CS := LCS
                   | L2CO := LCO
                   | B2CU := BCU
                   | B2CD := BCD
                   | EB2U := EBU
                   | EB2D := EBD
                   | EB2C := EBC
                   | SB2 := SB
                   |) where boolean H, BSU, BSD, LCH, LCS, LCO, BCU, BCD, EBU, EBD, EBC, SB; end
                | (| TSC := TS1C
                   | TS2 := T1S41
                   | TS1 := T1S40
                   | COMMANDES{DIST1,DIST2,DEL1,DEL2,DEL3,170,200}
                   | MONTER_4 := MONTER
                   | T_5 := T
                   | DESCENDRE_6 := DESCENDRE
                   |) where boolean TS1, TS2, TSC, MONTER, T, DESCENDRE; end
                | (| D1 := DESCENDRE_6
                   | T1 := T_5
                   | M1 := MONTER_4
                   | D2 := DESCENDRE_3
                   | T2 := T_2
                   | M2 := MONTER_1
                   | FILTRE_COMMANDES{}
                   |) where boolean M2, T2, D2, M1, T1, D1; end
                |)/ FERMER, OUVRIR, DESCENDRE_6, T_5, MONTER_4, DESCENDRE_3, T_2, MONTER_1 |)
            where 
            process COMMANDES =
                 { real DIST1, DIST2;
                   integer DEL1, DEL2, DEL3;
                   integer X, Y; }
                 ( ? boolean H100, H1, TS1, TS2, TSC;
                   ! boolean DESCENDRE, T, MONTER;
                 )
               (| (| (| RAZ := TOP
                      | ENTREE := TS1
                      | VERROU{true}
                      | SORTIE_1 := SORTIE
                      |) where boolean ENTREE, SORTIE, RAZ; end
                   | (| CAPTEUR := TS2
                      | H := H1
                      | FIN_CONVOI{DEL3}
                      |) where boolean H, CAPTEUR; end
                   | (| STOP := SORTIE_2
                      | START := SORTIE_1
                      | COMMANDE_DESCENTE{DIST1,DIST2,DEL1,DEL2,X,Y}
                      |) where boolean START, STOP; end
                   | (| RAZ := TOP
                      | ENTREE := TS2
                      | VERROU{true}
                      | SORTIE_2 := SORTIE
                      |) where boolean ENTREE, RAZ, SORTIE; end
                   | MONTER := true when (not TSC)
                   |)/ SORTIE_2, TOP, SORTIE_1 |)
               where 
               process COMMANDE_DESCENTE =
                    { real DIST1, DIST2;
                      integer DEL1, DEL2;
                      integer X, Y; }
                    ( ? boolean H100, START, STOP, H1;
                      ! boolean T, DESCENDRE;
                    )
                  (| (| (| H := H100
                         | CHRONO{}
                         |) where boolean H; end
                      | (| H := H1
                         | (| ATTENTE := integer((real(DUREE)*(DIST2/DIST1))/100.0)-DEL1
                            | N0 := ATTENTE when (ATTENTE>0)
                            | DELAI{}
                            | T := (true when (ATTENTE<=DEL2)) default (true when (N=DEL2))
                            | DESCENDRE := (true when (ATTENTE<=0)) default (^TOP)
                            |)/ ATTENTE, N0, TOP
                         |) where boolean H; end
                      | AFFICHE_COMPTEUR{X,Y}
                      |)/ N, DUREE |)
                  where 
                  boolean TOP;
                  integer ATTENTE, N0, DUREE, N;
                  end
               ; 
               process FIN_CONVOI =
                    { integer DEL3; }
                    ( ? boolean CAPTEUR, H;
                      ! boolean TOP;
                    )
                  (| (| N0 := DEL3 when (^CAPTEUR)
                      | DELAI{}
                      |)/ N0, N |)
                  where 
                  integer N, N0;
                  end
               ; 
               boolean SORTIE_1, SORTIE, TOP, SORTIE_2;
               end
            ; 
            process FILTRE_COMMANDES =
                 ( ? boolean M1, T1, M2, T2, D1, D2;
                   ! boolean OUVRIR, FERMER;
                 )
               (| COMPTE_TRAINS{}
                | (| F := (^D1) default (^D2)
                   | FERMER := VERROU{true}(OUVRIR,F)
                   |)/ F
                |)
               where 
               boolean F;
               process COMPTE_TRAINS =
                    ( ? boolean T1, M1, T2, M2;
                      ! boolean OUVRIR;
                    )
                  (| HN := (^T1) default (^T2) default (^M1) default (^M2)
                   | ZERO := 0 when (^HN)
                   | DN1 := (1 when (^T1)) default ZERO
                   | DN2 := (1 when (^T2)) default ZERO
                   | DN3 := ((-1) when (^M1)) default ZERO
                   | DN4 := ((-1) when (^M2)) default ZERO
                   | N := ZN+DN1+DN2+DN3+DN4
                   | ZN := N$1
                   | OUVRIR := true when (N=0)
                   | ERREUR := true when (N<0)
                   | ALERTE{}
                   |)
                  where 
                  integer ZERO, DN1, DN2, DN3, DN4, N, ZN init 0;
                  boolean HN, ERREUR;
                  process ALERTE =
                       ( ? boolean ERREUR;
                       )
                  
                  ; 
                  end
               ; 
               end
            ; 
            process CONTROLE_BARRIERE =
                 { integer DEL_BARRIERE; }
                 ( ? boolean H, OUVRIR, FERMER, BSU, BSD;
                   ! boolean EBU, LCH, EBD, SB;
                     boolean EBC, BCU;
                     boolean BCD, LCS, LCO;
                 )
               (| (| SB := (^BSU) default (not (^BSD))
                   | EBC := ^SB
                   | BCU := (^OUVRIR) default (^EBU)
                   | BCD := (^FERMER) default (^EBD)
                   | LCS := (^FERMER) default (^BSD)
                   | LCO := ^BSU
                   |)
                | (| INHIBER := BSU
                   | COMMANDE := OUVRIR
                   | GARDE{DEL_BARRIERE}
                   | EBU := TIMEOUT
                   |) where boolean COMMANDE, INHIBER, TIMEOUT; end
                | (| COMMANDE := EBD
                   | INHIBER := BSD
                   | GARDE{DEL_BARRIERE}
                   | LCH := TIMEOUT
                   |) where boolean INHIBER, TIMEOUT, COMMANDE; end
                | (| INHIBER := BSD
                   | COMMANDE := FERMER
                   | GARDE{DEL_BARRIERE}
                   | EBD := TIMEOUT
                   |) where boolean COMMANDE, INHIBER, TIMEOUT; end
                |)
               where 
               process GARDE =
                    { integer DEL_BARRIERE; }
                    ( ? boolean H, COMMANDE, INHIBER;
                      ! event TIMEOUT;
                    )
                  (| (| HN := (^COMMANDE) default (^INHIBER) default (^H)
                      | N ^= HN
                      | N := (DEL_BARRIERE when (^COMMANDE)) default (0 when (^INHIBER)) default ((ZN-1) when (ZN>0)) default ZN
                      | ZN := N$1
                      | TIMEOUT := (^H) when (ZN=1)
                      |)/ N, ZN, HN |)
                  where 
                  event HN;
                  integer N, ZN init 0;
                  end
               ; 
               end
            ; 
            boolean MONTER_1, MONTER, T_2, T, DESCENDRE_3, DESCENDRE, MONTER_4, T_5, DESCENDRE_6, OUVRIR, FERMER;
            end
         ; 
         end
      ; 
      boolean T1S40, T1S41, T1S30, T1S20, T1S10, T2S10, T2S11, T2S20, T2S30, T2S40, B1SU, B1SD, B2SU, B2SD, B1CU, B1CD, B2CU, B2CD;
      end
   ; 
   process GRAPHIQUES =
        ( ? boolean H;
            boolean L1CH, L1CS, L1CO, L2CH, L2CS, L2CO, TS1E, TS1C, TS1W, TS2W, TS2C, TS2E, SB1, EB1U, EB1D, EB1C, SB2, EB2U, EB2D, EB2C;
        )
      (| FEUX_GRAPHIQUES{}
       | TABLEAU_GRAPHIQUE{}
       |)
      where 
      process TABLEAU_GRAPHIQUE =
           ( ? boolean TS1E, TS1C, TS1W, TS2E, TS2C, TS2W, SB1, EB1U, EB1D, EB1C, SB2, EB2U, EB2D, EB2C;
           )
         (| (| TSW := TS1W
             | TSC := TS1C
             | TSE := TS1E
             | TEMOINS_VOIE{0,60,120,240,360}
             |) where boolean TSE, TSC, TSW; end
          | (| TSW := TS2W
             | TSC := TS2C
             | TSE := TS2E
             | TEMOINS_VOIE{0,100,120,240,360}
             |) where boolean TSE, TSC, TSW; end
          | (| EBC := EB1C
             | EBD := EB1D
             | EBU := EB1U
             | SB := SB1
             | TEMOINS_BARRIERE{0,200,137,280,400}
             |) where boolean SB, EBU, EBD, EBC; end
          | (| EBC := EB2C
             | EBD := EB2D
             | EBU := EB2U
             | SB := SB2
             | TEMOINS_BARRIERE{0,240,137,280,400}
             |) where boolean SB, EBU, EBD, EBC; end
          |)
         where 
         process TEMOINS_VOIE =
              { integer F, Y, X1, X2, X3; }
              ( ? boolean TSE, TSC, TSW;
              )
            (| (| T := TSE
                | TEMOIN{F,X1,Y,X1+100,Y+20}
                |) where boolean T; end
             | (| T := TSC
                | TEMOIN{F,X2,Y,X2+100,Y+20}
                |) where boolean T; end
             | (| T := TSW
                | TEMOIN{F,X3,Y,X3+100,Y+20}
                |) where boolean T; end
             |)
         ; 
         process TEMOINS_BARRIERE =
              { integer F, Y, X1, X2, X3; }
              ( ? boolean SB, EBU, EBD, EBC;
              )
            (| (| (| T := SB
                   | TEMOIN{F,X1,Y,X1+50,Y+20}
                   |) where boolean T; end
                | (| T1 := (^EBU) default (not (^EBC))
                   | T2 := (^EBD) default (not (^EBC))
                   |)
                | (| T := T1
                   | TEMOIN{F,X2,Y,X2+100,Y+20}
                   |) where boolean T; end
                | (| T := T2
                   | TEMOIN{F,X3,Y,X3+100,Y+20}
                   |) where boolean T; end
                |)/ T2, T1 |)
            where 
            boolean T1, T2;
            end
         ; 
         end
      ; 
      process FEUX_GRAPHIQUES =
           ( ? boolean H, L1CH, L1CS, L1CO, L2CH, L2CS, L2CO;
           )
         (| (| LCO := L1CO
             | LCS := L1CS
             | LCH := L1CH
             | FEU_GRAPH{1,498,72,514,88}
             |) where boolean LCH, LCS, LCO; end
          | (| LCO := L2CO
             | LCS := L2CS
             | LCH := L2CH
             | FEU_GRAPH{1,498,302,514,318}
             |) where boolean LCH, LCS, LCO; end
          |)
         where 
         process FEU_GRAPH =
              { integer F, X1, Y1, X2, Y2; }
              ( ? boolean H, LCH, LCS, LCO;
              )
            (| (| TSTABLE := (^LCH) default (not (^LCO))
                | (ACTIF,ZACTIF) := ETAT{}(LCS,TSTABLE,H)
                | HCLIGNO := (^H) when ACTIF
                | TCLIGNO := not ZTCLIGNO
                | ZTCLIGNO := TCLIGNO$1
                | TCLIGNO ^= HCLIGNO
                | T := TSTABLE default TCLIGNO
                | TEMOIN{F,X1,Y1,X2,Y2}
                |)/ TSTABLE, ACTIF, ZACTIF, HCLIGNO, TCLIGNO, ZTCLIGNO, T |)
            where 
            boolean TSTABLE, ACTIF, ZACTIF init false, HCLIGNO, TCLIGNO, ZTCLIGNO init false, T;
            end
         ; 
         end
      ; 
      end
   ; 
   process VERROU =
        { boolean INITIAL; }
        ( ? boolean RAZ, ENTREE;
          ! boolean SORTIE;
        )
      (| (| PASSANT := (^RAZ) default (not (^ENTREE))
          | ZPASSANT := PASSANT$1
          | SORTIE := ENTREE when ZPASSANT
          |)/ PASSANT, ZPASSANT |)
      where 
      boolean PASSANT, ZPASSANT init INITIAL;
      end
   ; 
   process ETAT =
        ( ? boolean ACTIVER, DESACTIVER, H;
          ! boolean ACTIF, ZACTIF;
        )
      (| (| HACTIF := (^ACTIVER) default (^DESACTIVER) default (^H)
          | ACTIF ^= HACTIF
          | ACTIF := (^ACTIVER) default (not (^DESACTIVER)) default ZACTIF
          | ZACTIF := ACTIF$1
          |)/ HACTIF |)
      where 
      boolean HACTIF;
      end
   ; 
   process DELAI =
        ( ? boolean H;
            integer N0;
          ! boolean TOP;
            integer N;
        )
      (| (| N := N0 default ((ZN-1) when (ZN>0)) default ZN
          | ZN := N$1
          | HN := (^N0) default (^H)
          | N ^= HN
          | TOP := (^H) when (ZN=1)
          |)/ ZN, HN |)
      where 
      boolean HN;
      integer ZN init 0;
      end
   ; 
   process CHRONO =
        ( ? boolean H, START, STOP;
          ! integer DUREE;
        )
      (| (| (| DESACTIVER := STOP
             | ACTIVER := START
             | (| ETAT{}
                | COMPTER := (^H) when ACTIF
                |)
             |) where boolean ACTIVER, DESACTIVER; end/ ACTIF
                                             / ZACTIF
          | (| N := (0 when (^START)) default (ZN+1)
             | ZN := N$1
             | HN := (^START) default (^STOP) default (^COMPTER)
             | N ^= HN
             | DUREE := N when (^STOP)
             |)/ HN, N, ZN
          |)/ COMPTER |)
      where 
      boolean COMPTER, ACTIF, ZACTIF init false, HN;
      integer ZN init 0, N;
      end
   ; 
   process P_MODULO =
        { integer M; }
        ( ? boolean HE;
          ! boolean HS;
        )
      (| HS := true when (ZN=1)
       | N := (M when (^HS)) default (ZN-1)
       | ZN := N$1
       | N ^= HE
       |)
      where 
      integer N, ZN init 1;
      end
   ; 
   process TEMOIN =
        { integer F, XX1, YY1, XX2, YY2; }
        ( ? boolean T;
        )
      (| (| COULEUR := (1 when T) default (0 when (^T))
          | FEN := F when (^T)
          | X1 := XX1 when (^T)
          | X2 := XX2 when (^T)
          | Y1 := YY1 when (^T)
          | Y2 := YY2 when (^T)
          | RECTANGLE{}
          |)/ COULEUR, X1, X2, Y1, Y2, FEN |)
      where 
      integer COULEUR, X1, X2, Y1, Y2, FEN;
      process RECTANGLE =
           ( ? integer FEN;
               integer X1, Y1, X2, Y2, COULEUR;
           )
           spec (| FEN ^= X1 ^= Y1 ^= X2 ^= Y2 ^= COULEUR |)
      
      ; 
      end
   ; 
   process AFFICHE_COMPTEUR =
        { integer X, Y; }
        ( ? integer N;
        )
      (| (| X1 := X when (^N)
          | Y1 := Y when (^N)
          | AFFENTIER{}
          |)/ X1, Y1 |)
      where 
      integer X1, Y1;
      process AFFENTIER =
           ( ? integer N, X1, Y1;
           )
           spec (| N ^= X1 ^= Y1 |)
      
      ; 
      end
   ; 
   process GERE_ENTREES =
        ( ? boolean H, HV11;
            real V11;
            boolean HV12;
            real V12;
            boolean HLW1;
            real LW1;
            boolean HNW1;
            integer NW1;
            boolean HV21;
            real V21;
            boolean HV22;
            real V22;
            boolean HLW2;
            real LW2;
            boolean HNW2;
            integer NW2;
            boolean HREPARER1, HPANNE1, HDEFAILLANCE1, HREPARER2, HPANNE2, HDEFAILLANCE2;
          ! boolean HMOD100, HMOD40, HMAX;
            boolean REPARER1, PANNE1, DEFAILLANCE1, REPARER2, PANNE2, DEFAILLANCE2;
        )
      (| GENERE_HORLOGES{}
       | (| H := HMOD40
          | ENTREES{}
          |) where boolean H; end
       |)
      where 
      process GENERE_HORLOGES =
           ( ? boolean H;
             ! boolean HMOD100, HMAX, HMOD40;
           )
         (| (| HE := H
             | P_MODULO{100}
             | HMOD100 := HS
             |) where boolean HE, HS; end
          | (| HE := H
             | P_MODULO{40}
             | HMOD40 := HS
             |) where boolean HE, HS; end
          | HMAX := H
          |)
      ; 
      process ENTREES =
           ( ? boolean H, HV11;
               real V11;
               boolean HV12;
               real V12;
               boolean HLW1;
               real LW1;
               boolean HNW1;
               integer NW1;
               boolean HV21;
               real V21;
               boolean HV22;
               real V22;
               boolean HLW2;
               real LW2;
               boolean HNW2;
               integer NW2;
               boolean HREPARER1, HPANNE1, HDEFAILLANCE1, HREPARER2, HPANNE2, HDEFAILLANCE2;
             ! boolean REPARER1, PANNE1, DEFAILLANCE1, REPARER2, PANNE2, DEFAILLANCE2;
           )
         (| (| NW := NW1
             | HNW := HNW1
             | LW := LW1
             | HLW := HLW1
             | V2 := V12
             | HV2 := HV12
             | V1 := V11
             | HV1 := HV11
             | ENTREES_VOIE{}
             |) where boolean HV1, HV2, HLW, HNW;
                      real V1, V2, LW;
                      integer NW; end
          | (| NW := NW2
             | HNW := HNW2
             | LW := LW2
             | HLW := HLW2
             | V2 := V22
             | HV2 := HV22
             | V1 := V21
             | HV1 := HV21
             | ENTREES_VOIE{}
             |) where boolean HV1, HV2, HLW, HNW;
                      real V1, V2, LW;
                      integer NW; end
          | (| HDEFAILLANCE := HDEFAILLANCE1
             | HPANNE := HPANNE1
             | HREPARER := HREPARER1
             | ENTREES_BARRIERE{}
             | REPARER1 := REPARER
             | PANNE1 := PANNE
             | DEFAILLANCE1 := DEFAILLANCE
             |) where boolean HREPARER, HPANNE, HDEFAILLANCE, REPARER, PANNE, DEFAILLANCE; end
          | (| HDEFAILLANCE := HDEFAILLANCE2
             | HPANNE := HPANNE2
             | HREPARER := HREPARER2
             | ENTREES_BARRIERE{}
             | REPARER2 := REPARER
             | PANNE2 := PANNE
             | DEFAILLANCE2 := DEFAILLANCE
             |) where boolean HREPARER, HPANNE, HDEFAILLANCE, REPARER, PANNE, DEFAILLANCE; end
          |)
         where 
         process ENTREES_VOIE =
              ( ? boolean H, HV1;
                  real V1;
                  boolean HV2;
                  real V2;
                  boolean HLW;
                  real LW;
                  boolean HNW;
                  integer NW;
              )
            (| (| HV1 ^= HV2 ^= HLW ^= HNW ^= H
                | LIREV1 := true when HV1
                | V1 ^= LIREV1
                | LIREV2 := true when HV2
                | V2 ^= LIREV2
                | LIRELW := true when HLW
                | LW ^= LIRELW
                | LIRENW := true when HNW
                | NW ^= LIRENW
                |)/ LIREV1, LIREV2, LIRELW, LIRENW |)
            where 
            boolean LIREV1, LIREV2, LIRELW, LIRENW;
            end
         ; 
         process ENTREES_BARRIERE =
              ( ? boolean H, HREPARER, HPANNE, HDEFAILLANCE;
                ! boolean REPARER, PANNE, DEFAILLANCE;
              )
            (| REPARER := true when HREPARER
             | PANNE := true when HPANNE
             | DEFAILLANCE := true when HDEFAILLANCE
             | HREPARER ^= HPANNE ^= HDEFAILLANCE ^= H
             |)
         ; 
         end
      ; 
      end
   ; 
   boolean L1CH, L1CS, L1CO, L2CH, L2CS, L2CO, TS1E, TS1C, TS1W, TS2W, TS2C, TS2E, SB1, EB1U, EB1D, EB1C, SB2, EB2U, EB2D, EB2C, HMOD40, HMAX, HMOD100, REPARER1, PANNE1, DEFAILLANCE1, REPARER2, PANNE2, DEFAILLANCE2;
   end
; 
