process SIMULATEUR =
     { integer N, NUL_CODE, LIN_CODE;
       integer TICK_NUMBER, FRONT_NUMBER, DELTA;
       integer TICK_NUMBER_BIS, FRONT_NUMBER_BIS, DELTA_BIS; }
     ( ? event HE;
     )
   (| (| CIRCUIT{}
       | CONTEXT{N,NUL_CODE,LIN_CODE,true,12345,67890}
       | (| (| SCREEN{TICK_NUMBER,FRONT_NUMBER,DELTA,1,1,2,5,1,140,10000.0e0,1000.0e0}
             | SCREEN{TICK_NUMBER_BIS,FRONT_NUMBER_BIS,DELTA_BIS,8,3,4,60,5,140,10000.0e0,1000.0e0}
             | WRITE_TIME{}(H_0_FIN,HSEC)
             |)
          | COMPRESS{0}
          |)
       |)/ OFF36, ON36, OFF35, ON35, OFF34, ON34, OFF33, ON33, OFF32, ON32, OFF31, ON31, OFF7, ON7, OFF6, ON6, OFF5, ON5, OFF4, ON4, ARRET, MARCHE, OFF2, ON2, OFF1, ON1, HSEC, HSCAN, H_0_FIN, ZPR_EV, ZPA_EV, PR_EV, PA_EV, EV, PR, PA |)
   where 
   process CIRCUIT =
        ( ? event HSEC;
            event ON1;
            event OFF1;
            event ON2;
            event OFF2;
            event MARCHE;
            event ARRET;
            event ON4;
            event OFF4;
            event ON5;
            event OFF5;
            event ON6;
            event OFF6;
            event ON7;
            event OFF7;
            event ON31;
            event OFF31;
            event ON32;
            event OFF32;
            event ON33;
            event OFF33;
            event ON34;
            event OFF34;
            event ON35;
            event OFF35;
            event ON36;
            event OFF36;
            boolean H_0_FIN;
            event HSCAN;
          ! real PA;
            real PR;
            event EV;
            real PA_EV;
            real PR_EV;
            real ZPA_EV;
            real ZPR_EV;
        )
      (| (| (| EV36 := EV_39
             | PR36 := PR_38
             | PA36 := PA_37
             | EV35 := EV_36
             | PR35 := PR_35
             | PA35 := PA_34
             | EV34 := EV_33
             | PR34 := PR_32
             | PA34 := PA_31
             | EV33 := EV_30
             | PR33 := PR_29
             | PA33 := PA_28
             | EV32 := EV_27
             | PR32 := PR_26
             | PA32 := PA_25
             | EV31 := EV_24
             | PR31 := PR_23
             | PA31 := PA_22
             | EV7 := EV_21
             | PR7 := PR_20
             | PA7 := PA_19
             | EV6 := EV_18
             | PR6 := PR_17
             | PA6 := PA_16
             | EV5 := EV_15
             | PR5 := PR_14
             | PA5 := PA_13
             | EV4 := EV_12
             | PR4 := PR_11
             | PA4 := PA_10
             | EV2 := EV_9
             | PR2 := PR_8
             | PA2 := PA_7
             | EV1 := EV_6
             | PR1 := PR_5
             | PA1 := PA_4
             | EV3 := EV_3
             | PR3 := PR_2
             | PA3 := PA_1
             | MODEL_CIRCUIT{}
             |) where real PA3, PR3, PA1, PR1, PA2, PR2, PA4, PR4, PA5, PR5, PA6, PR6, PA7, PR7, PA31, PR31, PA32, PR32, PA33, PR33, PA34, PR34, PA35, PR35, PA36, PR36;
                      event EV3, EV1, EV2, EV4, EV5, EV6, EV7, EV31, EV32, EV33, EV34, EV35, EV36; end
          | (| (| LAVE_LINGE{25,26,27,28,29,30,3,2000.0e0,200.0e0,200.0e0,60.0e0}
                | PA_1 := PA
                | PR_2 := PR
                | EV_3 := EV
                |) where real PA, PR;
                         event EV; end
             | (| OFF := OFF1
                | VON := ON1
                | CONVECTEUR{1,2,3,4,1,5*60,7*60,8*60,11*60,800.0e0,5.0e0,15.0e0,3.0e0,0.0e0,780.0e0,3.0e0,15.0e0,3.0e0,0.0e0}
                | PA_4 := PA
                | PR_5 := PR
                | EV_6 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF2
                | VON := ON2
                | CONVECTEUR{5,6,7,8,2,7*60,8*60,9*60,10*60,1554e0,4.0e0,20.0e0,10.0e0,2.0e0,1525.0e0,4.0e0,18.0e0,8.0e0,2.5e0}
                | PA_7 := PA
                | PR_8 := PR
                | EV_9 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF4
                | VON := ON4
                | CONVECTEUR{9,10,11,12,4,30*60,70*60,1*3600,24*3600,1000e0,1e0,20.0e0,10.0e0,5.0e0,971.0e0,1.0e0,15.0e0,8.0e0,5.0e0}
                | PA_10 := PA
                | PR_11 := PR
                | EV_12 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF5
                | VON := ON5
                | CONVECTEUR{13,14,15,16,5,50,70,60,90,1500.0e0,400.0e0,4000.0e0,8000.0e0,300.0e0,1470.0e0,390.0e0,4000.0e0,8000.0e0,300.0e0}
                | PA_13 := PA
                | PR_14 := PR
                | EV_15 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF6
                | VON := ON6
                | CONVECTEUR{17,18,19,20,6,4*60,5*60,25*60,30*60,1350.0e0,4.0e0,20.0e0,1.0e0,0.0e0,1320.0e0,3.0e0,20.0e0,1.0e0,0.0e0}
                | PA_16 := PA
                | PR_17 := PR
                | EV_18 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF7
                | VON := ON7
                | CONVECTEUR{21,22,23,24,7,8*60,12*60,10*60,15*60,350.0e0,320.0e0,60.0e0,20.0e0,0.0e0,260.0e0,300.0e0,40.0e0,20.0e0,0.0e0}
                | PA_19 := PA
                | PR_20 := PR
                | EV_21 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             |)
          | (| (| OFF := OFF31
                | VON := ON31
                | LECTURE_FICHIER{1}
                | PA_22 := PA
                | PR_23 := PR
                | EV_24 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF32
                | VON := ON32
                | LECTURE_FICHIER{2}
                | PA_25 := PA
                | PR_26 := PR
                | EV_27 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF33
                | VON := ON33
                | LECTURE_FICHIER{3}
                | PA_28 := PA
                | PR_29 := PR
                | EV_30 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF34
                | VON := ON34
                | LECTURE_FICHIER{4}
                | PA_31 := PA
                | PR_32 := PR
                | EV_33 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF35
                | VON := ON35
                | LECTURE_FICHIER{5}
                | PA_34 := PA
                | PR_35 := PR
                | EV_36 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             | (| OFF := OFF36
                | VON := ON36
                | LECTURE_FICHIER{6}
                | PA_37 := PA
                | PR_38 := PR
                | EV_39 := EV
                |) where event VON, OFF, EV;
                         real PA, PR; end
             |)
          |)/ EV_39, PR_38, PA_37, EV_36, PR_35, PA_34, EV_33, PR_32, PA_31, EV_30, PR_29, PA_28, EV_27, PR_26, PA_25, EV_24, PR_23, PA_22, EV_21, PR_20, PA_19, EV_18, PR_17, PA_16, EV_15, PR_14, PA_13, EV_12, PR_11, PA_10, EV_9, PR_8, PA_7, EV_6, PR_5, 
              PA_4, EV_3, PR_2, PA_1 |)
      where 
      process MODEL_CIRCUIT =
           ( ? real PA1;
               real PR1;
               event EV1;
               real PA2;
               real PR2;
               event EV2;
               real PA3;
               real PR3;
               event EV3;
               real PA4;
               real PR4;
               event EV4;
               real PA5;
               real PR5;
               event EV5;
               real PA6;
               real PR6;
               event EV6;
               real PA7;
               real PR7;
               event EV7;
               real PA31;
               real PR31;
               event EV31;
               real PA32;
               real PR32;
               event EV32;
               real PA33;
               real PR33;
               event EV33;
               real PA34;
               real PR34;
               event EV34;
               real PA35;
               real PR35;
               event EV35;
               real PA36;
               real PR36;
               event EV36;
               event HSCAN;
             ! real PA;
               real PR;
               event EV;
               real PA_EV;
               real PR_EV;
               real ZPA_EV;
               real ZPR_EV;
           )
         (| PA_SIMUL := PA1+PA2+PA3+PA4+PA5+PA6+PA7
          | PR_SIMUL := PR1+PR2+PR3+PR4+PR5+PR6+PR7
          | PA_REEL := PA31+PA32+PA33+PA34+PA35+PA36
          | PR_REEL := PR31+PR32+PR33+PR34+PR35+PR36
          | PAA := PA_SIMUL+PA_REEL
          | PRR := PR_SIMUL+PR_REEL
          | ZPAA := PAA$1
          | ZPRR := PRR$1
          | EV := EV1 default EV2 default EV3 default EV4 default EV5 default EV6 default EV7 default EV31 default EV32 default EV33 default EV34 default EV35 default EV36
          | HSCAN ^= PAA ^= PRR
          | PA_EV := PAA when EV
          | PR_EV := PRR when EV
          | ZPA_EV := ZPAA when EV
          | ZPR_EV := ZPRR when EV
          | HA := ^PA
          | HR := ^PR
          | CPA := PAA cell HA
          | CPR := PRR cell HR
          | PA := CPA when HA
          | PR := CPR when HR
          |)
         where 
         real CPR init 0.0;
         real CPA init 0.0;
         event HA, HR;
         real ZPRR init 0.0;
         real ZPAA init 0.0;
         real PRR;
         real PAA;
         real PA_SIMUL, PR_SIMUL, PA_REEL, PR_REEL;
         end
      ; 
      process LAVE_LINGE =
           { integer NUMGEN1, NUMGEN2, NUMGEN3, NUMGEN4, NUMGEN5, NUMGEN6;
             integer NUMERO_FICHIER;
             real R, M1, M2, M3; }
           ( ? event MARCHE;
               event ARRET;
               event HSEC;
               boolean H_0_FIN;
             ! real PA;
               real PR;
               event EV;
           )
         (| (| (| OFF1 := OFF_16
                | ON1 := ON_15
                | PR1 := PR_14
                | PA1 := PA_13
                | OFF2 := OFF_12
                | ON2 := ON_11
                | PR2 := PR_10
                | PA2 := PA_9
                | OFF3 := OFF_8
                | ON3 := ON_7
                | PR3 := PR_6
                | PA3 := PA_5
                | (| CA := (PA1+PA2+PA3) cell HSEC
                   | PA := CA when HSEC
                   | ZPA := PA$1
                   | CR := (PR1+PR2+PR3) cell HSEC
                   | PR := CR when HSEC
                   | ZPR := PR$1
                   | VON := ON1 default ON2 default ON3
                   | OFF := OFF1 default OFF2 default OFF3
                   | EV := VON default OFF
                   |)/ CA, CR
                | PA_1 := PA
                | PR_2 := PR
                | ON_3 := VON
                | OFF_4 := OFF
                |) where real PA, PR, PA3, PR3, PA2, PR2, PA1, PR1;
                         event VON, OFF, ON3, OFF3, ON2, OFF2, ON1, OFF1; end
             | (| PR1 := PR_2
                | PA1 := PA_1
                | (| HA := ^PA
                   | CA := PA1 cell HA
                   | PA := CA when HA
                   | HR := ^PR
                   | CR := PR1 cell HR
                   | PR := CR when HR
                   |)
                |) where real PA1, PR1; end
             | (| OFF := OFF_4
                | VON := ON_3
                | ZPR1 := ZPR
                | ZPA1 := ZPA
                | PR1 := PR_2
                | PA1 := PA_1
                | ECRIRE_FICHIER{NUMERO_FICHIER}
                |) where real PA1, PR1, ZPA1, ZPR1;
                         event VON, OFF; end
             | (| POMPE{M3}
                | PA_5 := PA
                | PR_6 := PR
                | ON_7 := VON
                | OFF_8 := OFF
                |) where real PA, PR;
                         event VON, OFF; end
             | (| TAMBOUR{M1,M2}
                | PA_9 := PA
                | PR_10 := PR
                | ON_11 := VON
                | OFF_12 := OFF
                |) where real PA, PR;
                         event VON, OFF; end
             | (| CHAUFFAGE{R}
                | PA_13 := PA
                | PR_14 := PR
                | ON_15 := VON
                | OFF_16 := OFF
                |) where real PA, PR;
                         event VON, OFF; end
             | (| H := HSEC
                | PROGRAMMATEUR{NUMGEN1,NUMGEN2,NUMGEN3,NUMGEN4,NUMGEN5,NUMGEN6}
                |) where event H; end
             |)/ I_POMPE, I_TAMBOUR, I_CHAUFFE, OFF_16, ON_15, PR_14, PA_13, OFF_12, ON_11, PR_10, PA_9, OFF_8, ON_7, PR_6, PA_5, OFF_4, ON_3, ZPR, ZPA, PR_2, PA_1 |)
         where 
         event H, ON_3, VON, OFF_4, OFF, ON_7, OFF_8, ON_11, OFF_12, ON_15, OFF_16;
         boolean Z_RUN init false;
         boolean RUN, I_CHAUFFE, I_TAMBOUR, I_POMPE;
         CA, CR, HA, HR;
         process CHAUFFAGE =
              { real R; }
              ( ? boolean I_CHAUFFE;
                ! real PA;
                  real PR;
                  event VON;
                  event OFF;
              )
            (| PA := (R when I_CHAUFFE) default (0.0e0 when (not I_CHAUFFE))
             | ZPA := PA$1
             | PR := 0.0e0
             | PA ^= PR
             | VON := when ((PA<1.0e-10) and (ZPA>1.0e-10))
             | OFF := when ((PA>1.0e-10) and (ZPA<1.0e-10))
             |)
            where 
            real ZPA init 0.0;
            end
         ; 
         process TAMBOUR =
              { real M1, M2; }
              ( ? boolean I_TAMBOUR;
                ! real PA;
                  real PR;
                  event VON;
                  event OFF;
              )
            (| (| PA := (M1 when I_TAMBOUR) default (0.0e0 when (not I_TAMBOUR))
                | PR := (M2 when I_TAMBOUR) default (0.0e0 when (not I_TAMBOUR))
                | ZPA := PA$1
                | ONA2 := when ((PA<1.0e-10) and (ZPA>1.0e-10))
                | OFFA2 := when ((PA>1.0e-10) and (ZPA<1.0e-10))
                | ZPR := PR$1
                | ONR2 := when ((PR<1.0e-10) and (ZPR>1.0e-10))
                | OFFR2 := when ((PR>1.0e-10) and (ZPR<1.0e-10))
                | VON := ONA2 default ONR2
                | OFF := OFFA2 default OFFR2
                |)/ ONA2, OFFA2, ONR2, OFFR2, ZPA, ZPR |)
            where 
            event ONA2, ONR2, OFFA2, OFFR2;
            real ZPR init 0.0e0;
            real ZPA init 0.0e0;
            end
         ; 
         process POMPE =
              { real M3; }
              ( ? boolean I_POMPE;
                ! real PA;
                  real PR;
                  event VON;
                  event OFF;
              )
            (| PA := (M3 when I_POMPE) default (0.0e0 when (not I_POMPE))
             | ZPA := PA$1
             | PR := 0.0e0
             | PA ^= PR
             | VON := when ((PA<1.0e-10) and (ZPA>1.0e-10))
             | OFF := when ((PA>1.0e-10) and (ZPA<1.0e-10))
             |)
            where 
            real ZPA init 0.0;
            end
         ; 
         process PUISSANCE =
              ( ? real PA1;
                  real PR1;
                  real PA2;
                  real PR2;
                  real PA3;
                  real PR3;
                  event HSEC;
                ! real PA;
                  real PR;
                  real ZPA;
                  real ZPR;
              )
            (| (| CA := (PA1+PA2+PA3) cell HSEC
                | PA := CA when HSEC
                | ZPA := PA$1 init 0.0
                | CR := (PR1+PR2+PR3) cell HSEC
                | PR := CR when HSEC
                | ZPR := PR$1 init 0.0
                |)/ CA, CR |)
            where 
            real CA, CR;
            end
         ; 
         process PROGRAMMATEUR =
              { integer NUMGEN1, NUMGEN2, NUMGEN3, NUMGEN4, NUMGEN5, NUMGEN6; }
              ( ? event MARCHE;
                  event ARRET;
                  event H;
                ! boolean I_CHAUFFE;
                  boolean I_TAMBOUR;
                  boolean I_POMPE;
              )
            (| (| TIMER{1600}
                | CHAUFFE_EACH{NUMGEN1,NUMGEN2}
                | TAMBOUR_EACH{NUMGEN3,NUMGEN4}
                | POMPE_EACH{NUMGEN5,NUMGEN6}
                |)/ UNIT, TIME, OPEN_ONE_RUN, ONE_RUN, I_MACHINE |)
            where 
            process TIMER =
                 { integer FIN_PROGRAMME; }
                 ( ? event MARCHE;
                     event ARRET;
                     event H;
                   ! boolean I_MACHINE;
                     boolean ONE_RUN;
                     event OPEN_ONE_RUN;
                     integer TIME;
                     event UNIT;
                 )
               (| UNIT := H default MARCHE default ARRET
                | (ONE_RUN,OPEN_ONE_RUN) := I{false}(MARCHE,RESET,UNIT)
                | I_MACHINE := I_EACH{true}(MARCHE,ARRET,UNIT,OPEN_ONE_RUN,ONE_RUN)
                | TIME := CHRONO_RESET{true}(H,MARCHE,ARRET,ONE_RUN,OPEN_ONE_RUN)
                | RESET := when (TIME=FIN_PROGRAMME)
                |)
               where 
               integer ZTIME init 0;
               event RESET;
               process CHRONO_RESET =
                    { boolean ETAT; }
                    ( ? UNIT;
                        event START;
                        event STOP;
                        ONE_RUN;
                        OPEN_ONE_RUN;
                      ! integer TIME;
                    )
                  (| RUN := I_EACH{ETAT}(START,STOP,UNIT,OPEN_ONE_RUN,ONE_RUN)
                   | TIME := COUNT_ON_EACH(UNIT,RUN,OPEN_ONE_RUN)
                   |)
                  where 
                  boolean RUN;
                  process COUNT_ON_EACH =
                       ( ? UNIT, INT_ON_EACH, OPEN_INT_EACH;
                         ! VALUE;
                       )
                     (| (| VALUE := ZVALUE+1
                         | ZVALUE := ZV_V when (^VALUE)
                         | ZV_V := ZV$1
                         | ZV := (0 when OPEN_INT_EACH) default VALUE
                         | VALUE ^= UNIT when INT_ON_EACH
                         |)/ ZVALUE, ZV |)
                     where 
                     ZV, ZVALUE, ZV_V init 0;
                     end
                  ; 
                  end
               ; 
               end
            ; 
            process I =
                 { V_0; }
                 ( ? event B, E, CLOCK;
                   ! boolean I;
                     event OPEN_I;
                 )
               (| (| (| I := I_V
                      | I_V := VAL$1
                      | VAL := NEW_VAL default I
                      | NEW_VAL := (not CLOSE_I) default OPEN_I
                      |)/ VAL, NEW_VAL
                   | OPEN_I := B when (not I)
                   | CLOSE_I := E when I
                   | I ^= B default E default CLOCK
                   |)/ CLOSE_I, I_V |)
               where 
               event CLOSE_I;
               boolean VAL, NEW_VAL, I_V init V_0;
               end
            ; 
            process I_EACH =
                 { V_0; }
                 ( ? event B, E, CLOCK, OPEN_INT_EACH;
                     boolean INT_EACH;
                   ! boolean INT;
                 )
               (| (| (| INT := I_V1
                      | (| I_V_V := (V_0 when OPEN_INT_EACH) default VAL
                         | I_V := I_V_V$1
                         | I_V1 := I_V when (^INT)
                         |)/ I_V_V, I_V
                      | VAL := NEW_VAL default INT
                      | NEW_VAL := (not CLOSE_I) default OPEN_I
                      |)/ VAL, NEW_VAL
                   | OPEN_I := B when (not INT)
                   | CLOSE_I := E when INT
                   | INT ^= (B default E default CLOCK) when INT_EACH
                   |)/ OPEN_I, CLOSE_I, I_V1 |)
               where 
               event OPEN_I, CLOSE_I;
               boolean I_V_V, VAL, NEW_VAL, I_V1, I_V init V_0;
               end
            ; 
            process TAMBOUR_EACH =
                 { integer NUMGEN1, NUMGEN2; }
                 ( ? boolean I_MACHINE;
                     boolean ONE_RUN;
                     event OPEN_ONE_RUN;
                     integer TIME;
                     event UNIT;
                   ! boolean I_TAMBOUR;
                 )
               (| DEBUT_LAVAGE := when (TIME=150)
                | (I_LAVAGE) := PROGRAMME{NUMGEN1,NUMGEN2,35,4,6,-2,2,-3,3}(DEBUT_LAVAGE,UNIT,TIME,I_MACHINE,OPEN_ONE_RUN,ONE_RUN)
                | DEBUT_RINCAGE := (when (TIME=530)) default (when (TIME=850))
                | (I_RINCAGE) := PROGRAMME{NUMGEN1,NUMGEN2,25,4,7,-2,2,-3,3}(DEBUT_RINCAGE,UNIT,TIME,I_MACHINE,OPEN_ONE_RUN,ONE_RUN)
                | DEBUT_ESSORRAGE := when (TIME=1160)
                | (I_ESSORRAGE) := PROGRAMME{NUMGEN1,NUMGEN2,6,50,5,-8,8,-2,2}(DEBUT_ESSORRAGE,UNIT,TIME,I_MACHINE,OPEN_ONE_RUN,ONE_RUN)
                | I_TAMBOUR := I_LAVAGE or I_RINCAGE or I_ESSORRAGE
                |)
               where 
               DEBUT_LAVAGE, I_LAVAGE, DEBUT_RINCAGE, I_RINCAGE, I_ESSORRAGE, DEBUT_ESSORRAGE;
               end
            ; 
            process CHAUFFE_EACH =
                 { integer NUMGEN1, NUMGEN2; }
                 ( ? boolean I_MACHINE;
                     boolean ONE_RUN;
                     event OPEN_ONE_RUN;
                     integer TIME;
                     event UNIT;
                   ! boolean I_CHAUFFE;
                 )
               (| DEBUT := when (TIME=1)
                | (I_CHAUFFE) := PROGRAMME{NUMGEN1,NUMGEN2,1,300,1,-10,10,0,0}(DEBUT,UNIT,TIME,I_MACHINE,OPEN_ONE_RUN,ONE_RUN)
                |)
               where 
               DEBUT;
               end
            ; 
            process POMPE_EACH =
                 { integer NUMGEN1, NUMGEN2; }
                 ( ? boolean I_MACHINE;
                     boolean ONE_RUN;
                     event OPEN_ONE_RUN;
                     integer TIME;
                     event UNIT;
                   ! boolean I_POMPE;
                 )
               (| DEBUT := (when (TIME=370)) default (when (TIME=500)) default (when (TIME=760)) default (when (TIME=900)) default (when (TIME=1050)) default (when (TIME=1300)) default (when (TIME=1410))
                | (I_POMPE) := PROGRAMME{NUMGEN1,NUMGEN2,2,60,2,-5,5,-1,1}(DEBUT,UNIT,TIME,I_MACHINE,OPEN_ONE_RUN,ONE_RUN)
                |)
               where 
               DEBUT;
               end
            ; 
            process PROGRAMME =
                 { integer NUMGEN1, NUMGEN2;
                   integer N, D_0, DELTA_0;
                   integer B_INF_D, B_SUP_D, B_INF_DELTA, B_SUP_DELTA; }
                 ( ? event DEBUT;
                     event UNIT;
                     integer TIME;
                     boolean I_MACHINE;
                     event OPEN_ONE_RUN;
                     boolean ONE_RUN;
                   ! boolean I_PROGRAMME;
                 )
               (| (| I_DUREE := I_EACH{false}(DEBUT,FIN,UNIT,OPEN_ONE_RUN,I_MACHINE)
                   | D := D_0+UNIFORME_INT{}(NUMGEN1,B_INF_D when START,B_SUP_D when START)
                   | DELTA := DELTA_0+UNIFORME_INT{}(NUMGEN2,B_INF_DELTA when STOP,B_SUP_DELTA when STOP)
                   | DEC_COMPTEUR := DEC_COUNT_EACH_1{N}(START,I_MACHINE,DEBUT)
                   | DEC_D := DEC_COUNT_EACH_2{}(^TIME,I_MACHINE,START,D)
                   | DEC_DELTA := DEC_COUNT_EACH_2{}(^TIME,I_MACHINE,STOP,DELTA)
                   | START := DEBUT default (when (DEC_DELTA=0))
                   | STOP := when (DEC_D=0)
                   | FIN := (when (DEC_COMPTEUR=0)) when (DEC_DELTA=0)
                   | I_PROG := I_EACH{false}(START,STOP,UNIT,OPEN_ONE_RUN,ONE_RUN)
                   | I_PROGRAMME := (((I_PROG when I_DUREE) default I_DUREE) when I_MACHINE) default I_MACHINE
                   |)/ I_DUREE, DEC_D, DEC_DELTA, DELTA, START, STOP, DEC_COMPTEUR |)
               where 
               event STOP, START;
               integer DEC_D, DEC_DELTA, DEC_COMPTEUR;
               integer D;
               integer DELTA;
               event FIN;
               integer Z_COMPEUR init N;
               integer Z_DEC_DELTA init -1;
               integer Z_DEC_D init -1;
               boolean I_DUREE, I_PROG;
               process DEC_COUNT_EACH_1 =
                    { integer N; }
                    ( ? UNIT;
                        INT_ON_EACH;
                        DEBUT;
                      ! VALUE;
                    )
                  (| (| VALUE := ZVALUE-1
                      | ZVALUE := ZV_V when (^VALUE)
                      | ZV_V := ZV$1
                      | ZV := (N when DEBUT) default VALUE
                      | VALUE ^= UNIT when INT_ON_EACH
                      |)/ ZVALUE, ZV |)
                  where 
                  ZV, ZVALUE, ZV_V init N;
                  end
               ; 
               process DEC_COUNT_EACH_2 =
                    ( ? UNIT;
                        INT_ON_EACH;
                        START;
                        integer D;
                      ! VALUE;
                    )
                  (| (| VALUE := ZVALUE-1
                      | ZVALUE := ZV_V when (^VALUE)
                      | ZV_V := ZV$1
                      | ZV := (D when START) default VALUE
                      | VALUE ^= UNIT when INT_ON_EACH
                      |)/ ZVALUE, ZV |)
                  where 
                  ZV, ZVALUE, ZV_V init 0;
                  end
               ; 
               end
            ; 
            boolean I_MACHINE, ONE_RUN;
            event OPEN_ONE_RUN, UNIT;
            integer TIME;
            end
         ; 
         real PA_1, PR_2, ZPA, ZPR, PA_5, PR_6, PA_9, PR_10, PA_13, PR_14;
         end
      ; 
      process LECTURE_FICHIER =
           { integer NUMERO_FICHIER; }
           ( ? event HSEC;
               event VON;
               event OFF;
               boolean H_0_FIN;
             ! real PA;
               real PR;
               event EV;
           )
         (| (| OUVERTURE_FERMETURE{NUMERO_FICHIER}
             | (| FILE_IN := VFILE
                | LECTURE{}
                | PA_1 := PA
                | PR_2 := PR
                | EV_3 := EV
                |) where integer FILE_IN;
                         real PA, PR;
                         event EV; end
             | (| H := HSEC
                | WATCH_RESET{}
                |) where event H; end
             | (| DELTA_PR1 := DELTA_PR
                | DELTA_PA1 := DELTA_PA
                | NEXT_PR1 := NEXT_PR
                | NEXT_PA1 := NEXT_PA
                | PR1 := PR_2
                | PA1 := PA_1
                | PUISSANCE_EACH{}
                |) where real PA1, PR1, NEXT_PA1, NEXT_PR1, DELTA_PA1, DELTA_PR1; end
             | (| EV1 := EV_3
                | (| EV := EV1 |)
                |) where event EV1; end
             |)/ SEC, MIN, HEURE, EV_3, NEXT_SEC, NEXT_MIN, NEXT_HEURE, DELTA_PR, DELTA_PA, NEXT_PR, NEXT_PA, PR_2, PA_1, VFILE |)
         where 
         event H_FILE_READ, H_FILE_CLOSE, HA, HR, EV_3;
         integer FILE1, CFILE, CFILE2;
         real ZPR1 init 0.0e0;
         real ZPA1 init 0.0e0, PA_1, PR_2, NEXT_PA, NEXT_PR, DELTA_PA, DELTA_PR;
         integer Z_SEC_LUE init 0;
         integer Z_MIN_LUE init 0;
         integer Z_HEURE_LUE init 0;
         integer Z_ADRESSE_FICHIER init 0, VFILE, NEXT_HEURE, NEXT_MIN, NEXT_SEC, HEURE, MIN, SEC;
         process WATCH_RESET =
              ( ? event H;
                  event VON;
                  event OFF;
                ! integer HEURE;
                  integer MIN;
                  integer SEC;
              )
            (| (| UNIT := H default VON default OFF
                | UNIT ^= L
                | L := VON default (not OFF) default ZL
                | ZL := L$1
                | HSEC := when L
                | SEC1 := COMPTEUR_MODULO{60}(HSEC)
                | HMIN := DYN_EVERY{0,60,60}(0 when HSEC,60 when HSEC,HSEC)
                | MIN1 := COMPTEUR_MODULO{60}(HMIN)
                | HHEURE := DYN_EVERY{0,60,60}(0 when HMIN,60 when HMIN,HMIN)
                | HEURE1 := COMPTEUR_MODULO{10000}(HHEURE)
                | H_SEC := ^SEC1
                | SEC := SEC1
                | CHEURE := HEURE1 cell H_SEC
                | CMIN := MIN1 cell H_SEC
                | HEURE := CHEURE when H_SEC
                | MIN := CMIN when H_SEC
                |)/ HMIN, HHEURE |)
            where 
            boolean L, ZL init false;
            integer Z_MIN init 0;
            integer Z_HEURE init 0;
            integer ZTIME init 0;
            OPEN_ONE_RUN, ONE_RUN;
            integer TIME, CMIN, CHEURE, MIN1, HEURE1, SEC1;
            event HSEC, UNIT, H_SEC, HMIN, HHEURE;
            process COMPTEUR_MODULO =
                 { integer N; }
                 ( ? UNIT;
                   ! VALUE;
                 )
               (| (| UNIT ^= VALUE
                   | VALUE := (0 when (ZVALUE=(N-1))) default (ZVALUE+1)
                   | ZVALUE := VALUE$1
                   |)/ ZVALUE |)
               where 
               integer ZVALUE init -1;
               end
            ; 
            end
         ; 
         process OUVERTURE_FERMETURE =
              { integer NUMERO_FICHIER; }
              ( ? boolean H_0_FIN;
                ! integer VFILE;
              )
            (| VFILE := OPEN_FILE_READ{}(NUMERO_FICHIER when H_0_FIN)
             | H_FILE_CLOSE := when (not H_0_FIN)
             | CFILE2 := VFILE cell H_FILE_CLOSE
             | FILE2 := CFILE2 when H_FILE_CLOSE
             | CLOSE_FILE{}(FILE2 when (not H_0_FIN))
             |)
            where 
            event H_FILE_READ, H_FILE_CLOSE;
            integer FILE1, CFILE, CFILE2, FILE2;
%              process CLOSE_FILE =
                 ( ? integer ADRESSE;
                 )
            
            ;  %

            process OPEN_FILE_READ =
                 ( ? integer NUMER0;
                   ! integer ADRESSE;
                 )
                 spec (| NUMER0 ^= ADRESSE |)
            
            ; 
            end
         ; 
         process LECTURE =
              ( ? integer FILE_IN;
                  integer HEURE;
                  integer MIN;
                  integer SEC;
                  event HSEC;
                  boolean H_0_FIN;
                ! real PA;
                  real PR;
                  real NEXT_PA;
                  real NEXT_PR;
                  real DELTA_PA;
                  real DELTA_PR;
                  integer NEXT_HEURE;
                  integer NEXT_MIN;
                  integer NEXT_SEC;
                  event EV;
              )
            (| (| FILE1 := FILE_IN
                | (| XFILE ^= (^FILE1) default VON default (when H_OK)
                   | XFILE := FILE1 default ZFILE
                   | ZFILE := XFILE$1
                   | VON := when ((HEURE=0) and (MIN=0) and (SEC=0))
                   | (EOF0,HEURE0_LUE,MIN0_LUE,SEC0_LUE,DELTA_PA0,DELTA_PR0,PA0_LUE,PR0_LUE) := READ_FILE(XFILE when H_0_FIN)
                   | (EOF1,HEURE1_LUE,MIN1_LUE,SEC1_LUE,DELTA_PA,DELTA_PR,PA1_LUE,PR1_LUE) := READ_FILE(XFILE when H_OK)
                   | H0 := (when H_0_FIN) default VON
                   | CHEURE0 := HEURE0_LUE cell H0
                   | HEURE0 := CHEURE0 when VON
                   | HEURE_LUE := HEURE0 default HEURE1_LUE default Z_HEURE_LUE
                   | Z_HEURE_LUE := HEURE_LUE$1
                   | CMIN0 := MIN0_LUE cell H0
                   | MIN0 := CMIN0 when VON
                   | MIN_LUE := MIN0 default MIN1_LUE default Z_MIN_LUE
                   | Z_MIN_LUE := MIN_LUE$1
                   | CSEC0 := SEC0_LUE cell H0
                   | SEC0 := CSEC0 when VON
                   | SEC_LUE := SEC0 default SEC1_LUE default Z_SEC_LUE
                   | Z_SEC_LUE := SEC_LUE$1
                   | H_OK := (HEURE=Z_HEURE_LUE) and (MIN=Z_MIN_LUE) and (SEC=Z_SEC_LUE)
                   | PA_LUE := PA0_LUE default PA1_LUE
                   | PR_LUE := PR0_LUE default PR1_LUE
                   | Z_PA_LUE := PA_LUE$1
                   | Z_PR_LUE := PR_LUE$1
                   | PA := Z_PA_LUE when H_OK
                   | PR := Z_PR_LUE when H_OK
                   | NEXT_PA := PA_LUE when H_OK
                   | NEXT_PR := PR_LUE when H_OK
                   | EV := when H_OK
                   |)
                | NEXT_HEURE := HEURE1_LUE
                | NEXT_MIN := MIN1_LUE
                | NEXT_SEC := SEC1_LUE
                |) where integer FILE1, HEURE1_LUE, MIN1_LUE, SEC1_LUE; end |)
            where 
            boolean EOF0, EOF1;
            real Z_PR_LUE init 0.0e0;
            real Z_PA_LUE init 0.0e0;
            integer Z_SEC_LUE init -1;
            integer Z_MIN_LUE init -1;
            integer Z_HEURE_LUE init -1;
            integer XFILE;
            integer ZFILE init 0;
            real CA, CR;
            CSEC0, CMIN0, CHEURE0, H_OK, PR_LUE, PA_LUE, PA1_LUE, SEC_LUE, SEC0, H0, MIN_LUE, MIN0, HEURE_LUE, HEURE0, HEURE0_LUE, DELTA_PA0, DELTA_PR0;
            PR1_LUE, MIN0_LUE, SEC0_LUE;
            PA0_LUE, PR0_LUE;
            VON;
            process READ_FILE =
                 ( ? integer ADRESSE;
                   ! boolean EOF;
                     integer HEURE;
                     integer MIN;
                     integer SEC;
                     real DELTA_PA;
                     real DELTA_PR;
                     real PA;
                     real PR;
                 )
                 spec (| ADRESSE ^= EOF ^= HEURE ^= MIN ^= SEC ^= DELTA_PA ^= DELTA_PR ^= PA ^= PR |)
            
            ; 
            end
         ; 
         process PUISSANCE_EACH =
              ( ? real PA1;
                  real PR1;
                  real NEXT_PA1;
                  real NEXT_PR1;
                  real DELTA_PA1;
                  real DELTA_PR1;
                  integer NEXT_HEURE;
                  integer NEXT_MIN;
                  integer NEXT_SEC;
                  integer HEURE;
                  integer MIN;
                  integer SEC;
                  event VON;
                  event OFF;
                ! real PA;
                  real PR;
              )
            (| (| HA := ^PA
                | CA := (PA_COURANTE default (0.0 when OFF)) cell HA
                | PA := CA when HA
                | HR := ^PR
                | CR := (PR_COURANTE default (0.0 when OFF)) cell HR
                | PR := CR when HR
                | X := real(SEC+(60*(MIN+(60*HEURE))))
                | X1 := (X when (^PA1)) default Z_X1
                | Z_X1 := X1$1
                | X2 := real(NEXT_SEC+(60*(NEXT_MIN+(60*NEXT_HEURE)))) default Z_X2
                | Z_X2 := X2$1
                | YA1 := PA1
                | YA2 := NEXT_PA1-DELTA_PA1
                | PA_COURANTE := (A1*X)+B1
                | A1 := ((YA1-YA2)/(X1-X2)) default Z_A1
                | Z_A1 := A1$1
                | B1 := (((X1*YA2)-(X2*YA1))/(X1-X2)) default Z_B1
                | Z_B1 := B1$1
                | YR1 := PR1
                | YR2 := NEXT_PR1-DELTA_PR1
                | PR_COURANTE := (A2*X)+B2
                | A2 := ((YR1-YR2)/(X1-X2)) default Z_A2
                | Z_A2 := A2$1
                | B2 := (((X1*YR2)-(X2*YR1))/(X1-X2)) default Z_B2
                | Z_B2 := B2$1
                | TOTO := VON
                |)/ TOTO |)
            where 
            event TOTO;
            event HA, HR;
            real Z_B2 init 0.0e0;
            real Z_A2 init 0.0e0;
            real Z_B1 init 0.0e0;
            real Z_A1 init 0.0e0;
            real Z_X2 init 0.0e0;
            real Z_X1 init 0.0e0;
            X, X1, X2, CA, CR, B2, YR2, YR1, A2, PR_COURANTE, B1, YA2, YA1, A1, PA_COURANTE;
            end
         ; 
         end
      ; 
      process ECRIRE_FICHIER =
           { integer NUMERO_FICHIER; }
           ( ? real PA1;
               real PR1;
               real ZPA1;
               real ZPR1;
               event VON;
               event OFF;
               event HSEC;
               boolean H_0_FIN;
           )
         (| CA := PA1 cell EVENEMENT
          | PA := CA when EVENEMENT
          | CR := PR1 cell EVENEMENT
          | PR := CR when EVENEMENT
          | ZCA := ZPA1 cell EVENEMENT
          | ZPA := ZCA when EVENEMENT
          | ZCR := ZPR1 cell EVENEMENT
          | ZPR := ZCR when EVENEMENT
          | EVENEMENT := VON default OFF
          | ADRESSE_FICHIER := OPEN_FILE_WRITE{}(NUMERO_FICHIER when H_0_FIN) default Z_ADRESSE_FICHIER
          | Z_ADRESSE_FICHIER := ADRESSE_FICHIER$1
          | ADRESSE_FICHIER ^= EVENEMENT default H_0_FIN
          | WRITE_FILE{}(ADRESSE_FICHIER when EVENEMENT,HEURE,MIN,SEC,PA-ZPA,PR-ZPR,PA,PR)
          | CLOSE_FILE{}(ADRESSE_FICHIER when (not H_0_FIN))
          | (HEURE,MIN,SEC) := WATCH{}(HSEC)
          | EVENEMENT ^= HEURE ^= MIN ^= SEC
          |)
         where 
         real CR init 0.0;
         real CA init 0.0;
         real ZCR init 0.0;
         real ZCA init 0.0;
         integer Z_ADRESSE_FICHIER init 0;
         HEURE, MIN, SEC, ZPA, ZPR, EVENEMENT, ADRESSE_FICHIER;
         PA, PR;
         end
      ; 
      process CONVECTEUR =
           { integer NG1, NG2, NG3, NG4, NUMERO_FICHIER, D_INF, D_SUP, DELTA_INF, DELTA_SUP;
             real MEAN1, MEAN2, VAR1, VAR2, COV12;
             real MEAN3, MEAN4, VAR3, VAR4, COV34; }
           ( ? event HSEC;
               event VON;
               event OFF;
               boolean H_0_FIN;
             ! real PA;
               real PR;
               event EV;
           )
         (| (| (| DUREE := D
                | OFF := OFF2
                | VON := ON2
                | PUISSANCE_INSTANTANEE{}
                |) where event VON, OFF;
                         integer DUREE; end
             | (| OFF := OFF2
                | VON := ON2
                | (| (PA_ON,PR_ON) := GAUSS2D{}(NG1,MEAN1 when VON,MEAN2 when VON,VAR1 when VON,VAR2 when VON,COV12 when VON)
                   | (PA_OFF,PR_OFF) := GAUSS2D{}(NG2,MEAN3 when VON,MEAN4 when VON,VAR3 when VON,VAR4 when VON,COV34 when VON)
                   |)
                |) where event VON, OFF; end
             | WATCH{}
             | (| OFF_I := OFF
                | ON_I := VON
                | H := HSEC
                | ALEA_LOCAL{NG3,NG4,D_INF,D_SUP,DELTA_INF,DELTA_SUP}
                |) where event H, ON_I, OFF_I; end
             | (| HA := ^PA
                | CA := PA1 cell HA
                | PA := CA when HA
                | HR := ^PR
                | CR := PR1 cell HR
                | PR := CR when HR
                |)
             | (| OFF := OFF2
                | VON := ON2
                | ECRIRE_FICHIER{NUMERO_FICHIER}
                |) where event VON, OFF; end
             | (| OFF1 := OFF2
                | ON1 := ON2
                | EV := ON1 default OFF1
                |) where event ON1, OFF1; end
             |)/ D, OFF2, ON2, SEC, MIN, HEURE, PR_OFF, PA_OFF, PR_ON, PA_ON, ZPR1, ZPA1, PR1, PA1 |)
         where 
         real CA, CR, PA1, PR1, ZPA1, ZPR1, PA_ON, PR_ON, PA_OFF, PR_OFF;
         event HA, HR, ON2, OFF2;
         process PUISSANCE_INSTANTANEE =
              ( ? real PA_ON;
                  real PR_ON;
                  real PA_OFF;
                  real PR_OFF;
                  event VON;
                  event OFF;
                  integer DUREE;
                  integer HEURE;
                  integer MIN;
                  integer SEC;
                  event HSEC;
                ! real PA1;
                  real PR1;
                  real ZPA1;
                  real ZPR1;
              )
            (| X := real(SEC+(60*(MIN+(60*HEURE)))) default Z_X
             | Z_X := X$1
             | X ^= HSEC default VON default OFF
             | X1 := X when VON
             | X2 := (X1+real(DUREE)) when VON
             | YA1 := PA_ON
             | YA2 := PA_OFF
             | A1 := ((YA1-YA2)/(X1-X2)) default (0.0e0 when OFF) default Z_A1
             | Z_A1 := A1$1
             | B1 := (((X1*YA2)-(X2*YA1))/(X1-X2)) default (0.0e0 when OFF) default Z_B1
             | Z_B1 := B1$1
             | PA1 := SUP{}((A1*X)+B1,0.0)
             | ZPA1 := PA1$1 init 0.0
             | YR1 := PR_ON
             | YR2 := PR_OFF
             | A2 := ((YR1-YR2)/(X1-X2)) default (0.0e0 when OFF) default Z_A2
             | Z_A2 := A2$1
             | B2 := (((X1*YR2)-(X2*YR1))/(X1-X2)) default (0.0e0 when OFF) default Z_B2
             | Z_B2 := B2$1
             | PR1 := SUP{}((A2*X)+B2,0.0)
             | ZPR1 := PR1$1 init 0.0
             | HEURE ^= MIN ^= SEC ^= HSEC
             |)
            where 
            real A1;
            real YA1;
            real YA2;
            real B1;
            real A2;
            real YR1;
            real YR2;
            real B2;
            real X, X2, X1;
            real Z_B2 init 0.0e0;
            real Z_A2 init 0.0e0;
            real Z_B1 init 0.0e0;
            real Z_A1 init 0.0e0;
            real Z_X2 init 0.0e0;
            real Z_X1 init 0.0e0;
            real Z_X init 0.0e0;
            process SUP =
                 ( ? real A;
                     real B;
                   ! real X;
                 )
               (| A ^= B ^= X
                | X := (A when (A>B)) default B
                |)
            ; 
            end
         ; 
         process ALEA_LOCAL =
              { integer NUMGEN1, NUMGEN2;
                integer D_INF, D_SUP;
                integer DELTA_INF, DELTA_SUP; }
              ( ? event H;
                  event ON_I;
                  event OFF_I;
                ! event ON2;
                  event OFF2;
                  integer D;
              )
            (| (RUN,OPEN) := I{false}(ON_I,OFF_I,H)
             | D := UNIFORME_INT{}(NUMGEN1,D_INF when ON2,D_SUP when ON2)
             | DELTA := UNIFORME_INT{}(NUMGEN2,DELTA_INF when OFF2,DELTA_SUP when OFF2)
             | DEC_D := DEC_COUNT_EACH{}(H,RUN,ON2,ON_I,D)
             | DEC_DELTA := DEC_COUNT_EACH{}(H,RUN,OFF2,ON_I,DELTA)
             | OFF2 := (when (DEC_D=0)) default OFF_I
             | ON2 := ON_I default (when (DEC_DELTA=0))
             |)
            where 
            OPEN, DELTA, RUN, DEC_DELTA, DEC_D;
            process I =
                 { V_0; }
                 ( ? event B, E, CLOCK;
                   ! boolean I;
                     event OPEN_I;
                 )
               (| (| (| I := I_V
                      | I_V := VAL$1
                      | VAL := NEW_VAL default I
                      | NEW_VAL := (not CLOSE_I) default OPEN_I
                      |)/ VAL, NEW_VAL
                   | OPEN_I := B when (not I)
                   | CLOSE_I := E when I
                   | I ^= B default E default CLOCK
                   |)/ CLOSE_I, I_V |)
               where 
               event CLOSE_I;
               boolean VAL, NEW_VAL, I_V init V_0;
               end
            ; 
            process I_EACH =
                 { V_0; }
                 ( ? event B, E, CLOCK, OPEN_INT_EACH;
                     boolean INT_EACH;
                   ! boolean INT;
                 )
               (| (| (| INT := I_V1
                      | (| I_V_V := (V_0 when OPEN_INT_EACH) default VAL
                         | I_V := I_V_V$1
                         | I_V1 := I_V when (^INT)
                         |)/ I_V_V, I_V
                      | VAL := NEW_VAL default INT
                      | NEW_VAL := (not CLOSE_I) default OPEN_I
                      |)/ VAL, NEW_VAL
                   | OPEN_I := B when (not INT)
                   | CLOSE_I := E when INT
                   | INT ^= (B default E default CLOCK) when INT_EACH
                   |)/ OPEN_I, CLOSE_I, I_V1 |)
               where 
               event OPEN_I, CLOSE_I;
               boolean I_V_V, VAL, NEW_VAL, I_V1, I_V init V_0;
               end
            ; 
            process DEC_COUNT_EACH =
                 ( ? UNIT, INT_ON_EACH, START;
                     event VON;
                     integer DUREE;
                   ! VALUE;
                 )
               (| (| VALUE := ZVALUE-1
                   | ZVALUE := ZV_V when (^VALUE)
                   | ZV_V := ZV$1
                   | ZV := (DUREE when START) default ((-1) when VON) default VALUE
                   | VALUE ^= UNIT when (^INT_ON_EACH)
                   |)/ ZVALUE, ZV |)
               where 
               ZV, ZVALUE, ZV_V init 0;
               end
            ; 
            end
         ; 
         integer HEURE, MIN, SEC, D;
         end
      ; 
      real PA_1, PR_2, PA_4, PR_5, PA_7, PR_8, PA_10, PR_11, PA_13, PR_14, PA_16, PR_17, PA_19, PR_20, PA_22, PR_23, PA_25, PR_26, PA_28, PR_29, PA_31, PR_32, PA_34, PR_35, PA_37, PR_38;
      event EV_3, EV_6, EV_9, EV_12, EV_15, EV_18, EV_21, EV_24, EV_27, EV_30, EV_33, EV_36, EV_39;
      end
   ; 
   process CONTEXT =
        { integer N, NUL_CODE, LIN_CODE;
          boolean PAR_DEFAUT;
          integer SEED1, SEED2; }
        ( ? event HE;
          ! boolean H_0_FIN;
            event HSCAN;
            event HSEC;
            event ON1;
            event OFF1;
            event ON2;
            event OFF2;
            event MARCHE;
            event ARRET;
            event ON4;
            event OFF4;
            event ON5;
            event OFF5;
            event ON6;
            event OFF6;
            event ON7;
            event OFF7;
            event ON31;
            event OFF31;
            event ON32;
            event OFF32;
            event ON33;
            event OFF33;
            event ON34;
            event OFF34;
            event ON35;
            event OFF35;
            event ON36;
            event OFF36;
        )
      (| (| S_PACE_MAKER{NUL_CODE,LIN_CODE}
          | (| HE := HES
             | ECHANTILLONNAGE{}
             | HSCAN := HE_DIV_1
             |) where event HE_DIV_1, HE; end/ HE_DIV_3
                                             / HE_DIV_10
                                             / HE_DIV_100
          | (| (| H := HSCAN
                | SCAN{N}
                | ON2_1 := ON2
                | OFF2_2 := OFF2
                |) where event H, ON2, OFF2; end
             | (| OFF := OFF2_2
                | VON := ON2_1
                | H := HSEC
                | ALEA{32}
                |) where event H, VON, OFF; end
             |)/ OFF2_2, ON2_1
          | (| H_0_FIN := H_0 default (not STOP) |)
          | HSEC := HSCAN
          | INITGEN{PAR_DEFAUT,SEED1,SEED2}
          |)/ STOP, H_0, HES |)
      where 
      process SCAN =
           { integer N; }
           ( ? event H;
             ! event ON1;
               event OFF1;
               event ON2;
               event OFF2;
               event MARCHE;
               event ARRET;
               event ON4;
               event OFF4;
               event ON5;
               event OFF5;
               event ON6;
               event OFF6;
               event ON7;
               event OFF7;
               event ON31;
               event OFF31;
               event ON32;
               event OFF32;
               event ON33;
               event OFF33;
               event ON34;
               event OFF34;
               event ON35;
               event OFF35;
               event ON36;
               event OFF36;
           )
         (| ON1 := GETSIG{}(H,R_ON1())
          | OFF1 := GETSIG{}(H,R_OFF1())
          | ON2 := GETSIG{}(H,R_ON2())
          | OFF2 := GETSIG{}(H,R_OFF2())
          | MARCHE := GETSIG{}(H,R_MARCHE())
          | ARRET := GETSIG{}(H,R_ARRET())
          | ON4 := GETSIG{}(H,R_ON4())
          | OFF4 := GETSIG{}(H,R_OFF4())
          | ON5 := GETSIG{}(H,R_ON5())
          | OFF5 := GETSIG{}(H,R_OFF5())
          | ON6 := GETSIG{}(H,R_ON6())
          | OFF6 := GETSIG{}(H,R_OFF6())
          | ON7 := GETSIG{}(H,R_ON7())
          | OFF7 := GETSIG{}(H,R_OFF7())
          | ON31 := GETSIG{}(H,R_ON31())
          | OFF31 := GETSIG{}(H,R_OFF31())
          | ON32 := GETSIG{}(H,R_ON32())
          | OFF32 := GETSIG{}(H,R_OFF32())
          | ON33 := GETSIG{}(H,R_ON33())
          | OFF33 := GETSIG{}(H,R_OFF33())
          | ON34 := GETSIG{}(H,R_ON34())
          | OFF34 := GETSIG{}(H,R_OFF34())
          | ON35 := GETSIG{}(H,R_ON35())
          | OFF35 := GETSIG{}(H,R_OFF35())
          | ON36 := GETSIG{}(H,R_ON36())
          | OFF36 := GETSIG{}(H,R_OFF36())
          |)
         where 
         process GETSIG =
              ( ? event H;
                  boolean C_ON;
                ! event VON;
              )
            (| H ^= C_ON
             | VON := when C_ON
             |)
         ; 
         process R_ON1 =
              ( ! boolean ON1;
              )
         
         ; 
         process R_OFF1 =
              ( ! boolean OFF1;
              )
         
         ; 
         process R_ON2 =
              ( ! boolean ON2;
              )
         
         ; 
         process R_OFF2 =
              ( ! boolean OFF2;
              )
         
         ; 
         process R_ARRET =
              ( ! boolean ARRET;
              )
         
         ; 
         process R_ON31 =
              ( ! boolean ON31;
              )
         
         ; 
         process R_ON32 =
              ( ! boolean ON32;
              )
         
         ; 
         process R_OFF31 =
              ( ! boolean OFF31;
              )
         
         ; 
         process R_OFF32 =
              ( ! boolean OFF32;
              )
         
         ; 
         process R_ON4 =
              ( ! boolean ON4;
              )
         
         ; 
         process R_ON5 =
              ( ! boolean ON5;
              )
         
         ; 
         process R_ON6 =
              ( ! boolean ON6;
              )
         
         ; 
         process R_MARCHE =
              ( ! boolean MARCHE;
              )
         
         ; 
         process R_ON7 =
              ( ! boolean ON7;
              )
         
         ; 
         process R_OFF4 =
              ( ! boolean OFF4;
              )
         
         ; 
         process R_OFF5 =
              ( ! boolean OFF5;
              )
         
         ; 
         process R_OFF6 =
              ( ! boolean OFF6;
              )
         
         ; 
         process R_OFF7 =
              ( ! boolean OFF7;
              )
         
         ; 
         process R_ON33 =
              ( ! boolean ON33;
              )
         
         ; 
         process R_ON34 =
              ( ! boolean ON34;
              )
         
         ; 
         process R_ON35 =
              ( ! boolean ON35;
              )
         
         ; 
         process R_ON36 =
              ( ! boolean ON36;
              )
         
         ; 
         process R_OFF33 =
              ( ! boolean OFF33;
              )
         
         ; 
         process R_OFF34 =
              ( ! boolean OFF34;
              )
         
         ; 
         process R_OFF35 =
              ( ! boolean OFF35;
              )
         
         ; 
         process R_OFF36 =
              ( ! boolean OFF36;
              )
         
         ; 
         end
      ; 
      process S_PACE_MAKER =
           { integer NUL_CODE, LIN_CODE; }
           ( ? event HE;
             ! event HES;
               event H_0;
               event STOP;
           )
         (| (| (| HE := HS_2
                | PACE_MAKER{}
                | HS_1 := HS
                |) where event HS, HE; end
             | (| HSP := HS_1
                | HS := HSP default TICK
                | HES := HS
                |) where event HS, HSP; end
             | (| SCAN{NUL_CODE,LIN_CODE}
                | HS_2 := HS
                |) where event HS; end
             | (| HW := ^NEW_BOUND
                | WIWRITE_SIG(ADR_COUNT when HW,NEW_BOUND)
                |)/ HW
             |)/ TICK, HS_2, C_UP_DOWN, C_LIN_EXP, PI_0, ADR_COUNT, HS_1, NEW_BOUND |)
         where 
         process SCAN =
              { integer NUL_CODE, LIN_CODE; }
              ( ? event HE;
                ! integer PI_0;
                  event H_0;
                  event STOP;
                  integer ADR_COUNT;
                  event TICK;
                  event HS;
                  boolean C_LIN_EXP;
                  boolean C_UP_DOWN;
              )
            (| (| PERIOD_INPUT{NUL_CODE,LIN_CODE}
                | (| HINIT := H_0
                   | MODE_INPUT{}
                   |) where event HINIT; end
                | RESET_PANEL{}
                | (| HSTOP := STOP
                   | WSTOP_SIG(HSTOP)
                   |) where event HSTOP; end
                | INIT_PACE{}
                |)/ AUTO |)
            where 
            process MODE_INPUT =
                 ( ? event HE;
                     event HINIT;
                   ! event TICK;
                     boolean AUTO;
                     event HS;
                     event STOP;
                 )
               (| (| (| (| C_SW_AUTO ^= HE
                         | C_SW_AUTO := RAUTO{}()
                         | NEXTAUTO ^= HINIT default (when C_SW_AUTO)
                         | NEXTAUTO := not ZAUTO
                         | ZAUTO := NEXTAUTO$1
                         | AUTOMOD := NEXTAUTO cell HE
                         | HS := HE when AUTOMOD
                         |)
                      | AUTO := NEXTAUTO
                      |) where boolean NEXTAUTO; end/ C_SW_AUTO
                                             / ZAUTO
                   | (| C_STOP ^= when (not AUTOMOD)
                      | C_STOP := RSTOP{}()
                      | STOP := when C_STOP
                      |)/ C_STOP
                   | (| C_TICK ^= HE
                      | C_TICK := RTICK{}()
                      | TICK := when C_TICK
                      |)/ C_TICK
                   |)/ AUTOMOD |)
               where 
               process RAUTO =
                    ( ! boolean AUTO;
                    )
               
               ; 
               process RTICK =
                    ( ! boolean TICK;
                    )
               
               ; 
               process RSTOP =
                    ( ! boolean STOP;
                    )
               
               ; 
               boolean C_SW_AUTO, ZAUTO init true, AUTOMOD init true, C_STOP, C_TICK;
               end
            ; 
            process RESET_PANEL =
                 ( ? boolean AUTO;
                 )
            
            ; 
            process WSTOP_SIG =
                 ( ? event DOWN;
                 )
            
            ; 
            process INIT_PACE =
                 ( ? event HE;
                   ! event H_0;
                     integer PI_0;
                     integer ADR_COUNT;
                 )
               (| CINIT := NCINIT$1
                | NCINIT := not HE
                | H_0 := when CINIT
                | DESCR ^= H_0
                | GET_PACE_RHYTHM_SIG{}()
                | ADR_COUNT := DESCR cell HE
                |)
               where 
               integer DESCR;
               boolean CINIT init true, NCINIT;
               process GET_PACE_RHYTHM_SIG =
                    ( ! integer DESCR;
                        integer PI_0;
                    )
                    spec (| DESCR ^= PI_0 |)
               
               ; 
               end
            ; 
            boolean AUTO;
            end
         ; 
         integer NEW_BOUND, ADR_COUNT, PI_0;
         event HS_1, HS, HS_2, TICK, HW;
         boolean C_LIN_EXP, C_UP_DOWN;
         end
      ; 
      process PACE_MAKER =
           ( ? boolean C_UP_DOWN;
               boolean C_LIN_EXP;
               integer PI_0;
               event HE;
             ! integer NEW_BOUND;
               event HS;
           )
         (| HS := DYN_EVERY{0,1,1}(0 when HE,NEW_BOUND,HE)
          | SET_BOUND{}
          |)
         where 
         process SET_BOUND =
              ( ? boolean C_UP_DOWN;
                  boolean C_LIN_EXP;
                  integer PI_0;
                ! integer NEW_BOUND;
              )
            (| (| (| NEW_LIN := NEW_BOUND_2
                   | NEW_EXP := NEW_BOUND_1
                   | (| NEW_BOUND ^= (^C_LIN_EXP) default (^PI_0)
                      | NEW_BOUND := PI_0 default NEW_LIN default NEW_EXP default OLD_BOUND
                      |)
                   |) where integer NEW_EXP, NEW_LIN; end
                | OLD_BOUND := NEW_BOUND$1
                | (| EXPONENTIAL{}(C_UP_DOWN when (not C_LIN_EXP),OLD_BOUND when (not C_LIN_EXP))
                   | NEW_BOUND_1 := NEW_BOUND
                   |) where integer NEW_BOUND; end
                | (| LINEAR{}(C_UP_DOWN when C_LIN_EXP,OLD_BOUND when C_LIN_EXP)
                   | NEW_BOUND_2 := NEW_BOUND
                   |) where integer NEW_BOUND; end
                |)/ NEW_BOUND_2, NEW_BOUND_1, OLD_BOUND |)
            where 
            process EXPONENTIAL =
                 ( ? boolean C_UP_DOWN;
                     integer OLD_BOUND;
                   ! integer NEW_BOUND;
                 )
               (| VD := (OLD_BOUND+OLD_BOUND) when (not C_UP_DOWN)
                | VU := (OLD_BOUND/2) when (OLD_BOUND>1) when C_UP_DOWN
                | NEW_BOUND := VU default (VD when (VD>0))
                |)
               where 
               integer VD, VU;
               end
            ; 
            process LINEAR =
                 ( ? boolean C_UP_DOWN;
                     integer OLD_BOUND;
                   ! integer NEW_BOUND;
                 )
               (| DELTA := ((OLD_BOUND/16) when (OLD_BOUND>=16)) default (1 when (^OLD_BOUND))
                | VD := (OLD_BOUND+DELTA) when (not C_UP_DOWN)
                | VU := (OLD_BOUND-DELTA) when (OLD_BOUND>1) when C_UP_DOWN
                | NEW_BOUND := VU default (VD when (VD>0))
                |)
               where 
               integer DELTA, VD, VU;
               end
            ; 
            integer OLD_BOUND init 1, NEW_BOUND_1, NEW_BOUND_2;
            end
         ; 
         end
      ; 
      process PERIOD_INPUT =
           { integer NUL_CODE, LIN_CODE; }
           ( ? event HE;
               integer ADR_COUNT;
             ! boolean C_UP_DOWN;
               boolean C_LIN_EXP;
           )
         (| CODE_CHANGE := RCHANGE_SIG{}(ADR_COUNT when HE)
          | C_LIN_EXP := (CODE_CHANGE=LIN_CODE) when (CODE_CHANGE/=NUL_CODE)
          | C_UP_DOWN := RUPDOWN_SIG{}(ADR_COUNT when (^C_LIN_EXP))
          |)
         where 
         integer CODE_CHANGE;
         process RUPDOWN_SIG =
              ( ? integer ADRCOUNT;
                ! boolean UPDOWN;
              )
              spec (| ADRCOUNT ^= UPDOWN |)
         
         ; 
         process RCHANGE_SIG =
              ( ? integer ADRCOUNT;
                ! integer CODE;
              )
              spec (| ADRCOUNT ^= CODE |)
         
         ; 
         end
      ; 
      process WIWRITE_SIG =
           ( ? integer ADR_COUNT;
               integer V;
           )
           spec (| ADR_COUNT ^= V |)
      
      ; 
      process ALEA =
           { integer NUMGEN; }
           ( ? event H;
               event VON;
               event OFF;
             ! event ON2;
               event OFF2;
           )
         (| (| (RUN,OPEN) := I{false}(VON,OFF,H)
             | D := UNIFORME_INT{}(NUMGEN,40 when ON2,200 when ON2)
             | DELTA := UNIFORME_INT{}(NUMGEN,10 when OFF2,400 when OFF2)
             | DEC_D := DEC_COUNT_EACH{}(H,RUN,ON2,VON,D)
             | DEC_DELTA := DEC_COUNT_EACH{}(H,RUN,OFF2,VON,DELTA)
             | OFF2 := (when (DEC_D=0)) default OFF
             | ON2 := VON default (when (DEC_DELTA=0))
             |)/ OPEN, DELTA, RUN, D, DEC_D, DEC_DELTA |)
         where 
         OPEN, DELTA, RUN, D, DEC_DELTA, DEC_D;
         process I =
              { V_0; }
              ( ? event B, E, CLOCK;
                ! boolean I;
                  event OPEN_I;
              )
            (| (| (| I := I_V
                   | I_V := VAL$1
                   | VAL := NEW_VAL default I
                   | NEW_VAL := (not CLOSE_I) default OPEN_I
                   |)/ VAL, NEW_VAL
                | OPEN_I := B when (not I)
                | CLOSE_I := E when I
                | I ^= B default E default CLOCK
                |)/ CLOSE_I, I_V |)
            where 
            event CLOSE_I;
            boolean VAL, NEW_VAL, I_V init V_0;
            end
         ; 
         process I_EACH =
              { V_0; }
              ( ? event B, E, CLOCK, OPEN_INT_EACH;
                  boolean INT_EACH;
                ! boolean INT;
              )
            (| (| (| INT := I_V1
                   | (| I_V_V := (V_0 when OPEN_INT_EACH) default VAL
                      | I_V := I_V_V$1
                      | I_V1 := I_V when (^INT)
                      |)/ I_V_V, I_V
                   | VAL := NEW_VAL default INT
                   | NEW_VAL := (not CLOSE_I) default OPEN_I
                   |)/ VAL, NEW_VAL
                | OPEN_I := B when (not INT)
                | CLOSE_I := E when INT
                | INT ^= (B default E default CLOCK) when INT_EACH
                |)/ OPEN_I, CLOSE_I, I_V1 |)
            where 
            event OPEN_I, CLOSE_I;
            boolean I_V_V, VAL, NEW_VAL, I_V1, I_V init V_0;
            end
         ; 
         process DEC_COUNT_EACH =
              ( ? UNIT, INT_ON_EACH, START;
                  event VON;
                  integer DUREE;
                ! VALUE;
              )
            (| (| VALUE := ZVALUE-1
                | ZVALUE := ZV_V when (^VALUE)
                | ZV_V := ZV$1
                | ZV := (DUREE when START) default ((-1) when VON) default VALUE
                | VALUE ^= UNIT when INT_ON_EACH
                |)/ ZVALUE, ZV |)
            where 
            ZV, ZVALUE, ZV_V init 0;
            end
         ; 
         end
      ; 
      process ECHANTILLONNAGE =
           ( ? event HE;
             ! event HE_DIV_1;
               event HE_DIV_3;
               event HE_DIV_10;
               event HE_DIV_100;
           )
         (| HE_DIV_1 := HE
          | HE_DIV_3 := DYN_EVERY{0,3,3}(0 when HE,3 when HE,HE)
          | HE_DIV_10 := DYN_EVERY{0,10,10}(0 when HE,10 when HE,HE)
          | HE_DIV_100 := DYN_EVERY{0,100,100}(0 when HE,100 when HE,HE)
          |)
      ; 
      process INITGEN =
           { boolean PAR_DEFAUT;
             integer SEED1, SEED2; }
           ( ? event H_0;
           )
         (| INIT_GENERATEUR(PAR_DEFAUT when H_0,SEED1 when H_0,SEED2 when H_0) |)
         where 
         process INIT_GENERATEUR =
              ( ? boolean PAR_DEFAUT;
                  integer SEED1;
                  integer SEED2;
              )
              spec (| PAR_DEFAUT ^= SEED1 ^= SEED2 |)
         
         ; 
         end
      ; 
      event HES, H_0, STOP, HE_DIV_3, HE_DIV_10, HE_DIV_100, ON2_1, OFF2_2;
      end
   ; 
   process DYN_EVERY =
        { integer PHY_0, PI_0, V_0; }
        ( ? integer PHY;
            integer PERIOD;
            event HE;
          ! event HS;
        )
      (| (| MAX1 := ((0 when (PERIOD<=1)) default (PERIOD-1)) cell HE
          | MAX := MAX1 when HE
          | CPHY1 := ((0 when (PHY<0)) default PHY) cell HE
          | CPHY := CPHY1 when HE
          | ZV := V$1
          | V := (0 when (ZV>=MAX)) default (ZV+1)
          | HS := when (V=CPHY)
          |)/ ZV, V, CPHY1, MAX1 |)
      where 
      integer MAX1 init PI_0-1, MAX, CPHY1 init PHY_0, CPHY, ZV init V_0, V;
      end
   ; 
   process DYN_EVERY_AFTER =
        { integer PHY_0, PI_0, V_0; }
        ( ? integer PHY;
            integer PERIOD;
            event HE;
            event HRESET;
          ! event HS;
        )
      (| (| H := HE default HRESET
          | MAX1 := ((0 when (PERIOD<=1)) default (PERIOD-1)) cell H
          | MAX := MAX1 when H
          | CPHY1 := ((0 when (PHY<0)) default PHY) cell H
          | CPHY := CPHY1 when H
          | ZV := V$1
          | V := (0 when HRESET) default (0 when (ZV>=MAX)) default (ZV+1)
          | HS := HE when (V=CPHY)
          |)/ H, MAX1, CPHY1, ZV, V |)
      where 
      integer MAX1 init PI_0-1, MAX, CPHY1 init PHY_0, CPHY, ZV init V_0, V;
      event H;
      end
   ; 
   process SCREEN =
        { integer TICK_NUMBER, FRONT_NUMBER, DELTA, PAS, FEN1, FEN2, ALPHA, BETA, Y_MAX;
          real PA_MAX, PR_MAX; }
        ( ? boolean H_0_FIN;
            event HSEC;
            real PA;
            real PR;
        )
      (| (| (| HE := HSEC
             | (| HE_BIS := when (ZA=0)
                | ZA := A$1
                | A := (0 when (ZA=(PAS-1))) default (ZA+1)
                | A ^= HE
                | X0 := AFFICHAGE_CIRCULAIRE{TICK_NUMBER,FRONT_NUMBER,300,DELTA}(SCREEN1,SCREEN2,HE_BIS)
                | X := X0 cell HE
                |)
             |) where event HE; end
          | AFFICHAGE{0,DELTA,ALPHA,BETA,PA_MAX,PR_MAX,Y_MAX}(SCREEN1,SCREEN2,HEURE,MIN,SEC,PA,PR,X)
          | (| HE := HSEC
             | INITSCREEN{FEN1,FEN2,PA_MAX,PR_MAX,Y_MAX}
             |) where event HE; end
          | WATCH_SCREEN{}
          | (| H_0 := when H_0_FIN |)
          |)/ H_0, SEC, MIN, HEURE, SCREEN2, SCREEN1, X |)
      where 
      integer ZA init 0, X, SCREEN1, SCREEN2, HEURE, MIN, SEC;
      HE_BIS, A;
      X0;
      process AFFICHAGE_CIRCULAIRE =
           { integer XN, FN, DY, TS; }
           ( ? integer SCREEN1;
               integer SCREEN2;
               boolean HE;
             ! integer V;
           )
         (| (| V := ACCU_MOD{TS,TS*XN,TS*(FN-1)}(HE)
             | WEFFACE_X_SIG(SCREEN1 when (^V),V,TS,DY)
             | WEFFACE_X_SIG(SCREEN2 when (^V),V,TS,DY)
             |)/ V
          | V := ACCU_MOD{TS,TS*XN,TS*(XN-1)}(HE)
          |)
         where 
         process ACCU_MOD =
              { integer V_INC, V_BOUND, V_INIT; }
              ( ? boolean HE;
                ! integer V;
              )
            (| (| V ^= HE
                | ZV := V$1
                | V1 := ZV+V_INC
                | V := (0 when (V1>=V_BOUND)) default V1
                |)/ V1, ZV |)
            where 
            integer V1, ZV init V_INIT;
            end
         ; 
         end
      ; 
      process WVLINE_X_SIG =
           ( ? integer SCREEN;
               integer X1;
               integer Y1;
               integer Y2;
           )
           spec (| SCREEN ^= X1 ^= Y1 ^= Y2 |)
      
      ; 
      process WHLINE_X_SIG =
           ( ? integer SCREEN;
               integer X1;
               integer Y1;
               integer X2;
           )
           spec (| SCREEN ^= X1 ^= Y1 ^= X2 |)
      
      ; 
      process WEFFACE_X_SIG =
           ( ? integer SCREEN;
               integer X1;
               integer DX;
               integer DY;
           )
           spec (| SCREEN ^= X1 ^= DX ^= DY |)
      
      ; 
      process INITSCREEN =
           { integer FEN1, FEN2;
             real PA_MAX, PR_MAX;
             integer Y_MAX; }
           ( ? event H_0;
               event HE;
             ! integer SCREEN1;
               integer SCREEN2;
           )
         (| (| ECRAN1 ^= ECRAN2 ^= H_0
             | ECRAN1 := GET_DISPLAY_SIG{}(FEN1)
             | ECRAN2 := GET_DISPLAY_SIG{}(FEN2)
             | SCREEN1 := ECRAN1 cell HE
             | SCREEN2 := ECRAN2 cell HE
             | TRACE_ECHELLE_Y_SIG(SCREEN1,PA_MAX,Y_MAX)
             | TRACE_ECHELLE_Y_SIG(SCREEN2,PR_MAX,Y_MAX)
             |)/ ECRAN1, ECRAN2 |)
         where 
         ECRAN1, ECRAN2;
         process GET_DISPLAY_SIG =
              ( ? integer N;
                ! integer DESCR;
              )
              spec (| N ^= DESCR |)
         
         ; 
         process TRACE_ECHELLE_Y_SIG =
              ( ? integer SCREEN;
                  real P_MAX;
                  integer Y_MAX;
              )
              spec (| SCREEN ^= P_MAX ^= Y_MAX |)
         
         ; 
         end
      ; 
      process WLINE_X_SIG =
           ( ? integer SCREEN;
               integer X1;
               integer Y1;
               integer X2;
               integer Y2;
           )
           spec (| SCREEN ^= X1 ^= Y1 ^= X2 ^= Y2 |)
      
      ; 
      process WIWRITE_X_SIG =
           ( ? integer SCREEN;
               integer V;
               integer X;
               integer Y;
           )
           spec (| SCREEN ^= X ^= V ^= Y |)
      
      ; 
      process AFFICHAGE =
           { integer Y_POS, DX, ALPHA, BETA;
             real PA_MAX, PR_MAX;
             integer Y_MAX; }
           ( ? integer SCREEN1;
               integer SCREEN2;
               integer HEURE;
               integer MIN;
               integer SEC;
               real PA;
               real PR;
               integer X;
           )
         (| (| H := ^X
             | HMIN := ^MIN
             | ECRAN1 := SCREEN1 when H
             | ECRAN2 := SCREEN2 when H
             | X2 := X
             | BIDON1 := (PA/PA_MAX)*real(Y_MAX)
             | BIDON2 := (PR/PR_MAX)*real(Y_MAX)
             | YA2 := REALTOINT{}(BIDON1)
             | YR2 := REALTOINT{}(BIDON2)
             | YA1 := YA2$1
             | YR1 := YR2$1
             | X1 := X2-DX
             | WLINE_X_SIG(ECRAN1,X1,YA1,X2,YA1)
             | WLINE_X_SIG(ECRAN2,X1,YR1,X2,YR1)
             | WLINE_X_SIG(ECRAN1,X2,YA1,X2,YA2)
             | WLINE_X_SIG(ECRAN2,X2,YR1,X2,YR2)
             | TRACE_ECHELLE_X{Y_POS,ALPHA,BETA}(ECRAN1,HEURE,MIN,SEC,X1,X2)
             | TRACE_ECHELLE_X{Y_POS,ALPHA,BETA}(ECRAN2,HEURE,MIN,SEC,X1,X2)
             |)/ ECRAN1, ECRAN2, X1, X2, HMIN, H, BIDON1, BIDON2 |)
         where 
         real BIDON1, BIDON2;
         integer YR1 init 0, YR2;
         integer YA1 init 0, YA2;
         integer X1, X2;
         integer ECRAN1, ECRAN2;
         event H, HMIN;
         process TRACE_ECHELLE_X =
              { integer Y_POS, ALPHA, BETA; }
              ( ? integer ECRAN;
                  integer HEURE;
                  integer MIN;
                  integer SEC;
                  integer X1;
                  integer X2;
              )
            (| (| H := ^HEURE
                | HMIN := ^MIN
                | HSEC := ^SEC
                | CHEURE := HEURE cell HMIN
                | HSEC5 := ECHANT{ALPHA}(HSEC)
                | WVLINE_X_SIG(ECRAN when HSEC5,X2 when HSEC5,Y_POS,Y_POS+3)
                | WVLINE_X_SIG(ECRAN when HMINB,X2 when HMINB,Y_POS,Y_POS+6)
                | HMINB := ECHANT{BETA}(HMIN)
                | WIWRITE_X_SIG(ECRAN when HMINB,CHEURE when HMINB,X1 when HMINB,15)
                | WIWRITE_X_SIG(ECRAN when HMINB,MIN when HMINB,X1 when HMINB,25)
                |)/ H, HSEC, HMIN, CHEURE, HSEC5 |)
            where 
            H, HMIN, HSEC, CHEURE, HSEC5;
            HMINB;
            process ECHANT =
                 { integer ALPHA; }
                 ( ? event H;
                   ! event HS;
                 )
               (| (| H ^= C
                   | ZC := C$1
                   | C := ((ALPHA-1) when (ZC=0)) default (ZC-1)
                   | HS := when (ZC=0)
                   |)/ C, ZC |)
               where 
               integer ZC init 0;
               integer C;
               end
            ; 
            end
         ; 
         end
      ; 
      process WATCH_SCREEN =
           ( ? event HSEC;
             ! integer HEURE;
               integer MIN;
               integer SEC;
           )
         (| (| SEC := COMPTEUR_MODULO{60}(HSEC)
             | HMIN := DYN_EVERY{0,60,60}(0 when HSEC,60 when HSEC,HSEC)
             | MIN := COMPTEUR_MODULO{60}(HMIN)
             | HHEURE := DYN_EVERY{0,60,60}(0 when HMIN,60 when HMIN,HMIN)
             | HEURE := COMPTEUR_MODULO{8760}(HHEURE)
             |)/ HMIN, HHEURE |)
         where 
         event HHEURE, HMIN;
         integer ZVALUE init 0;
         process COMPTEUR_MODULO =
              { integer N; }
              ( ? UNIT;
                ! VALUE;
              )
            (| (| UNIT ^= VALUE
                | VALUE := (0 when (ZVALUE=(N-1))) default (ZVALUE+1)
                | ZVALUE := VALUE$1
                |)/ ZVALUE |)
            where 
            integer ZVALUE init -1;
            end
         ; 
         end
      ; 
      event H_0;
      end
   ; 
   process MESURE =
        { real M1, S1, M2, S2; }
        ( ? real PAE;
            real PRE;
          ! real PAS;
            real PRS;
        )
      (| PAS := PAE
       | PRS := PRE
       |)
   ; 
   function REALTOINT =
        ( ? real R;
          ! integer I;
        )
   
   ; 
   process COMPRESS =
        { integer NUMERO_FICHIER; }
        ( ? boolean H_0_FIN;
            event HSEC;
            event EV;
            real PA_EV;
            real PR_EV;
            real ZPA_EV;
            real ZPR_EV;
        )
      (| ADRESSE_FICHIER := OPEN_FILE_WRITE{}(NUMERO_FICHIER when H_0_FIN) default Z_ADRESSE_FICHIER
       | Z_ADRESSE_FICHIER := ADRESSE_FICHIER$1
       | ADRESSE_FICHIER ^= EV default H_0_FIN
       | WRITE_FILE{}(ADRESSE_FICHIER when EV,HEURE,MIN,SEC,PA_EV-ZPA_EV,PR_EV-ZPR_EV,PA_EV,PR_EV)
       | CLOSE_FILE{}(ADRESSE_FICHIER when (not H_0_FIN))
       | (HEURE,MIN,SEC) := WATCH{}(HSEC)
       | EV ^= HEURE ^= MIN ^= SEC
       |)
      where 
      integer Z_ADRESSE_FICHIER init 0;
      HEURE, MIN, SEC, ADRESSE_FICHIER;
      end
   ; 
   process UNIFORME_INT =
        ( ? integer NUMGEN;
            integer B_INF;
            integer B_SUP;
          ! integer U;
        )
        spec (| NUMGEN ^= B_INF ^= B_SUP ^= U |)
   
   ; 
   process INVERSE_GAUSSIENNE =
        ( ? integer NUMGEN1;
            integer NUMGEN2;
            real LAMBDA;
            real MU;
          ! real X;
        )
        spec (| NUMGEN1 ^= NUMGEN2 ^= LAMBDA ^= MU ^= X |)
   
   ; 
   process GAUSSIENNE =
        ( ? integer NUMGEN;
            real LAMBDA;
            real MU;
          ! real X;
        )
        spec (| NUMGEN ^= LAMBDA ^= MU ^= X |)
   
   ; 
   process WEIBULL =
        ( ? integer NUMGEN;
            real A;
          ! real X;
        )
        spec (| NUMGEN ^= A ^= X |)
   
   ; 
   process RAYLEIGHT =
        ( ? integer NUMGEN;
            real A;
          ! real X;
        )
        spec (| NUMGEN ^= A ^= X |)
   
   ; 
   process GAUSS2D =
        ( ? integer NUMGEN;
            real MEAN1;
            real MEAN2;
            real VAR1;
            real VAR2;
            real COVAR12;
          ! real X1;
            real X2;
        )
        spec (| NUMGEN ^= MEAN1 ^= MEAN2 ^= VAR1 ^= VAR2 ^= COVAR12 ^= X1 ^= X2 |)
   
   ; 
   process UNIFORME =
        ( ? integer NUMGEN;
            real B_INF;
            real B_SUP;
          ! real U;
        )
        spec (| NUMGEN ^= B_INF ^= B_SUP ^= U |)
   
   ; 
   process WATCH =
        ( ? event HSEC;
          ! integer HEURE;
            integer MIN;
            integer SEC;
        )
      (| (| SEC_CHANGE := COMPTEUR_MODULO{60}(HSEC)
          | HMIN := DYN_EVERY{0,60,60}(0 when HSEC,60 when HSEC,HSEC)
          | MIN_CHANGE := COMPTEUR_MODULO{60}(HMIN)
          | HHEURE := DYN_EVERY{0,60,60}(0 when HMIN,60 when HMIN,HMIN)
          | HEURE_CHANGE := COMPTEUR_MODULO{8760}(HHEURE)
          | H_SEC_DEMANDE := ^SEC
          | C_SEC := SEC_CHANGE cell H_SEC_DEMANDE
          | SEC := C_SEC when H_SEC_DEMANDE
          | H_MIN_DEMANDE := ^MIN
          | C_MIN := MIN_CHANGE cell H_MIN_DEMANDE
          | MIN := C_MIN when H_MIN_DEMANDE
          | H_HEURE_DEMANDE := ^HEURE
          | C_HEURE := HEURE_CHANGE cell H_HEURE_DEMANDE
          | HEURE := C_HEURE when H_HEURE_DEMANDE
          |)/ HMIN, HHEURE |)
      where 
      event HHEURE, HMIN;
      integer ZVALUE init 0;
      C_HEURE;
      C_MIN;
      C_SEC;
      H_HEURE_DEMANDE;
      HEURE_CHANGE;
      H_MIN_DEMANDE;
      MIN_CHANGE;
      H_SEC_DEMANDE;
      SEC_CHANGE;
      process COMPTEUR_MODULO =
           { integer N; }
           ( ? UNIT;
             ! VALUE;
           )
         (| (| UNIT ^= VALUE
             | VALUE := (0 when (ZVALUE=(N-1))) default (ZVALUE+1)
             | ZVALUE := VALUE$1
             |)/ ZVALUE |)
         where 
         integer ZVALUE init -1;
         end
      ; 
      end
   ; 
   process OPEN_FILE_WRITE =
        ( ? integer FILE_NUMBER;
          ! integer FILE_ADRESS;
        )
        spec (| FILE_NUMBER ^= FILE_ADRESS |)
   
   ; 
   process WRITE_FILE =
        ( ? integer FICHIER;
            integer HEURE;
            integer MIN;
            integer SEC;
            real DELTA_PA;
            real DELTA_PR;
            real PA;
            real PR;
        )
        spec (| FICHIER ^= HEURE ^= MIN ^= SEC ^= DELTA_PA ^= DELTA_PR ^= PA ^= PR |)
   
   ; 
   process CLOSE_FILE =
        ( ? integer FILE_NUMBER;
        )
   
   ; 
   process WRITE_TIME =
        ( ? boolean H_0;
            event HSEC;
        )
      (| (HEURE,MIN,SEC,JOUR) := WATCH{}(HSEC)
       | ADR ^= when H_0
       | ADR := GET_ADRESSE_HEURE_SIG{}()
       | SCREEN := ADR cell HSEC
       | WRITE_HEURE_SIG{}(SCREEN when HSEC,JOUR,HEURE,MIN,SEC)
       |)
      where 
      integer ADR;
      SCREEN, HEURE, MIN, SEC, JOUR;
      process WRITE_HEURE_SIG =
           ( ? integer JOUR;
               integer HEURE;
               integer MIN;
               integer SEC;
               integer SCREEN;
           )
           spec (| JOUR ^= HEURE ^= MIN ^= SEC ^= SCREEN |)
      
      ; 
      process GET_ADRESSE_HEURE_SIG =
           ( ! integer ADR;
           )
      
      ; 
      process WATCH =
           ( ? event HSEC;
             ! integer HEURE;
               integer MIN;
               integer SEC;
               integer JOUR;
           )
         (| (| SEC_CHANGE := COMPTEUR_MODULO{60}(HSEC)
             | HMIN := DYN_EVERY{0,60,60}(0 when HSEC,60 when HSEC,HSEC)
             | MIN_CHANGE := COMPTEUR_MODULO{60}(HMIN)
             | HHEURE := DYN_EVERY{0,60,60}(0 when HMIN,60 when HMIN,HMIN)
             | HEURE_CHANGE := COMPTEUR_MODULO{24}(HHEURE)
             | HJOUR := DYN_EVERY{0,24,24}(0 when HMIN,24 when HHEURE,HHEURE)
             | JOUR_CHANGE := COMPTEUR_MODULO{365}(HJOUR)
             | H_SEC_DEMANDE := ^SEC
             | C_SEC := SEC_CHANGE cell H_SEC_DEMANDE
             | SEC := C_SEC when H_SEC_DEMANDE
             | H_MIN_DEMANDE := ^MIN
             | C_MIN := MIN_CHANGE cell H_MIN_DEMANDE
             | MIN := C_MIN when H_MIN_DEMANDE
             | H_HEURE_DEMANDE := ^HEURE
             | C_HEURE := HEURE_CHANGE cell H_HEURE_DEMANDE
             | HEURE := C_HEURE when H_HEURE_DEMANDE
             | H_JOUR_DEMANDE := ^JOUR
             | C_JOUR := JOUR_CHANGE cell H_JOUR_DEMANDE
             | JOUR := C_JOUR when H_JOUR_DEMANDE
             |)/ HMIN, HHEURE, HJOUR |)
         where 
         event HHEURE, HMIN, HJOUR;
         integer ZVALUE init 0;
         C_HEURE, C_MIN, C_SEC, C_JOUR, H_HEURE_DEMANDE, HEURE_CHANGE, H_MIN_DEMANDE, MIN_CHANGE, H_SEC_DEMANDE, SEC_CHANGE, H_JOUR_DEMANDE, JOUR_CHANGE;
         process COMPTEUR_MODULO =
              { integer N; }
              ( ? UNIT;
                ! VALUE;
              )
            (| (| UNIT ^= VALUE
                | VALUE := (0 when (ZVALUE=(N-1))) default (ZVALUE+1)
                | ZVALUE := VALUE$1
                |)/ ZVALUE |)
            where 
            integer ZVALUE init -1;
            end
         ; 
         end
      ; 
      end
   ; 
   real PA, PR, PA_EV, PR_EV, ZPA_EV, ZPR_EV;
   event EV, HSCAN, HSEC, ON1, OFF1, ON2, OFF2, MARCHE, ARRET, ON4, OFF4, ON5, OFF5, ON6, OFF6, ON7, OFF7, ON31, OFF31, ON32, OFF32, ON33, OFF33, ON34, OFF34, ON35, OFF35, ON36, OFF36;
   boolean H_0_FIN;
   end
; 
