module M_Q1_COST =
   type HomoType = external;
   constant HomoType NilHomoTypeValue = external;
   constant HomoType d_epsilon = external;
   process Q1_COST =
        ( ? boolean err2, stable, next_stable, OK, C_d, C_, C_cc_391, C_380, C_error_405, C_cc, C_error, C_338, C_335;
            HomoType d_c, d_b, d_a, d_x, d_err2, d_C_cc, d_C_cc_391, d_C_error, d_C_error_405;
          ! HomoType d_error, d_x1, d_x2, d_OK, d_stable, d_C_y, d_C_x1, d_C_error_323;
        )
      pragmas 
         main
         Defined_clock_hierarchy
      end pragmas
      (| (| CLK_stable_0 := ^stable
          | CLK_stable_0 ^= stable ^= next_stable ^= C_338 ^= C_335 ^= d_stable ^= d_C_y ^= d_C_x1
          | CLK_stable_0 ^= biterate ^= C ^= C_y ^= OK_354 ^= C_d_364 ^= C__375 ^= C_cc_397 ^= C__429 ^= C_x21 ^= C_x1 ^= C_469 ^= C_473 ^= C_476 ^= OK_238 ^= C_d_247 ^= C__256 ^= C_cc_268 ^= C_cc_391_277 ^= C_356 ^= C_365 ^= C_371 ^= C_375 ^= C_378 ^= 
            C_381 ^= C_384 ^= C_387 ^= C_394 ^= C_397 ^= C_409 ^= C_412 ^= C_415 ^= C_418 ^= C_427 ^= C_430 ^= C_439 ^= C_445 ^= C_451 ^= C_454 ^= C_460 ^= d_stable_internal ^= d_next_stable ^= d_yy ^= d_pre_next_yy ^= d_mx ^= d_next_yy ^= d_biterate ^= 
            d_s ^= d_XZX_164 ^= d_C ^= d_C_335 ^= d_C_338 ^= d_C_y_internal ^= d_OK_354 ^= d_C_d_364 ^= d_C__375 ^= d_C_cc_397 ^= d_C__429 ^= d_C_x21 ^= d_C_x1_internal ^= d_C_469 ^= d_C_473 ^= d_C_476 ^= d_OK_238 ^= d_C_d_247 ^= d_C__256 ^= d_C_cc_268 ^= 
            d_C_cc_391_277 ^= d_C_356 ^= d_C_365 ^= d_C_371 ^= d_C_375 ^= d_C_378 ^= d_C_381 ^= d_C_384 ^= d_C_387 ^= d_C_394 ^= d_C_397 ^= d_C_409 ^= d_C_412 ^= d_C_415 ^= d_C_418 ^= d_C_427 ^= d_C_430 ^= d_C_439 ^= d_C_445 ^= d_C_451 ^= d_C_454 ^= 
            d_C_460 ^= d_nlabel_475 ^= d_nlabel_476 ^= d_nlabel_477 ^= d_nlabel_479 ^= d_nlabel_480 ^= d_nlabel_483 ^= d_CLK_stable_0 ^= done_1266 ^= done_1269 ^= done_1298 ^= done_1309 ^= done_1321 ^= done_1340 ^= done_1343 ^= done_1347 ^= done_1351 ^= 
            done_1355 ^= done_1359 ^= done_1363 ^= done_1371 ^= done_1377 ^= done_1381 ^= done_1390 ^= done_1402 ^= done_1413 ^= done_1422 ^= done_1432 ^= done_1443 ^= done_1449 ^= done_1453 ^= done_1472 ^= done_1488 ^= done_1498 ^= done_1507 ^= done_1512 
            ^= done_1518 ^= XZX_1521 ^= done_1522 ^= XZX_1533 ^= done_1534 ^= done_1544 ^= done_1565 ^= done_1576 ^= done_1587 ^= done_1593 ^= done_1598 ^= done_1609 ^= done_1615 ^= XZX_1618 ^= done_1619 ^= XZX_1630 ^= done_1631 ^= XZX_1640 ^= done_1641 ^=
            XZX_1653 ^= XZX_1659 ^= done_1660 ^= XZX_1672 ^= done_1673 ^= done_1692 ^= XZX_1700 ^= done_1701 ^= XZX_1710 ^= done_1711 ^= XZX_1720 ^= done_1721 ^= done_1742 ^= XZX_1745 ^= done_1746 ^= XZX_1755 ^= done_1756 ^= XZX_1768 ^= done_1769 ^= 
            done_1780 ^= done_1793 ^= done_1799 ^= XZX_1810 ^= done_1817 ^= XZX_1822 ^= done_1823 ^= XZX_1835 ^= done_1843 ^= done_1850 ^= done_1859 ^= done_1869 ^= done_1875 ^= XZX_1878 ^= done_1879 ^= XZX_1895 ^= done_1896 ^= done_1907 ^= done_1925 ^= 
            XZX_1933 ^= done_1934 ^= XZX_1950 ^= done_1951 ^= done_1962 ^= done_1969 ^= done_1976 ^= XZX_1982 ^= done_1983 ^= done_1991 ^= done_2014 ^= done_2033 ^= done_2054 ^= done_2069 ^= done_2087 ^= done_2106 ^= done_2122 ^= done_2132 ^= done_2148 ^= 
            done_2161 ^= done_2168 ^= XZX_2180 ^= done_2181 ^= done_2189 ^= XZX_2195 ^= done_2196 ^= done_2204 ^= XZX_2210 ^= done_2211 ^= done_2219 ^= XZX_2225 ^= done_2226 ^= done_2234 ^= done_2247 ^= done_2254 ^= done_2284 ^= done_2287 ^= done_2290 ^= 
            done_2295 ^= done_2299 ^= done_2303 ^= done_2307 ^= done_2311 ^= done_2315 ^= done_2319 ^= done_2327 ^= done_2346 ^= done_2353 ^= done_2363 ^= done_2370 ^= done_2380 ^= done_2383 ^= done_2387 ^= done_2422 ^= done_2425 ^= done_2446 ^= XZX_2455 
            ^= done_2456 ^= XZX_2472 ^= done_2473 ^= done_2484 ^= done_2496 ^= done_2499 ^= done_2504 ^= done_2508 ^= done_2512 ^= done_2519 ^= done_2527 ^= XZX_2533 ^= done_2534 ^= done_2542 ^= done_2549 ^= XZX_2555 ^= done_2556 ^= done_2564 ^= done_2571 
            ^= done_2579 ^= done_2587 ^= done_2595 ^= done_2610 ^= done_2613 ^= done_2617 ^= done_2621 ^= done_2625 ^= done_2629 ^= done_2648 ^= done_2715 ^= done_2723 ^= done_2738 ^= done_2760 ^= done_2813 ^= done_2861 ^= done_2888 ^= done_2899 ^= 
            done_2926 ^= done_2934 ^= done_2942 ^= done_2950 ^= done_2958 ^= done_2966 ^= done_2974 ^= done_2982 ^= done_2990 ^= done_3006 ^= done_3014 ^= done_3022 ^= done_3030 ^= done_3038 ^= done_3050 ^= done_3058 ^= done_3066 ^= done_3074 ^= done_3082 
            ^= done_3090 ^= done_3098 ^= done_3106 ^= done_3114 ^= done_3203 ^= done_3209 ^= done_3215 ^= done_3226 ^= done_3237 ^= done_3243 ^= done_3259 ^= done_3270 ^= done_3276 ^= done_3301 ^= done_3311 ^= done_3317
          |)
       | (| CLK := when biterate
          | CLK ^= d_CLK
          |)
       | (| CLK_c_0 := when stable
          | CLK_c_0 ^= OK ^= C_error_405 ^= C_cc ^= d_c ^= d_b ^= d_a ^= d_C_cc ^= d_C_error_405 ^= d_OK ^= d_C_error_323 ^= d_c_internal ^= d_b_internal ^= d_a_internal ^= d_C_cc_internal ^= d_C_error_405_internal ^= d_OK_internal ^= d_C_383 ^= 
            d_C_380_262 ^= d_C_error_323_internal ^= d_C_391 ^= d_nlabel ^= d_nlabel_478 ^= d_nlabel_481 ^= d_nlabel_482 ^= d_nlabel_484 ^= d_nlabel_485 ^= d_nlabel_486 ^= d_CLK_c_0 ^= done_1289 ^= done_2438 ^= done_2659 ^= done_2708 ^= done_2769 ^= 
            done_2827 ^= done_2880
          | CLK_c_0 ^= C_383 ^= C_error_438 ^= C_380_262 ^= C_error_283 ^= C_error_323 ^= C_391 ^= C_433 ^= C_436 ^= C_463 ^= C_466 ^= d_C_error_438 ^= d_C_error_283 ^= d_C_433 ^= d_C_436 ^= d_C_463 ^= d_C_466 ^= done ^= done_1229 ^= done_1241 ^= 
            done_1273 ^= done_1277 ^= done_1281 ^= done_1285 ^= XZX_2339 ^= done_2394 ^= done_2403 ^= done_2430 ^= done_2434 ^= done_2636 ^= done_2655 ^= done_2666 ^= done_2676 ^= done_2700 ^= done_2704 ^= done_2746 ^= done_2765 ^= done_2777 ^= done_2785 
            ^= XZX_2791 ^= done_2792 ^= done_2800 ^= done_2819 ^= done_2823 ^= done_2833 ^= done_2841 ^= done_2848 ^= done_2868 ^= done_2872 ^= done_2876
          |)
       | (| CLK_bb := when OK
          | CLK_bb ^= C_d ^= C_ ^= C_380 ^= d_bb ^= d_C_d ^= d_C_ ^= d_C_380 ^= d_dd ^= d_aa ^= d_XZX_99 ^= d_XZX_103 ^= d_cc ^= d_CLK_bb ^= XZX_1575 ^= XZX_2032 ^= XZX_2053
          | CLK_bb ^= XZX_1862 ^= XZX_1918 ^= XZX_2007 ^= XZX_2046
          |)
       | (| CLK_d_0 := when C_d
          | CLK_d_0 ^= d_d ^= d_CLK_d_0 ^= XZX_1543 ^= XZX_1597
          | CLK_d_0 ^= XZX_1556 ^= XZX_1730
          |)
       | (| CLK_x0_0 := when C_
          | CLK_x0_0 ^= d_x0 ^= d_XZX_109 ^= d_CLK_x0_0 ^= XZX_1431
          | CLK_x0_0 ^= XZX_1425
          |)
       | (| CLK_24 := when C_380
          | CLK_24 ^= d_CLK_24
          | CLK_24 ^= XZX_1251
          |)
       | (| CLK_C_cc_391_0 := when C_cc
          | CLK_C_cc_391_0 ^= C_cc_391 ^= C_error ^= d_C_cc_391 ^= d_C_error ^= d_C_cc_391_internal ^= d_C_error_internal ^= d_CLK_C_cc_391_0
          |)
       | (| CLK_x_0 := when C_cc_391
          | CLK_x_0 ^= d_x ^= d_x_internal ^= d_CLK_x_0
          |)
       | (| CLK_err2_0 := when C_error
          | CLK_err2_0 ^= err2 ^= d_err2 ^= d_err2_internal ^= d_CLK_err2_0
          |)
       | (| CLK_46 := when C_error_438
          | CLK_46 ^= XZX ^= XZX_1240
          |)
       | (| CLK_error_0 := when C_error_323
          | CLK_error_0 ^= d_error ^= d_error_internal ^= d_CLK_error_1
          |)
       | (| CLK_217 := when C_391
          | CLK_217 ^= d_CLK_876
          |)
       | (| nlabel :: Q1_Cluster_1_M{}
          | nlabel ^= CLK_c_0
          |)
       | (| nlabel_478 :: Q1_Cluster_5_M{}
          | nlabel_478 ^= CLK_c_0
          |)
       | (| nlabel_481 :: Q1_Cluster_8_M{}
          | nlabel_481 ^= CLK_c_0
          |)
       | (| nlabel_482 :: Q1_Cluster_9_M{}
          | nlabel_482 ^= CLK_c_0
          |)
       | (| nlabel_484 :: Q1_Cluster_11_M{}
          | nlabel_484 ^= CLK_c_0
          |)
       | (| nlabel_485 :: Q1_Cluster_12_M{}
          | nlabel_485 ^= CLK_c_0
          |)
       | (| nlabel_486 :: Q1_Cluster_13_M{}
          | nlabel_486 ^= CLK_c_0
          |)
       | (| C_383 := left_tt ( C_380,OK )
          | C_error_438 := C_383 or C_error_405
          | C_380_262 := left_tt ( C_380,OK )
          | C_error_283 := left_tt ( C_error,C_cc )
          | C_error_323 := C_380_262 or C_error_283
          | C_391 := (not C_380_262) and C_error_283
          | C_433 := C_391 or C_error_438
          | C_436 := C_433 or C_380_262
          | C_463 := C_cc and C_error_323
          | C_466 := C_error_323 and C_error_438
          | done_1273 := pack(d_C_error_internal,d_err2_internal)
          | done_1277 := pack(d_C_380,done_1273)
          | done_1281 := pack(d_C_error_438,done_1277)
          | done_1285 := pack(d_C_error_323_internal,done_1281)
          | done_1289 := pack(d_C_391,done_1285)
          | done_2430 := pack(d_OK_internal,d_b_internal)
          | done_2434 := pack(d_stable_internal,done_2430)
          | done_2438 := pack(d_aa,done_2434)
          | done_2655 := pack(d_stable_internal,d_C_error_405_internal)
          | done_2659 := pack(d_C_383,done_2655)
          | done_2700 := pack(d_OK_internal,d_c_internal)
          | done_2704 := pack(d_stable_internal,done_2700)
          | done_2708 := pack(d_aa,done_2704)
          | done_2765 := pack(d_C_error_internal,d_C_cc_internal)
          | done_2769 := pack(d_stable_internal,done_2765)
          | done_2819 := pack(d_stable_internal,d_C_cc_internal)
          | done_2823 := pack(d_C_380_262,done_2819)
          | done_2827 := pack(d_C_error_283,done_2823)
          | done_2868 := pack(d_C_error_438,d_stable_internal)
          | done_2872 := pack(d_C_380_262,done_2868)
          | done_2876 := pack(d_C_error_323_internal,done_2872)
          | done_2880 := pack(d_C_391,done_2876)
          |)
       | (| CLK_65 := when C_335
          | CLK_65 ^= d_CLK_65
          |)
       | (| CLK_x2_0 := when C_y
          | CLK_x2_0 ^= d_x2 ^= d_x2_internal ^= d_x_194 ^= d_x_185 ^= d_y ^= d_bb_127 ^= d_CLK_x2_0 ^= XZX_1452 ^= XZX_1471 ^= XZX_2086 ^= XZX_2105
          | CLK_x2_0 ^= XZX_1465 ^= XZX_2099
          |)
       | (| CLK_XZX_181_0 := when C__429
          | CLK_XZX_181_0 ^= d_XZX_181 ^= d_CLK_XZX_181_0
          |)
       | (| CLK_x21_0 := when C_x21
          | CLK_x21_0 ^= d_x21 ^= d_CLK_x21_0 ^= XZX_1389 ^= XZX_1401
          |)
       | (| CLK_x1_0 := when C_x1
          | CLK_x1_0 ^= d_x1 ^= d_x1_internal ^= d_CLK_x1_0 ^= XZX_1308 ^= XZX_1320
          |)
       | (| CLK_207 := when C_375
          | CLK_207 ^= d_CLK_866
          |)
       | (| CLK_209 := when C_378
          | CLK_209 ^= d_CLK_868
          |)
       | (| CLK_211 := when C_381
          | CLK_211 ^= d_CLK_870
          |)
       | (| CLK_213 := when C_384
          | CLK_213 ^= d_CLK_872
          |)
       | (| CLK_215 := when C_387
          | CLK_215 ^= d_CLK_874
          |)
       | (| CLK_220 := when C_394
          | CLK_220 ^= d_CLK_878
          | CLK_220 ^= XZX_2465
          |)
       | (| CLK_222 := when C_397
          | CLK_222 ^= d_CLK_880
          | CLK_222 ^= XZX_1888 ^= XZX_1943
          |)
       | (| nlabel_475 :: Q1_Cluster_2_M{}
          | nlabel_475 ^= CLK_stable_0
          |)
       | (| nlabel_476 :: Q1_Cluster_3_M{}
          | nlabel_476 ^= CLK_stable_0
          |)
       | (| nlabel_477 :: Q1_Cluster_4_M{}
          | nlabel_477 ^= CLK_stable_0
          |)
       | (| nlabel_479 :: Q1_Cluster_6_M{}
          | nlabel_479 ^= CLK_stable_0
          |)
       | (| nlabel_480 :: Q1_Cluster_7_M{}
          | nlabel_480 ^= CLK_stable_0
          |)
       | (| nlabel_483 :: Q1_Cluster_10_M{}
          | nlabel_483 ^= CLK_stable_0
          |)
       | (| nlabel_531 :: Q1_Cluster_delays_M{}
          | nlabel_531 ^= CLK_stable_0
          |)
       | (| biterate := CLK_d_0 default ((not stable) when CLK_207)
          | C := not biterate
          | C_y := next_stable and biterate
          | OK_354 := left_tt ( OK,stable )
          | C_d_364 := (C_d when CLK_bb) default (not CLK_222)
          | C__375 := (C_ when CLK_bb) default (not CLK_222)
          | C_cc_397 := (C_cc_391 when CLK_C_cc_391_0) default (not CLK_220)
          | C__429 := C_y or OK_354
          | C_x21 := C_y or C__375
          | C_x1 := C_x21 or C_cc_397
          | C_469 := (not C_y) and C__375
          | C_473 := (not C_x21) and C_cc_397
          | C_476 := not C_d_364
          | OK_238 := left_tt ( OK,stable )
          | C_d_247 := left_tt ( C_d,stable )
          | C__256 := left_tt ( C_,stable )
          | C_cc_268 := left_tt ( C_cc,stable )
          | C_cc_391_277 := left_tt ( C_cc_391,stable )
          | C_356 := C_469 and C__256
          | C_365 := C_473 and C_cc_391_277
          | C_371 := C_476 or C_d_247
          | C_375 := (not C_d_247) and C_476
          | C_378 := (not C_x21) and C_365
          | C_381 := (not C_y) and C_356
          | C_384 := (not C_335) and C_338
          | C_387 := (not biterate) and C
          | C_394 := not C_cc_268
          | C_397 := not OK_238
          | C_409 := C_371 or biterate
          | C_412 := C_409 or C_387
          | C_415 := C_412 or C_335
          | C_418 := C_415 or C_384
          | C_427 := C_x21 or C_x1
          | C_430 := C_427 or C_378
          | C_439 := C_418 or OK_238
          | C_445 := C_378 or C_x1
          | C_451 := stable and C_y
          | C_454 := C_x1 and C_cc_268
          | C_460 := stable and C_x1
          | (d_nlabel,done_1266) := CostSubGraph(done_1289,d_error_internal,d_CLK_c_0,done_1269)
          | done_1347 := pack(d_C_cc_391_internal,d_x_internal)
          | done_1351 := pack(d_x21,done_1347)
          | done_1355 := pack(d_C_x21,done_1351)
          | done_1359 := pack(d_C_x1_internal,done_1355)
          | done_1363 := pack(d_C_378,done_1359)
          | (d_nlabel_475,done_1340) := CostSubGraph(done_1363,d_x1_internal,d_CLK_stable_0,done_1343)
          | done_2290 := pack(d_C_y_internal,d_x2_internal)
          | done_2295 := pack(d_stable_internal,d_OK_internal)
          | done_2299 := pack(d_bb,done_2295)
          | done_2303 := pack(d_pre_next_yy,done_2299)
          | done_2307 := pack(d_OK_354,done_2303)
          | done_2311 := pack(d_cc,done_2307)
          | done_2315 := pack(d_OK_238,done_2311)
          | done_2319 := pack(d_C_397,done_2315)
          | (d_nlabel_476,done_2284) := CostSubGraph(done_2319,done_2290,d_CLK_stable_0,done_2287)
          | done_2387 := pack(d_stable_internal,d_a_internal)
          | (d_nlabel_477,done_2380) := CostSubGraph(done_2387,d_OK_internal,d_CLK_stable_0,done_2383)
          | (d_nlabel_478,done_2422) := CostSubGraph(done_2438,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_2425)
          | done_2504 := pack(d_C_cc_391_internal,d_C_cc_internal)
          | done_2508 := pack(d_stable_internal,done_2504)
          | done_2512 := pack(d_C_394,done_2508)
          | (d_nlabel_479,done_2496) := CostSubGraph(done_2512,NilHomoTypeValue when CLK_stable_0,d_CLK_stable_0,done_2499)
          | done_2617 := pack(d_C_cc_397,d_stable_internal)
          | done_2621 := pack(d_C_x21,done_2617)
          | done_2625 := pack(d_C_cc_268,done_2621)
          | done_2629 := pack(d_C_cc_391_277,done_2625)
          | (d_nlabel_480,done_2610) := CostSubGraph(done_2629,d_C_x1_internal,d_CLK_stable_0,done_2613)
          | (d_nlabel_481,done_2648) := CostSubGraph(done_2659,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_1340)
          | (d_nlabel_482,done_2287) := CostSubGraph(done_2708,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_2422)
          | done_2738 := pack(d_stable_internal,d_C_cc_internal)
          | (d_nlabel_483,done_2499) := CostSubGraph(done_2738,NilHomoTypeValue when CLK_stable_0,d_CLK_stable_0,done_2380)
          | (d_nlabel_484,done_2383) := CostSubGraph(done_2769,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_2760)
          | (d_nlabel_485,done_2813) := CostSubGraph(done_2827,d_C_error_323_internal,d_CLK_c_0,done_2648)
          | (d_nlabel_486,done_2861) := CostSubGraph(done_2880,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_1266)
          | (d_CLK,done_2926) := CostWhen1(d_biterate,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_c_0,done_2934) := CostWhen1(d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_bb,done_2942) := CostWhen1(d_OK_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_d_0,done_2950) := CostWhen1(d_C_d,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_CLK_x0_0,done_2958) := CostWhen1(d_C_,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_CLK_24,done_2966) := CostWhen1(d_C_380,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_CLK_C_cc_391_0,done_2974) := CostWhen1(d_C_cc_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_x_0,done_2982) := CostWhen1(d_C_cc_391_internal,d_CLK_C_cc_391_0,NilHomoTypeValue when CLK_C_cc_391_0)
          | (d_CLK_err2_0,done_2990) := CostWhen1(d_C_error_internal,d_CLK_C_cc_391_0,NilHomoTypeValue when CLK_C_cc_391_0)
          | (d_CLK_65,done_3006) := CostWhen1(d_C_335,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_x2_0,done_3014) := CostWhen1(d_C_y_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_XZX_181_0,done_3022) := CostWhen1(d_C__429,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_x21_0,done_3030) := CostWhen1(d_C_x21,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_x1_0,done_3038) := CostWhen1(d_C_x1_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | d_CLK_stable_0 := CostConst{__TC__#_event}()
          | (d_CLK_error_1,done_3050) := CostWhen1(d_C_error_323_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_866,done_3058) := CostWhen1(d_C_375,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_868,done_3066) := CostWhen1(d_C_378,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_870,done_3074) := CostWhen1(d_C_381,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_872,done_3082) := CostWhen1(d_C_384,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_874,done_3090) := CostWhen1(d_C_387,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_876,done_3098) := CostWhen1(d_C_391,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_878,done_3106) := CostWhen1(d_C_394,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_880,done_3114) := CostWhen1(d_C_397,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_c_internal,done_3203) := CostInput{__TC__#_real}(d_c,d_CLK_c_0,done_3209)
          | (d_b_internal,done_3215) := CostInput{__TC__#_real}(d_b,d_CLK_c_0,done_3203)
          | (d_a_internal,done_3226) := CostInput{__TC__#_real}(d_a,d_CLK_c_0,done_3215)
          | (d_x_internal,done_3237) := CostInput{__TC__#_real}(d_x,d_CLK_x_0,done_3243)
          | (d_err2_internal,done_2760) := CostInput{__TC__#_logical}(d_err2,d_CLK_err2_0,done_3237)
          | (d_C_cc_internal,done_3259) := CostInput{__TC__#_logical}(d_C_cc,d_CLK_c_0,done_3226)
          | (d_C_cc_391_internal,done_3270) := CostInput{__TC__#_logical}(d_C_cc_391,d_CLK_C_cc_391_0,done_3276)
          | (d_C_error_internal,done_3243) := CostInput{__TC__#_logical}(d_C_error,d_CLK_C_cc_391_0,done_3270)
          | (d_C_error_405_internal,done_3276) := CostInput{__TC__#_logical}(d_C_error_405,d_CLK_c_0,done_3259)
          | (d_error,done_3301) := CostOutput{__TC__#_logical}(d_error_internal,d_CLK_error_1,done_2861)
          | (d_x1,done_3311) := CostOutput{__TC__#_real}(d_x1_internal,d_CLK_x1_0,done_3317)
          | (d_x2,done_3317) := CostOutput{__TC__#_real}(d_x2_internal,d_CLK_x2_0,done_3301)
          | (d_OK,done_2425) := CostOutput{__TC__#_logical}(d_OK_internal,d_CLK_c_0,done_2496)
          | (d_stable,done_3209) := CostOutput{__TC__#_logical}(d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_y,done_2613) := CostOutput{__TC__#_logical}(d_C_y_internal,d_CLK_stable_0,done_2284)
          | (d_C_x1,done_1343) := CostOutput{__TC__#_logical}(d_C_x1_internal,d_CLK_stable_0,done_2610)
          | (d_C_error_323,done_1269) := CostOutput{__TC__#_logical}(d_C_error_323_internal,d_CLK_c_0,done_2813)
          |)
       |)
      where 
      event CLK_755, CLK_752, CLK_750, CLK_746, CLK_744, CLK_662, CLK_657, CLK_647, CLK_587, CLK_571, CLK_222, CLK_220, CLK_217, CLK_215, CLK_213, CLK_211, CLK_209, CLK_207, CLK_error_0, CLK_x1_0, CLK_x21_0, CLK_XZX_181_0, CLK_x2_0, CLK_65, CLK_46, 
           CLK_err2_0, CLK_x_0, CLK_C_cc_391_0, CLK_24, CLK_x0_0, CLK_d_0, CLK_bb, CLK_c_0, CLK, CLK_stable_0;
      label nlabel_475, nlabel_476, nlabel_477, nlabel_479, nlabel_480, nlabel_483, nlabel_531; 
      label nlabel, nlabel_478, nlabel_481, nlabel_482, nlabel_484, nlabel_485, nlabel_486; 
      process Q1_Cluster_1_M =
           ( ? event CLK_217, CLK_error_0, CLK_46, CLK_err2_0, CLK_24, CLK_c_0;
               HomoType d_err2_internal, d_CLK_24, d_CLK_error_1, d_CLK_876;
             ! HomoType d_error_internal, done, XZX, done_1229, XZX_1240, done_1241, XZX_1251;
           )
         (| (| CLK_c_0 ^= done ^= done_1229 ^= done_1241
             | CLK_24 ^= d_CLK_24 ^= XZX_1251
             | CLK_err2_0 ^= d_err2_internal
             | CLK_46 ^= XZX ^= XZX_1240
             | CLK_error_0 ^= d_error_internal ^= d_CLK_error_1
             | CLK_217 ^= d_CLK_876
             |)
          | (XZX,done_1229) := CostWhen{__TC__#_logical}(d_err2_internal,d_CLK_876,NilHomoTypeValue when CLK_46)
          | XZX_1251 := CostConst{__TC__#_event}()
          | (XZX_1240,done_1241) := CostWhen{__TC__#_event}(XZX_1251,d_CLK_24,NilHomoTypeValue when CLK_46)
          | (d_error_internal,done) := CostDefault{__TC__#_logical}(XZX_1240,XZX,d_CLK_error_1,NilHomoTypeValue when CLK_46)
          |)
      %Q1_Cluster_1_M%; 
      process Q1_Cluster_5_M =
           ( ? event CLK_bb, CLK_c_0;
               HomoType d_b_internal, d_aa, d_CLK_bb;
             ! HomoType d_bb, d_XZX_99, done_2394, done_2403;
           )
         (| (| CLK_c_0 ^= d_b_internal ^= done_2394 ^= done_2403
             | CLK_bb ^= d_bb ^= d_aa ^= d_XZX_99 ^= d_CLK_bb
             |)
          | (d_bb,done_2394) := CostDivi{__TC__#_real,__TC__#_real}(d_XZX_99,d_aa,d_CLK_bb,done_2403)
          | (d_XZX_99,done_2403) := CostWhen{__TC__#_real}(d_b_internal,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          |)
      %Q1_Cluster_5_M%; 
      process Q1_Cluster_8_M =
           ( ? event CLK_c_0;
               boolean C_error_438;
               HomoType d_C_error_405_internal, d_C_383, d_CLK_c_0;
             ! HomoType d_C_error_438, done_2636;
           )
         (| (| CLK_c_0 ^= C_error_438 ^= d_C_error_405_internal ^= d_C_383 ^= d_C_error_438 ^= d_CLK_c_0 ^= done_2636 |)
          | (d_C_error_438,done_2636) := CostOr(d_C_383,d_C_error_405_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          |)
      %Q1_Cluster_8_M%; 
      process Q1_Cluster_9_M =
           ( ? event CLK_bb, CLK_c_0;
               HomoType d_c_internal, d_aa, d_CLK_bb;
             ! HomoType d_XZX_103, d_cc, done_2666, done_2676;
           )
         (| (| CLK_c_0 ^= d_c_internal ^= done_2666 ^= done_2676
             | CLK_bb ^= d_aa ^= d_XZX_103 ^= d_cc ^= d_CLK_bb
             |)
          | (d_XZX_103,done_2666) := CostWhen{__TC__#_real}(d_c_internal,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_cc,done_2676) := CostDivi{__TC__#_real,__TC__#_real}(d_XZX_103,d_aa,d_CLK_bb,done_2666)
          |)
      %Q1_Cluster_9_M%; 
      process Q1_Cluster_11_M =
           ( ? event CLK_C_cc_391_0, CLK_c_0;
               HomoType d_C_cc_internal, d_C_error_internal, d_CLK_c_0;
             ! HomoType d_C_error_283, done_2746;
           )
         (| (| CLK_c_0 ^= d_C_cc_internal ^= d_C_error_283 ^= d_CLK_c_0 ^= done_2746
             | CLK_C_cc_391_0 ^= d_C_error_internal
             |)
          | (d_C_error_283,done_2746) := CostLeftTT(d_C_error_internal,d_C_cc_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          |)
      %Q1_Cluster_11_M%; 
      process Q1_Cluster_12_M =
           ( ? event CLK_c_0;
               boolean C_error_323, C_391, C_463;
               HomoType d_C_cc_internal, d_C_380_262, d_C_error_283, d_CLK_c_0;
             ! HomoType d_C_error_323_internal, d_C_391, d_C_463, done_2777, done_2785, XZX_2791, done_2792, done_2800;
           )
         (| (| CLK_c_0 ^= C_error_323 ^= C_391 ^= C_463 ^= d_C_cc_internal ^= d_C_380_262 ^= d_C_error_283 ^= d_C_error_323_internal ^= d_C_391 ^= d_C_463 ^= d_CLK_c_0 ^= done_2777 ^= done_2785 ^= XZX_2791 ^= done_2792 ^= done_2800 |)
          | (d_C_error_323_internal,done_2777) := CostOr(d_C_380_262,d_C_error_283,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (XZX_2791,done_2792) := CostNot(d_C_380_262,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_C_391,done_2785) := CostAnd(XZX_2791,d_C_error_283,d_CLK_c_0,done_2777)
          | (d_C_463,done_2800) := CostAnd(d_C_cc_internal,d_C_error_323_internal,d_CLK_c_0,done_2785)
          |)
      %Q1_Cluster_12_M%; 
      process Q1_Cluster_13_M =
           ( ? event CLK_c_0;
               boolean C_436, C_466;
               HomoType d_C_error_438, d_C_380_262, d_C_error_323_internal, d_C_391, d_CLK_c_0;
             ! HomoType d_C_433, d_C_436, d_C_466, done_2833, done_2841, done_2848;
           )
         (| (| CLK_c_0 ^= C_436 ^= C_466 ^= d_C_error_438 ^= d_C_380_262 ^= d_C_error_323_internal ^= d_C_391 ^= d_C_433 ^= d_C_436 ^= d_C_466 ^= d_CLK_c_0 ^= done_2833 ^= done_2841 ^= done_2848 |)
          | (d_C_433,done_2833) := CostOr(d_C_391,d_C_error_438,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_C_436,done_2841) := CostOr(d_C_433,d_C_380_262,d_CLK_c_0,done_2833)
          | (d_C_466,done_2848) := CostAnd(d_C_error_323_internal,d_C_error_438,d_CLK_c_0,done_2841)
          |)
      %Q1_Cluster_13_M%; 
      process Q1_Cluster_2_M =
           ( ? event CLK_209, CLK_x1_0, CLK_x21_0, CLK_x_0, CLK_stable_0;
               HomoType d_x_internal, d_x21, d_CLK_x21_0, d_CLK_x1_0, d_CLK_868;
             ! HomoType d_x1_internal, done_1298, XZX_1308, done_1309, XZX_1320, done_1321;
           )
         (| (| CLK_stable_0 ^= done_1298 ^= done_1309 ^= done_1321
             | CLK_x_0 ^= d_x_internal
             | CLK_x21_0 ^= d_x21 ^= d_CLK_x21_0
             | CLK_x1_0 ^= d_x1_internal ^= d_CLK_x1_0 ^= XZX_1308 ^= XZX_1320
             | CLK_209 ^= d_CLK_868
             |)
          | (XZX_1308,done_1309) := CostWhen{__TC__#_real}(d_x_internal,d_CLK_868,NilHomoTypeValue when CLK_x1_0)
          | (XZX_1320,done_1321) := CostWhen{__TC__#_real}(d_x21,d_CLK_x21_0,NilHomoTypeValue when CLK_x1_0)
          | (d_x1_internal,done_1298) := CostDefault{__TC__#_real}(XZX_1320,XZX_1308,d_CLK_x1_0,NilHomoTypeValue when CLK_x1_0)
          |)
      %Q1_Cluster_2_M%; 
      process Q1_Cluster_3_M =
           ( ? event CLK_222, CLK_bb, CLK_c_0, CLK_stable_0;
               boolean biterate, C_y, C__429, C_x21, C_375, C_381, C_384, C_387, C_418, C_439, C_451, C_d, C_, C_380, C_335;
               HomoType d_OK_internal, d_stable_internal, d_bb, d_pre_next_yy, d_OK_354, d_cc, d_OK_238, d_CLK, d_CLK_c_0, d_CLK_bb, d_CLK_d_0, d_CLK_x0_0, d_CLK_65, d_CLK_x2_0, d_CLK_XZX_181_0, d_CLK_x21_0, d_CLK_stable_0, d_CLK_866, d_CLK_870, 
                        d_CLK_872, d_CLK_874, d_CLK_880;
             ! HomoType d_x2_internal, d_x21, d_x0, d_x_194, d_d, d_next_stable, d_yy, d_XZX_181, d_mx, d_next_yy, d_biterate, d_s, d_XZX_164, d_C, d_C_335, d_C_338, d_C_y_internal, d_C_d, d_C_d_364, d_C_, d_C__375, d_C__429, d_C_x21, d_C_469, d_C_476, 
                        d_C_380, d_C_383, d_dd, d_XZX_109, d_x_185, d_y, d_bb_127, d_C_d_247, d_C__256, d_C_380_262, d_C_356, d_C_371, d_C_375, d_C_381, d_C_384, d_C_387, d_C_409, d_C_412, d_C_415, d_C_418, d_C_439, d_C_451, done_1371, done_1377, 
                        done_1381, XZX_1389, done_1390, XZX_1401, done_1402, done_1413, done_1422, XZX_1425, XZX_1431, done_1432, done_1443, done_1449, XZX_1452, done_1453, XZX_1465, XZX_1471, done_1472, done_1488, done_1498, done_1507, done_1512, 
                        done_1518, XZX_1521, done_1522, XZX_1533, done_1534, XZX_1543, done_1544, XZX_1556, done_1565, XZX_1575, done_1576, done_1587, done_1593, XZX_1597, done_1598, done_1609, done_1615, XZX_1618, done_1619, XZX_1630, done_1631, XZX_1640,
                        done_1641, XZX_1653, XZX_1659, done_1660, XZX_1672, done_1673, done_1692, XZX_1700, done_1701, XZX_1710, done_1711, XZX_1720, done_1721, XZX_1730, done_1742, XZX_1745, done_1746, XZX_1755, done_1756, XZX_1768, done_1769, done_1780, 
                        done_1793, done_1799, XZX_1810, done_1817, XZX_1822, done_1823, XZX_1835, done_1843, done_1850, done_1859, XZX_1862, done_1869, done_1875, XZX_1878, done_1879, XZX_1888, XZX_1895, done_1896, done_1907, XZX_1918, done_1925, XZX_1933,
                        done_1934, XZX_1943, XZX_1950, done_1951, done_1962, done_1969, done_1976, XZX_1982, done_1983, done_1991, XZX_2007, done_2014, XZX_2032, done_2033, XZX_2046, XZX_2053, done_2054, done_2069, XZX_2086, done_2087, XZX_2099, XZX_2105, 
                        done_2106, done_2122, done_2132, done_2148, done_2161, done_2168, XZX_2180, done_2181, done_2189, XZX_2195, done_2196, done_2204, XZX_2210, done_2211, done_2219, XZX_2225, done_2226, done_2234, done_2247, done_2254;
           )
         (| (| CLK_stable_0 ^= biterate ^= C_y ^= C__429 ^= C_x21 ^= C_375 ^= C_381 ^= C_384 ^= C_387 ^= C_418 ^= C_439 ^= C_451 ^= C_335 ^= d_stable_internal ^= d_next_stable ^= d_yy ^= d_pre_next_yy ^= d_mx ^= d_next_yy ^= d_biterate ^= d_s ^= 
               d_XZX_164 ^= d_C ^= d_C_335 ^= d_C_338 ^= d_C_y_internal ^= d_OK_354 ^= d_C_d_364 ^= d_C__375 ^= d_C__429 ^= d_C_x21 ^= d_C_469 ^= d_C_476 ^= d_OK_238 ^= d_C_d_247 ^= d_C__256 ^= d_C_356 ^= d_C_371 ^= d_C_375 ^= d_C_381 ^= d_C_384 ^= 
               d_C_387 ^= d_C_409 ^= d_C_412 ^= d_C_415 ^= d_C_418 ^= d_C_439 ^= d_C_451 ^= d_CLK_stable_0 ^= done_1371 ^= done_1377 ^= done_1381 ^= done_1390 ^= done_1402 ^= done_1413 ^= done_1422 ^= done_1432 ^= done_1443 ^= done_1449 ^= done_1453 ^= 
               done_1472 ^= done_1488 ^= done_1498 ^= done_1507 ^= done_1512 ^= done_1518 ^= XZX_1521 ^= done_1522 ^= XZX_1533 ^= done_1534 ^= done_1544 ^= done_1565 ^= done_1576 ^= done_1587 ^= done_1593 ^= done_1598 ^= done_1609 ^= done_1615 ^= XZX_1618 
               ^= done_1619 ^= XZX_1630 ^= done_1631 ^= XZX_1640 ^= done_1641 ^= XZX_1653 ^= XZX_1659 ^= done_1660 ^= XZX_1672 ^= done_1673 ^= done_1692 ^= XZX_1700 ^= done_1701 ^= XZX_1710 ^= done_1711 ^= XZX_1720 ^= done_1721 ^= done_1742 ^= XZX_1745 ^= 
               done_1746 ^= XZX_1755 ^= done_1756 ^= XZX_1768 ^= done_1769 ^= done_1780 ^= done_1793 ^= done_1799 ^= XZX_1810 ^= done_1817 ^= XZX_1822 ^= done_1823 ^= XZX_1835 ^= done_1843 ^= done_1850 ^= done_1859 ^= done_1869 ^= done_1875 ^= XZX_1878 ^= 
               done_1879 ^= XZX_1895 ^= done_1896 ^= done_1907 ^= done_1925 ^= XZX_1933 ^= done_1934 ^= XZX_1950 ^= done_1951 ^= done_1962 ^= done_1969 ^= done_1976 ^= XZX_1982 ^= done_1983 ^= done_1991 ^= done_2014 ^= done_2033 ^= done_2054 ^= done_2069 
               ^= done_2087 ^= done_2106 ^= done_2122 ^= done_2132 ^= done_2148 ^= done_2161 ^= done_2168 ^= XZX_2180 ^= done_2181 ^= done_2189 ^= XZX_2195 ^= done_2196 ^= done_2204 ^= XZX_2210 ^= done_2211 ^= done_2219 ^= XZX_2225 ^= done_2226 ^= 
               done_2234 ^= done_2247 ^= done_2254
             | CLK ^= d_CLK
             | CLK_c_0 ^= d_OK_internal ^= d_C_383 ^= d_C_380_262 ^= d_CLK_c_0
             | CLK_bb ^= C_d ^= C_ ^= C_380 ^= d_bb ^= d_C_d ^= d_C_ ^= d_C_380 ^= d_dd ^= d_cc ^= d_CLK_bb ^= XZX_1575 ^= XZX_1862 ^= XZX_1918 ^= XZX_2007 ^= XZX_2032 ^= XZX_2046 ^= XZX_2053
             | CLK_d_0 ^= d_d ^= d_CLK_d_0 ^= XZX_1543 ^= XZX_1556 ^= XZX_1597 ^= XZX_1730
             | CLK_x0_0 ^= d_x0 ^= d_XZX_109 ^= d_CLK_x0_0 ^= XZX_1425 ^= XZX_1431
             | CLK_65 ^= d_CLK_65
             | CLK_x2_0 ^= d_x2_internal ^= d_x_194 ^= d_x_185 ^= d_y ^= d_bb_127 ^= d_CLK_x2_0 ^= XZX_1452 ^= XZX_1465 ^= XZX_1471 ^= XZX_2086 ^= XZX_2099 ^= XZX_2105
             | CLK_XZX_181_0 ^= d_XZX_181 ^= d_CLK_XZX_181_0
             | CLK_x21_0 ^= d_x21 ^= d_CLK_x21_0 ^= XZX_1389 ^= XZX_1401
             | CLK_207 ^= d_CLK_866
             | CLK_211 ^= d_CLK_870
             | CLK_213 ^= d_CLK_872
             | CLK_215 ^= d_CLK_874
             | CLK_222 ^= d_CLK_880 ^= XZX_1888 ^= XZX_1943
             |)
          | (d_x2_internal,done_1371) := CostRenaming{__TC__#_real}(d_x_185,d_CLK_x2_0,done_1377)
          | (XZX_1389,done_1390) := CostWhen{__TC__#_real}(d_x0,d_CLK_870,NilHomoTypeValue when CLK_x21_0)
          | (XZX_1401,done_1402) := CostWhen{__TC__#_real}(d_x_194,d_CLK_x2_0,NilHomoTypeValue when CLK_x21_0)
          | (d_x21,done_1381) := CostDefault{__TC__#_real}(XZX_1401,XZX_1389,d_CLK_x21_0,done_1371)
          | XZX_1425 := CostConst{__TC__#_real}()
          | (XZX_1431,done_1432) := CostUMinus{__TC__#_real}(d_XZX_109,d_CLK_x0_0,NilHomoTypeValue when CLK_x0_0)
          | (d_x0,done_1413) := CostDivi{__TC__#_real,__TC__#_real}(XZX_1431,XZX_1425,d_CLK_x0_0,done_1422)
          | XZX_1465 := CostConst{__TC__#_real}()
          | (XZX_1471,done_1472) := CostPlus{__TC__#_real,__TC__#_real}(d_bb_127,d_y,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (XZX_1452,done_1453) := CostDivi{__TC__#_real,__TC__#_real}(XZX_1471,XZX_1465,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_x_194,done_1443) := CostUMinus{__TC__#_real}(XZX_1452,d_CLK_x2_0,done_1449)
          | (d_d,done_1488) := CostWhen{__TC__#_real}(d_dd,d_CLK_d_0,NilHomoTypeValue when CLK_d_0)
          | (d_next_stable,done_1498) := CostLT{__TC__#_real,__TC__#_real}(d_s,d_epsilon,d_CLK_stable_0,done_1507)
          | (XZX_1521,done_1522) := CostWhen{__TC__#_real}(d_pre_next_yy,d_CLK_866,NilHomoTypeValue when CLK_stable_0)
          | XZX_1556 := CostConst{__TC__#_real}()
          | (XZX_1543,done_1544) := CostDivi{__TC__#_real,__TC__#_real}(d_d,XZX_1556,d_CLK_d_0,NilHomoTypeValue when CLK_d_0)
          | (XZX_1533,done_1534) := CostWhen{__TC__#_real}(XZX_1543,d_CLK_d_0,NilHomoTypeValue when CLK_stable_0)
          | (d_yy,done_1512) := CostDefault{__TC__#_real}(XZX_1533,XZX_1521,d_CLK_stable_0,done_1518)
          | (XZX_1575,done_1576) := CostWhen{__TC__#_real}(d_bb,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_XZX_181,done_1565) := CostCell{__TC__#_real}(XZX_1575,d_CLK_XZX_181_0,d_CLK_XZX_181_0,NilHomoTypeValue when CLK_XZX_181_0)
          | (XZX_1597,done_1598) := CostWhen{__TC__#_real}(d_d,d_CLK_d_0,NilHomoTypeValue when CLK_d_0)
          | (d_mx,done_1587) := CostCell{__TC__#_real}(XZX_1597,d_CLK_stable_0,d_CLK_stable_0,done_1593)
          | (XZX_1618,done_1619) := CostWhen{__TC__#_real}(d_yy,d_CLK_874,NilHomoTypeValue when CLK_stable_0)
          | XZX_1653 := CostConst{__TC__#_real}()
          | (XZX_1672,done_1673) := CostDivi{__TC__#_real,__TC__#_real}(d_mx,d_yy,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1659,done_1660) := CostPlus{__TC__#_real,__TC__#_real}(d_yy,XZX_1672,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1640,done_1641) := CostDivi{__TC__#_real,__TC__#_real}(XZX_1659,XZX_1653,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1630,done_1631) := CostWhen{__TC__#_real}(XZX_1640,d_CLK,NilHomoTypeValue when CLK_stable_0)
          | (d_next_yy,done_1609) := CostDefault{__TC__#_real}(XZX_1630,XZX_1618,d_CLK_stable_0,done_1615)
          | (XZX_1710,done_1711) := CostNot(d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1700,done_1701) := CostWhen{__TC__#_logical}(XZX_1710,d_CLK_866,NilHomoTypeValue when CLK_stable_0)
          | XZX_1730 := CostConst{__TC__#_event}()
          | (XZX_1720,done_1721) := CostWhen{__TC__#_event}(XZX_1730,d_CLK_d_0,NilHomoTypeValue when CLK_stable_0)
          | (d_biterate,done_1692) := CostDefault{__TC__#_logical}(XZX_1720,XZX_1700,d_CLK_stable_0,done_1512)
          | (XZX_1755,done_1756) := CostUMinus{__TC__#_real}(d_XZX_164,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1745,done_1746) := CostWhen{__TC__#_real}(XZX_1755,d_CLK_872,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1768,done_1769) := CostWhen{__TC__#_real}(d_XZX_164,d_CLK_65,NilHomoTypeValue when CLK_stable_0)
          | (d_s,done_1507) := CostDefault{__TC__#_real}(XZX_1768,XZX_1745,d_CLK_stable_0,done_1742)
          | (d_XZX_164,done_1780) := CostMinus{__TC__#_real,__TC__#_real}(d_next_yy,d_yy,d_CLK_stable_0,done_1609)
          | (d_C,done_1793) := CostNot(d_biterate,d_CLK_stable_0,done_1692)
          | XZX_1810 := CostConst{__TC__#_real}()
          | (d_C_335,done_1799) := CostGEQ{__TC__#_real,__TC__#_real}(d_XZX_164,XZX_1810,d_CLK_stable_0,done_1780)
          | XZX_1835 := CostConst{__TC__#_real}()
          | (XZX_1822,done_1823) := CostGEQ{__TC__#_real,__TC__#_real}(d_XZX_164,XZX_1835,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_338,done_1817) := CostNot(XZX_1822,d_CLK_stable_0,done_1799)
          | (d_C_y_internal,done_1843) := CostAnd(d_next_stable,d_biterate,d_CLK_stable_0,done_1498)
          | XZX_1862 := CostConst{__TC__#_real}()
          | (d_C_d,done_1850) := CostGT{__TC__#_real,__TC__#_real}(d_dd,XZX_1862,d_CLK_bb,done_1859)
          | XZX_1888 := CostConst{__TC__#_logical}()
          | (XZX_1878,done_1879) := CostWhen{__TC__#_logical}(XZX_1888,d_CLK_880,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1895,done_1896) := CostWhen{__TC__#_logical}(d_C_d,d_CLK_bb,NilHomoTypeValue when CLK_stable_0)
          | (d_C_d_364,done_1869) := CostDefault{__TC__#_logical}(XZX_1895,XZX_1878,d_CLK_stable_0,done_1875)
          | XZX_1918 := CostConst{__TC__#_real}()
          | (d_C_,done_1907) := CostEQ{__TC__#_real,__TC__#_real}(d_dd,XZX_1918,d_CLK_bb,done_1850)
          | XZX_1943 := CostConst{__TC__#_logical}()
          | (XZX_1933,done_1934) := CostWhen{__TC__#_logical}(XZX_1943,d_CLK_880,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1950,done_1951) := CostWhen{__TC__#_logical}(d_C_,d_CLK_bb,NilHomoTypeValue when CLK_stable_0)
          | (d_C__375,done_1925) := CostDefault{__TC__#_logical}(XZX_1950,XZX_1933,d_CLK_stable_0,done_1869)
          | (d_C__429,done_1962) := CostOr(d_C_y_internal,d_OK_354,d_CLK_stable_0,done_1843)
          | (d_C_x21,done_1969) := CostOr(d_C_y_internal,d_C__375,d_CLK_stable_0,done_1962)
          | (XZX_1982,done_1983) := CostNot(d_C_y_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_469,done_1976) := CostAnd(XZX_1982,d_C__375,d_CLK_stable_0,done_1969)
          | (d_C_476,done_1991) := CostNot(d_C_d_364,d_CLK_stable_0,done_1925)
          | XZX_2007 := CostConst{__TC__#_real}()
          | (d_C_380,done_1422) := CostLT{__TC__#_real,__TC__#_real}(d_dd,XZX_2007,d_CLK_bb,done_1907)
          | (d_C_383,done_2014) := CostLeftTT(d_C_380,d_OK_internal,d_CLK_c_0,done_1413)
          | XZX_2046 := CostConst{__TC__#_real}()
          | (XZX_2032,done_2033) := CostMult{__TC__#_real,__TC__#_real}(XZX_2046,d_cc,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (XZX_2053,done_2054) := CostMult{__TC__#_real,__TC__#_real}(d_bb,d_bb,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_dd,done_1859) := CostMinus{__TC__#_real,__TC__#_real}(XZX_2053,XZX_2032,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_XZX_109,done_2069) := CostWhen{__TC__#_real}(d_bb,d_CLK_x0_0,NilHomoTypeValue when CLK_x0_0)
          | XZX_2099 := CostConst{__TC__#_real}()
          | (XZX_2105,done_2106) := CostMinus{__TC__#_real,__TC__#_real}(d_bb_127,d_y,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (XZX_2086,done_2087) := CostDivi{__TC__#_real,__TC__#_real}(XZX_2105,XZX_2099,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_x_185,done_1377) := CostUMinus{__TC__#_real}(XZX_2086,d_CLK_x2_0,done_1443)
          | (d_y,done_2122) := CostWhen{__TC__#_real}(d_yy,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_bb_127,done_2132) := CostWhen{__TC__#_real}(d_XZX_181,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_C_d_247,done_1593) := CostLeftTT(d_C_d,d_stable_internal,d_CLK_stable_0,done_1991)
          | (d_C__256,done_2148) := CostLeftTT(d_C_,d_stable_internal,d_CLK_stable_0,done_1587)
          | (d_C_380_262,done_1875) := CostLeftTT(d_C_380,d_OK_internal,d_CLK_c_0,done_2014)
          | (d_C_356,done_2161) := CostAnd(d_C_469,d_C__256,d_CLK_stable_0,done_1976)
          | (d_C_371,done_2168) := CostOr(d_C_476,d_C_d_247,d_CLK_stable_0,done_2148)
          | (XZX_2180,done_2181) := CostNot(d_C_d_247,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_375,done_1518) := CostAnd(XZX_2180,d_C_476,d_CLK_stable_0,done_2168)
          | (XZX_2195,done_2196) := CostNot(d_C_y_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_381,done_2189) := CostAnd(XZX_2195,d_C_356,d_CLK_stable_0,done_2161)
          | (XZX_2210,done_2211) := CostNot(d_C_335,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_384,done_2204) := CostAnd(XZX_2210,d_C_338,d_CLK_stable_0,done_1817)
          | (XZX_2225,done_2226) := CostNot(d_biterate,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_387,done_2219) := CostAnd(XZX_2225,d_C,d_CLK_stable_0,done_1793)
          | (d_C_409,done_2234) := CostOr(d_C_371,d_biterate,d_CLK_stable_0,done_2219)
          | (d_C_412,done_1615) := CostOr(d_C_409,d_C_387,d_CLK_stable_0,done_2234)
          | (d_C_415,done_2247) := CostOr(d_C_412,d_C_335,d_CLK_stable_0,done_2204)
          | (d_C_418,done_2254) := CostOr(d_C_415,d_C_384,d_CLK_stable_0,done_2247)
          | (d_C_439,done_1742) := CostOr(d_C_418,d_OK_238,d_CLK_stable_0,done_2254)
          | (d_C_451,done_1449) := CostAnd(d_stable_internal,d_C_y_internal,d_CLK_stable_0,done_2189)
          |)
      %Q1_Cluster_3_M%; 
      process Q1_Cluster_4_M =
           ( ? event CLK_c_0, CLK_stable_0;
               boolean C_397, OK;
               HomoType d_a_internal, d_stable_internal, d_CLK_c_0, d_CLK_bb, d_CLK_stable_0;
             ! HomoType d_OK_internal, d_OK_354, d_aa, d_OK_238, d_C_397, done_2327, XZX_2339, done_2346, done_2353, done_2363, done_2370;
           )
         (| (| CLK_stable_0 ^= C_397 ^= d_stable_internal ^= d_OK_354 ^= d_OK_238 ^= d_C_397 ^= d_CLK_stable_0 ^= done_2327 ^= done_2346 ^= done_2353 ^= done_2363 ^= done_2370
             | CLK_c_0 ^= OK ^= d_a_internal ^= d_OK_internal ^= d_CLK_c_0 ^= XZX_2339
             | CLK_bb ^= d_aa ^= d_CLK_bb
             |)
          | XZX_2339 := CostConst{__TC__#_real}()
          | (d_OK_internal,done_2327) := CostNEQ{__TC__#_real,__TC__#_real}(d_a_internal,XZX_2339,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_OK_354,done_2346) := CostLeftTT(d_OK_internal,d_stable_internal,d_CLK_stable_0,done_2327)
          | (d_aa,done_2353) := CostWhen{__TC__#_real}(d_a_internal,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_OK_238,done_2363) := CostLeftTT(d_OK_internal,d_stable_internal,d_CLK_stable_0,done_2346)
          | (d_C_397,done_2370) := CostNot(d_OK_238,d_CLK_stable_0,done_2363)
          |)
      %Q1_Cluster_4_M%; 
      process Q1_Cluster_6_M =
           ( ? event CLK_220, CLK_C_cc_391_0, CLK_stable_0;
               HomoType d_C_cc_391_internal, d_stable_internal, d_CLK_C_cc_391_0, d_CLK_stable_0, d_CLK_878;
             ! HomoType d_C_cc_397, d_C_cc_391_277, done_2446, XZX_2455, done_2456, XZX_2465, XZX_2472, done_2473, done_2484;
           )
         (| (| CLK_stable_0 ^= d_stable_internal ^= d_C_cc_397 ^= d_C_cc_391_277 ^= d_CLK_stable_0 ^= done_2446 ^= XZX_2455 ^= done_2456 ^= XZX_2472 ^= done_2473 ^= done_2484
             | CLK_C_cc_391_0 ^= d_C_cc_391_internal ^= d_CLK_C_cc_391_0
             | CLK_220 ^= d_CLK_878 ^= XZX_2465
             |)
          | XZX_2465 := CostConst{__TC__#_logical}()
          | (XZX_2455,done_2456) := CostWhen{__TC__#_logical}(XZX_2465,d_CLK_878,NilHomoTypeValue when CLK_stable_0)
          | (XZX_2472,done_2473) := CostWhen{__TC__#_logical}(d_C_cc_391_internal,d_CLK_C_cc_391_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_cc_397,done_2446) := CostDefault{__TC__#_logical}(XZX_2472,XZX_2455,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_cc_391_277,done_2484) := CostLeftTT(d_C_cc_391_internal,d_stable_internal,d_CLK_stable_0,done_2446)
          |)
      %Q1_Cluster_6_M%; 
      process Q1_Cluster_7_M =
           ( ? event CLK_stable_0;
               boolean C_x1, C_378, C_430, C_445, C_454, C_460;
               HomoType d_stable_internal, d_C_cc_397, d_C_x21, d_C_cc_268, d_C_cc_391_277, d_CLK_stable_0;
             ! HomoType d_C_x1_internal, d_C_473, d_C_365, d_C_378, d_C_427, d_C_430, d_C_445, d_C_454, d_C_460, done_2519, done_2527, XZX_2533, done_2534, done_2542, done_2549, XZX_2555, done_2556, done_2564, done_2571, done_2579, done_2587, done_2595;
           )
         (| (| CLK_stable_0 ^= C_x1 ^= C_378 ^= C_430 ^= C_445 ^= C_454 ^= C_460 ^= d_stable_internal ^= d_C_cc_397 ^= d_C_x21 ^= d_C_x1_internal ^= d_C_473 ^= d_C_cc_268 ^= d_C_cc_391_277 ^= d_C_365 ^= d_C_378 ^= d_C_427 ^= d_C_430 ^= d_C_445 ^= 
               d_C_454 ^= d_C_460 ^= d_CLK_stable_0 ^= done_2519 ^= done_2527 ^= XZX_2533 ^= done_2534 ^= done_2542 ^= done_2549 ^= XZX_2555 ^= done_2556 ^= done_2564 ^= done_2571 ^= done_2579 ^= done_2587 ^= done_2595 |)
          | (d_C_x1_internal,done_2519) := CostOr(d_C_x21,d_C_cc_397,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_2533,done_2534) := CostNot(d_C_x21,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_473,done_2527) := CostAnd(XZX_2533,d_C_cc_397,d_CLK_stable_0,done_2519)
          | (d_C_365,done_2542) := CostAnd(d_C_473,d_C_cc_391_277,d_CLK_stable_0,done_2527)
          | (XZX_2555,done_2556) := CostNot(d_C_x21,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_378,done_2549) := CostAnd(XZX_2555,d_C_365,d_CLK_stable_0,done_2542)
          | (d_C_427,done_2564) := CostOr(d_C_x21,d_C_x1_internal,d_CLK_stable_0,done_2549)
          | (d_C_430,done_2571) := CostOr(d_C_427,d_C_378,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_445,done_2579) := CostOr(d_C_378,d_C_x1_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_454,done_2587) := CostAnd(d_C_x1_internal,d_C_cc_268,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_460,done_2595) := CostAnd(d_stable_internal,d_C_x1_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          |)
      %Q1_Cluster_7_M%; 
      process Q1_Cluster_10_M =
           ( ? event CLK_c_0, CLK_stable_0;
               boolean C_394;
               HomoType d_C_cc_internal, d_stable_internal, d_CLK_stable_0;
             ! HomoType d_C_cc_268, d_C_394, done_2715, done_2723;
           )
         (| (| CLK_stable_0 ^= C_394 ^= d_stable_internal ^= d_C_cc_268 ^= d_C_394 ^= d_CLK_stable_0 ^= done_2715 ^= done_2723
             | CLK_c_0 ^= d_C_cc_internal
             |)
          | (d_C_cc_268,done_2715) := CostLeftTT(d_C_cc_internal,d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_394,done_2723) := CostNot(d_C_cc_268,d_CLK_stable_0,done_2715)
          |)
      %Q1_Cluster_10_M%; 
      process Q1_Cluster_delays_M =
           ( ? event CLK_stable_0;
               HomoType d_next_stable, d_next_yy, d_CLK_stable_0;
             ! HomoType d_stable_internal, d_pre_next_yy, done_2888, done_2899;
           )
         (| (| CLK_stable_0 ^= d_stable_internal ^= d_next_stable ^= d_pre_next_yy ^= d_next_yy ^= d_CLK_stable_0 ^= done_2888 ^= done_2899 |)
          | (d_stable_internal,done_2888) := CostDelay{__TC__#_logical}(d_next_stable,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_pre_next_yy,done_2899) := CostDelay{__TC__#_real}(d_next_yy,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          |)
      %Q1_Cluster_delays_M%; 
      boolean biterate, C, C_y, OK_354, C_d_364, C__375, C_cc_397, C__429, C_x21, C_x1, C_469, C_473, C_476, C_383, C_error_438, OK_238, C_d_247, C__256, C_380_262, C_cc_268, C_cc_391_277, C_error_283, C_error_323, C_356, C_365, C_371, C_375, C_378, C_381,
             C_384, C_387, C_391, C_394, C_397, C_409, C_412, C_415, C_418, C_427, C_430, C_433, C_436, C_439, C_445, C_451, C_454, C_460, C_463, C_466;
      HomoType d_c_internal, d_b_internal, d_a_internal, d_x_internal, d_err2_internal, d_C_cc_internal, d_C_cc_391_internal, d_C_error_internal, d_C_error_405_internal, d_error_internal, d_x1_internal, d_x2_internal, d_OK_internal, d_stable_internal, 
               d_x21, d_x0, d_x_194, d_d, d_bb, d_next_stable, d_yy, d_XZX_181, d_pre_next_yy, d_mx, d_next_yy, d_biterate, d_s, d_XZX_164, d_C, d_C_335, d_C_338, d_C_y_internal, d_OK_354, d_C_d, d_C_d_364, d_C_, d_C__375, d_C_cc_397, d_C__429, d_C_x21, 
               d_C_x1_internal, d_C_469, d_C_473, d_C_476, d_C_380, d_C_383, d_C_error_438, d_dd, d_aa, d_XZX_99, d_XZX_103, d_cc, d_XZX_109, d_x_185, d_y, d_bb_127, d_OK_238, d_C_d_247, d_C__256, d_C_380_262, d_C_cc_268, d_C_cc_391_277, d_C_error_283, 
               d_C_error_323_internal, d_C_356, d_C_365, d_C_371, d_C_375, d_C_378, d_C_381, d_C_384, d_C_387, d_C_391, d_C_394, d_C_397, d_C_409, d_C_412, d_C_415, d_C_418, d_C_427, d_C_430, d_C_433, d_C_436, d_C_439, d_C_445, d_C_451, d_C_454, d_C_460, 
               d_C_463, d_C_466, d_nlabel, d_nlabel_475, d_nlabel_476, d_nlabel_477, d_nlabel_478, d_nlabel_479, d_nlabel_480, d_nlabel_481, d_nlabel_482, d_nlabel_483, d_nlabel_484, d_nlabel_485, d_nlabel_486, d_CLK, d_CLK_c_0, d_CLK_bb, d_CLK_d_0, 
               d_CLK_x0_0, d_CLK_24, d_CLK_C_cc_391_0, d_CLK_x_0, d_CLK_err2_0, d_CLK_65, d_CLK_x2_0, d_CLK_XZX_181_0, d_CLK_x21_0, d_CLK_x1_0, d_CLK_stable_0, d_CLK_error_1, d_CLK_866, d_CLK_868, d_CLK_870, d_CLK_872, d_CLK_874, d_CLK_876, d_CLK_878, 
               d_CLK_880, done, XZX, done_1229, XZX_1240, done_1241, XZX_1251, done_1266, done_1269, done_1273, done_1277, done_1281, done_1285, done_1289, done_1298, XZX_1308, done_1309, XZX_1320, done_1321, done_1340, done_1343, done_1347, done_1351, 
               done_1355, done_1359, done_1363, done_1371, done_1377, done_1381, XZX_1389, done_1390, XZX_1401, done_1402, done_1413, done_1422, XZX_1425, XZX_1431, done_1432, done_1443, done_1449, XZX_1452, done_1453, XZX_1465, XZX_1471, done_1472, 
               done_1488, done_1498, done_1507, done_1512, done_1518, XZX_1521, done_1522, XZX_1533, done_1534, XZX_1543, done_1544, XZX_1556, done_1565, XZX_1575, done_1576, done_1587, done_1593, XZX_1597, done_1598, done_1609, done_1615, XZX_1618, 
               done_1619, XZX_1630, done_1631, XZX_1640, done_1641, XZX_1653, XZX_1659, done_1660, XZX_1672, done_1673, done_1692, XZX_1700, done_1701, XZX_1710, done_1711, XZX_1720, done_1721, XZX_1730, done_1742, XZX_1745, done_1746, XZX_1755, done_1756,
               XZX_1768, done_1769, done_1780, done_1793, done_1799, XZX_1810, done_1817, XZX_1822, done_1823, XZX_1835, done_1843, done_1850, done_1859, XZX_1862, done_1869, done_1875, XZX_1878, done_1879, XZX_1888, XZX_1895, done_1896, done_1907, 
               XZX_1918, done_1925, XZX_1933, done_1934, XZX_1943, XZX_1950, done_1951, done_1962, done_1969, done_1976, XZX_1982, done_1983, done_1991, XZX_2007, done_2014, XZX_2032, done_2033, XZX_2046, XZX_2053, done_2054, done_2069, XZX_2086, 
               done_2087, XZX_2099, XZX_2105, done_2106, done_2122, done_2132, done_2148, done_2161, done_2168, XZX_2180, done_2181, done_2189, XZX_2195, done_2196, done_2204, XZX_2210, done_2211, done_2219, XZX_2225, done_2226, done_2234, done_2247, 
               done_2254, done_2284, done_2287, done_2290, done_2295, done_2299, done_2303, done_2307, done_2311, done_2315, done_2319, done_2327, XZX_2339, done_2346, done_2353, done_2363, done_2370, done_2380, done_2383, done_2387, done_2394, done_2403, 
               done_2422, done_2425, done_2430, done_2434, done_2438, done_2446, XZX_2455, done_2456, XZX_2465, XZX_2472, done_2473, done_2484, done_2496, done_2499, done_2504, done_2508, done_2512, done_2519, done_2527, XZX_2533, done_2534, done_2542, 
               done_2549, XZX_2555, done_2556, done_2564, done_2571, done_2579, done_2587, done_2595, done_2610, done_2613, done_2617, done_2621, done_2625, done_2629, done_2636, done_2648, done_2655, done_2659, done_2666, done_2676, done_2700, done_2704, 
               done_2708, done_2715, done_2723, done_2738, done_2746, done_2760, done_2765, done_2769, done_2777, done_2785, XZX_2791, done_2792, done_2800, done_2813, done_2819, done_2823, done_2827, done_2833, done_2841, done_2848, done_2861, done_2868, 
               done_2872, done_2876, done_2880, done_2888, done_2899, done_2926, done_2934, done_2942, done_2950, done_2958, done_2966, done_2974, done_2982, done_2990, done_3006, done_3014, done_3022, done_3030, done_3038, done_3050, done_3058, done_3066,
               done_3074, done_3082, done_3090, done_3098, done_3106, done_3114, done_3203, done_3209, done_3215, done_3226, done_3237, done_3243, done_3259, done_3270, done_3276, done_3301, done_3311, done_3317;
      end
   %Q1_COST%; %(| done_2920 := pack(d_next_yy,d_next_stable)
                | (d_nlabel_531,done_2913) := CostSubGraph(done_2920,d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_46,done_2998) := CostWhen1(d_C_error_438,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                | (d_CLK_894,done_3122) := CostWhen1(d_C_418,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_902,done_3130) := CostWhen1(d_C_430,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_906,done_3138) := CostWhen1(d_C_436,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                | (d_CLK_908,done_3146) := CostWhen1(d_C_439,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_912,done_3154) := CostWhen1(d_C_445,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_916,done_3162) := CostWhen1(d_C_451,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_918,done_3170) := CostWhen1(d_C_454,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_922,done_3178) := CostWhen1(d_C_460,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_924,done_3186) := CostWhen1(d_C_463,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                | (d_CLK_926,done_3194) := CostWhen1(d_C_466,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                |)***war: unused signals 
   *
   %
   use Cost_Context, STD, COSTBIB; 
end %M_Q1_COST%; 
