process VERIF_TABLE_TRA =
     ( ? event REACT_CLOCK, SENSOR_TOP, SENSOR_BOTTOM;
         real CURRENT_POS;
       ! boolean ERROR_UPWARD_TOP, ERROR_DOWNWARD_BOTTOM;
         event V_STOP, V_START_DOWN, V_START_UP, READY_UNLOAD, READY_LOAD, H_STOP, GO_TO_FEED, GO_TO_ROBOT;
     )
   pragmas 
      Main
   end pragmas
   (| (| SENSOR_TOP ^= SENSOR_TOP |)
    | (| SENSOR_BOTTOM ^= SENSOR_BOTTOM |)
    | (| XZX_154 := H_STOP_1_81 ^+ V_START_UP
       | ACT_XZX_154{}
       |)
    | (| CLK_40 := V_START_UP ^- READY_LOAD |)
    | (| CLK_43 := XZX_154 ^- CLK_286 |)
    | (| CLK_47 := H_STOP_1_81 ^- READY_LOAD |)
    | (| CLK_50 := XZX_154 ^- CLK_287 |)
    | (| CLK_53 := V_START_UP ^- H_STOP_1_81 |)
    | (| CLK_58 := CLK_55 ^* V_START_UP |)
    | (| CLK_62 := CLK_59 ^* H_STOP_1_81 |)
    | (| READY_LOAD := CLK_58 ^+ CLK_62
       | READY_LOAD ^= READY_LOAD
       |)
    | (| CLK_99 := V_START_DOWN ^- READY_UNLOAD |)
    | (| CLK_101 := XZX_237 ^- CLK_288 |)
    | (| XZX_237 := H_STOP_3_83 ^+ V_START_DOWN
       | ACT_XZX_237{}
       |)
    | (| CLK_105 := H_STOP_3_83 ^- READY_UNLOAD |)
    | (| CLK_108 := XZX_237 ^- CLK_289 |)
    | (| CLK_111 := V_START_DOWN ^- H_STOP_3_83 |)
    | (| CLK_116 := CLK_113 ^* V_START_DOWN |)
    | (| CLK_120 := CLK_117 ^* H_STOP_3_83 |)
    | (| READY_UNLOAD := CLK_116 ^+ CLK_120
       | READY_UNLOAD ^= READY_UNLOAD
       |)
    | (| CLK_CURRENT_POS := ^CURRENT_POS
       | CLK_CURRENT_POS ^= CURRENT_POS
       | ACT_CLK_CURRENT_POS{}
       |)
    | (| CLK_176 := SENSOR_BOTTOM ^* CLK_173 |)
    | (| CLK_180 := SENSOR_TOP ^* CLK_177 |)
    | (| CLK_182 := CLK_180 ^- CLK_176 |)
    | (| CLK_183 := CLK_176 ^+ CLK_180 |)
    | (| CLK_185 := REACT_CLOCK ^- CLK_183 |)
    | (| REACT_CLOCK ^= REACT_CLOCK ^= ERROR_UPWARD_TOP ^= ERROR_DOWNWARD_BOTTOM
       | ACT_REACT_CLOCK{}
       |)
    | (| CLK_191 := CLK_176 ^- CLK_180 |)
    | (| CLK_286 := CLK_62 ^+ V_START_UP |)
    | (| CLK_287 := CLK_58 ^+ H_STOP_1_81 |)
    | (| CLK_288 := CLK_120 ^+ V_START_DOWN |)
    | (| CLK_289 := CLK_116 ^+ H_STOP_3_83 |)
    | (| (| (| CLK := SENSOR_TOP ^* SENSOR_BOTTOM |)
          | ^0 ^= CLK
          |) |)%**WARNING: Clocks constraints
      %
    |)
   where 
   constant real MIN_POS = 0.0;
   constant real MAX_POS = 45.0;
   constant real INI_POS = 0.0;
   event CLK_289, CLK_288, CLK_287, CLK_286, CLK_191, CLK_185, CLK_183, CLK_182, CLK_180, CLK_177, CLK_176, CLK_173, H_STOP_3_83, CLK_CURRENT_POS, CLK_120, CLK_117, CLK_116, CLK_113, CLK_111, CLK_108, CLK_105, XZX_237, CLK_101, CLK_99, H_STOP_1_81, CLK_62,
        CLK_59, CLK_58, CLK_55, CLK_53, CLK_50, CLK_47, CLK_43, CLK_40, XZX_154;
   process ACT_XZX_154 =
        ( )
      (| XZX_154 ^= READY ^= POSSIBL ^= NEXT_STATE ^= NEXT_STATE_139 ^= XZX
       | (| CLK_55 := when XZX |)
       | (| CLK_59 := when READY |)
       | (| READY := NEXT_STATE$1 init false
          | POSSIBL := NEXT_STATE_139$1 init false
          | NEXT_STATE := (not READY_LOAD) default CLK_40 default (READY when CLK_43)
          | NEXT_STATE_139 := (not READY_LOAD) default CLK_47 default (POSSIBL when CLK_50)
          | XZX := H_STOP_1_81 default (POSSIBL when CLK_53)
          |)
       |)
      where 
      boolean READY, POSSIBL, NEXT_STATE, NEXT_STATE_139, XZX;
      end
   %ACT_XZX_154%; 
   process ACT_XZX_237 =
        ( )
      (| XZX_237 ^= READY_204 ^= POSSIBL_205 ^= NEXT_STATE_210 ^= NEXT_STATE_222 ^= XZX_229
       | (| CLK_113 := when XZX_229 |)
       | (| CLK_117 := when READY_204 |)
       | (| READY_204 := NEXT_STATE_210$1 init false
          | POSSIBL_205 := NEXT_STATE_222$1 init false
          | NEXT_STATE_210 := (not READY_UNLOAD) default CLK_99 default (READY_204 when CLK_101)
          | NEXT_STATE_222 := (not READY_UNLOAD) default CLK_105 default (POSSIBL_205 when CLK_108)
          | XZX_229 := H_STOP_3_83 default (POSSIBL_205 when CLK_111)
          |)
       |)
      where 
      boolean READY_204, POSSIBL_205, NEXT_STATE_210, NEXT_STATE_222, XZX_229;
      end
   %ACT_XZX_237%; 
   process ACT_CLK_CURRENT_POS =
        ( )
      (| CLK_CURRENT_POS ^= LAST_POS ^= LAST_POS_196
       | (| H_STOP_1_81 := when ((CURRENT_POS<=MIN_POS) and (LAST_POS>MIN_POS)) |)
       | (| H_STOP_3_83 := when ((CURRENT_POS>=MAX_POS) and (LAST_POS_196<MAX_POS)) |)
       | (| H_STOP := H_STOP_1_81 ^+ H_STOP_3_83
          | H_STOP ^= H_STOP
          |)
       | (| LAST_POS := CURRENT_POS$1 init INI_POS
          | LAST_POS_196 := CURRENT_POS$1 init INI_POS
          |)
       |)
      where 
      real LAST_POS, LAST_POS_196;
      end
   %ACT_CLK_CURRENT_POS%; 
   process ACT_REACT_CLOCK =
        ( )
      (| REACT_CLOCK ^= S_TOP ^= S_BOTTOM ^= Z_S_TOP ^= Z_S_BOTTOM ^= ERROR ^= LIMIT_REACHED ^= STARTED ^= WITHIN ^= AFT_LIMIT ^= ERROR_385 ^= LIMIT_REACHED_402 ^= STARTED_403 ^= WITHIN_404 ^= AFT_LIMIT_405
       | (| CLK_173 := when Z_S_TOP
          | CLK_174 := when (not Z_S_TOP)
          |)
       | (| CLK_177 := when Z_S_BOTTOM
          | CLK_178 := when (not Z_S_BOTTOM)
          |)
       | (| CLK_193 := when S_TOP |)
       | (| CLK_198 := when S_BOTTOM |)
       | (| V_START_DOWN := CLK_174 ^* CLK_193
          | V_START_DOWN ^= V_START_DOWN ^= GO_TO_FEED
          | (| GO_TO_FEED := true when V_START_DOWN |)
          |)
       | (| V_START_UP := CLK_178 ^* CLK_198
          | V_START_UP ^= V_START_UP ^= GO_TO_ROBOT
          | (| GO_TO_ROBOT := true when V_START_UP |)
          |)
       | (| V_STOP := V_START_UP ^+ V_START_DOWN
          | V_STOP ^= V_STOP
          |)
       | (| CLK_268 := V_STOP ^- V_START_UP |)
       | (| CLK_270 := V_STOP ^- V_START_DOWN |)
       | (| CLK_275 := REACT_CLOCK ^- V_START_DOWN |)
       | (| CLK_277 := REACT_CLOCK ^- V_STOP |)
       | (| CLK_279 := REACT_CLOCK ^- V_START_UP |)
       | (| ERROR_UPWARD_TOP := ERROR_385
          | ERROR_DOWNWARD_BOTTOM := ERROR
          | S_TOP := (not CLK_176) default (SENSOR_TOP when CLK_182) default (Z_S_TOP when CLK_185)
          | S_BOTTOM := (not CLK_180) default (SENSOR_BOTTOM when CLK_191) default (Z_S_BOTTOM when CLK_185)
          | Z_S_TOP := S_TOP$1 init false
          | Z_S_BOTTOM := S_BOTTOM$1 init true
          | ERROR := AFT_LIMIT and WITHIN
          | LIMIT_REACHED := V_START_UP default (not CLK_279)
          | STARTED := V_START_DOWN default (not CLK_270) default (WITHIN when CLK_277)
          | WITHIN := STARTED$1 init false
          | AFT_LIMIT := LIMIT_REACHED$1 init false
          | ERROR_385 := AFT_LIMIT_405 and WITHIN_404
          | LIMIT_REACHED_402 := V_START_DOWN default (not CLK_275)
          | STARTED_403 := V_START_UP default (not CLK_268) default (WITHIN_404 when CLK_277)
          | WITHIN_404 := STARTED_403$1 init false
          | AFT_LIMIT_405 := LIMIT_REACHED_402$1 init false
          |)
       |)
      where 
      event CLK_279, CLK_277, CLK_275, CLK_270, CLK_268, CLK_198, CLK_193, CLK_178, CLK_174;
      boolean S_TOP, S_BOTTOM, Z_S_TOP, Z_S_BOTTOM, ERROR, LIMIT_REACHED, STARTED, WITHIN, AFT_LIMIT, ERROR_385, LIMIT_REACHED_402, STARTED_403, WITHIN_404, AFT_LIMIT_405;
      end
   %ACT_REACT_CLOCK%; 
   end
%VERIF_TABLE_TRA%; 
